#ifndef XXX_TXTCLIENT_H
#define XXX_TXTCLIENT_H

/*#ifdef XXX_WIN32
#include <afx.h>
#endif
*/
#include <iostream.h>
#include <strstream.h>
#include <fstream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <ctype.h>
#include "predconnect.h"

#ifdef XXX_READLINE
extern "C" {
#include "readline/readline.h" 
#include "readline/chardefs.h"
#include "readline/history.h"
#include "readline/keymaps.h"
 };
extern FILE* rl_outstream;
#endif

/***
#if defined(__GNUG__) && defined(__svr4__)
extern "C" {
     extern int shutdown(int, int);
     extern int socket(int, int, int);
 };
#endif
*******/

const char* const XXX_CL_CONSULTSTR = "_consult" ;
const char* const XXX_CL_DEFSTR = "_defaults" ;
const char* const XXX_CL_HELPSTR = "_help" ;
const char* const XXX_CL_LANGSTR = "_lang" ;
const char* const XXX_CL_OUTFSTR = "_outfile" ;
const char* const XXX_CL_QUITSTR = "_quit" ;
const char* const XXX_CL_SHELLSTR = "_shell" ;
const char* const XXX_CL_TOGGLESTR = "_toggle" ;
const char* const XXX_CL_LABELSTR = "_label" ;
const char* const XXX_CL_TIMERFSTR = "_timerfile" ;

const int XXX_CL_OK = 0;
const int XXX_CL_QUIT = 1;

const int XXX_INPUT_BUFFER_MAX = 3000;
const int XXX_INPUT_LINEBUFFER_MAX = 1000;

struct IStreamList {
  int Count;
  IStreamList* Next;
  istream* Stream;
  IStreamList() { Next = NULL; Stream = NULL; Count = 0;}
  ~IStreamList() { if (Next) delete Next;
		   if (Stream) delete Stream; }
  void Add(istream* Str) {
    if (Next) Next->Add(Str);
    else {
      IStreamList* Tmp = new IStreamList;
      Tmp->Stream = Str;
      Tmp->Next = Next;
      Next = Tmp;
     }
    Count++;
   }
  int ListCount() { return Count; }
  char Empty() { return (Count <= 0); }
  int GetCommand(char* Buf, int BufLength, int& CommandLength);
 };

class XxxTxtClientEnv {
  static const char* const DefaultPrompt;
  static const int DefaultPort;
  static const int DefaultTiming;
  static const int DefaultVerbose;
  static const bool DefaultPrintSchemas;
  static const bool DefaultPrintBinary;
 public:
  char TimingOn;
  char Verbose;
  bool PrintSchemas;
  bool PrintBinary;
  bool EchoInput;
  char HostName[50];
  char UserName[50];
  int ServerPort;
  bool DisplayPrompt;
  char Prompt[15];
  char CurrentLang[25];
  ostream* OutStr;
  ostream* TimerStr;
  char TimerLabel[20];  // used to tag timer info
#ifdef XXX_WIN32
  clock_t Time;
#else
  struct timeval Time;
#endif
  XxxTxtClientEnv(int argc, char** argv) { 
    EchoInput = false;
    DisplayPrompt = true;
    TimingOn = DefaultTiming;
    Verbose = DefaultVerbose;
    PrintSchemas = DefaultPrintSchemas;
    PrintBinary = DefaultPrintBinary;
    strcpy(Prompt, DefaultPrompt);
    strcpy(CurrentLang, "SQL");
    char *TmpHostName;
	char *HostNameEnvVar;
#ifdef XXX_WIN32
    HostNameEnvVar = "COMPUTERNAME";
#else
	HostNameEnvVar = "HOST";
#endif
    if (!(TmpHostName = getenv(HostNameEnvVar))) {
      fprintf(stderr, "Unable to identify current host!\n");
	  exit(1);
	}
	strcpy(HostName, TmpHostName);
    char *TmpUserName;
	char *UserNameEnvVar;
#ifdef XXX_WIN32
	UserNameEnvVar = "USERNAME";
#else
	UserNameEnvVar = "USER";
#endif
    if (!(TmpUserName = getenv(UserNameEnvVar))) {
      fprintf(stderr, "Unable to identify current user!\n");
	  exit(1);
    }
    strcpy(UserName, TmpUserName);
    // delete TmpUserName;
    OutStr = &(cout);
    TimerStr = &(cout);
    strcpy(TimerLabel, "ClockTime");
    // set stream for readline output
#ifdef XXX_READLINE
    rl_outstream = stderr;
    using_history();
#endif
    ReadCommandLine(argc, argv);
   }
  void ReadCommandLine(int argc, char** argv);
  void PrintDefaults(ostream& ) const;
  void PrintFlagsHelp(ostream& ) const;
  void PrintCommandsHelp(ostream& ) const;
  IStreamList* GetInput(int& Status);
  void TimerStart();
  void TimerDisplay(ostream& OStr);
 };

extern XxxTxtClientEnv* Env;


#endif

