package PREDATOR.ADT;

import java.io.*;

/**
 * The audio ADT.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see AudioObject
 * @see AudioMetaInfo
 */
public class ADT_audio extends ADT {
  /**
   * Returns the class of the audio ADT's object data
   * @param MetaInfo The meta-info for the object to be read
   * @return The class of the audio ADT's object data
   */
  public Class getObjectClass(ADTMetaInfo MetaInfo)
  { 
    return (new AudioObject().getClass());
  }
  /**
   * Returns the class of the ADT's meta info.  For instance, the
   * audio ADT returns AudioMetaInfo.
   * @return The class of the ADT's meta info
   */
  public Class getMetaInfoClass()
  {
    return (new AudioMetaInfo().getClass());
  }
}

