package PREDATOR.ADT;

import java.io.*;
import PREDATOR.*;

/**
 * The counter ADT.  
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see IntegerData
 * @see CounterMetaInfo
 */
public class ADT_counter extends ADT {
  /**
   * Returns the class of the counter ADT's object data: IntegerObject
   * @param MetaInfo The meta-info for the object to be read
   * @return The class of the counter ADT's object data
   */
  public Class getObjectClass(ADTMetaInfo MetaInfo)
  { 
    return (new IntegerObject().getClass());
  }
  /**
   * Returns the class of the ADT's meta info.  For instance, the
   * audio ADT returns AudioMetaInfo.
   * @return The class of the ADT's meta info
   */
  public Class getMetaInfoClass()
  {
    return (new CounterMetaInfo().getClass());
  }
}

