package PREDATOR.ADT;

import java.io.*;
import PREDATOR.*;

/**
 * The date ADT.  
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see DateObject
 * @see DateMetaInfo
 */
public class ADT_date extends ADT {
  /**
   * Returns the class of the date ADT's object data: DateObject
   * @param MetaInfo The meta-info for the object to be read
   * @return The class of the date ADT's object data
   */
  public Class getObjectClass(ADTMetaInfo MetaInfo)
  { 
    return (new DateObject().getClass());
  }
  /**
   * Returns the class of the ADT's meta info.  For instance, the
   * audio ADT returns AudioMetaInfo.
   * @return The class of the ADT's meta info
   */
  public Class getMetaInfoClass()
  {
    return (new DateMetaInfo().getClass());
  }
}

