package PREDATOR.ADT;

import java.io.*;

/**
 * The document ADT.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see DocumentObject
 * @see DocumentMetaInfo
 */
public class ADT_document extends ADT {
  /**
   * Returns the class of the document ADT's object data: DocumentData
   * @param MetaInfo The meta-info for the object to be read
   * @return The class of the document ADT's object data
   */
  public Class getObjectClass(ADTMetaInfo MetaInfo)
  { 
    return (new DocumentObject().getClass());
  }
  /**
   * Returns the class of the ADT's meta info.  For instance, the
   * audio ADT returns AudioMetaInfo.
   * @return The class of the ADT's meta info
   */
  public Class getMetaInfoClass()
  {
    return (new DocumentMetaInfo().getClass());
  }
}

