package PREDATOR.ADT;

import java.io.*;
import PREDATOR.*;

/**
 * The timeseries ADT.  
 * @author Victor Cheng
 * @version 0.1
 * @see TimeSeriesObject
 */
public class ADT_genTimeSeries extends ADT {
  /**
   * Returns the class of the timeseries ADT's object data
   * @param MetaInfo The meta-info for the object to be read
   * @return The class of the timeseries ADT's object data
   */
  public Class getObjectClass(ADTMetaInfo MetaInfo)
  { 
    return (new GenTimeSeriesObject().getClass());
  }
  /**
   * Determines if the binary version of the ADT is variable size
   * @param MetaInfo The meta-info for the object to be read
   * @return true if the in-record version of the ADT is variable size,
   *         false otherwise
   */
  public boolean isVariableSize(ADTMetaInfo MetaInfo) { return true; }
}

