package PREDATOR.ADT;

import java.io.*;
import PREDATOR.*;

/**
 * The image ADT.  The image is displayed by creating a frame which loads
 * the image via http and displays it.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see ImageObject
 * @see ImageMetaInfo
 */
public class ADT_image extends ADT {
  /**
   * Returns the class of the image ADT's object data: ImageData
   * @param MetaInfo The meta-info for the object to be read
   * @return The class of the image ADT's object data
   */
  public Class getObjectClass(ADTMetaInfo MetaInfo)
  { 
    return (new ImageObject().getClass());
  }
  /**
   * Returns the class of the ADT's meta info.  For instance, the
   * audio ADT returns AudioMetaInfo.
   * @return The class of the ADT's meta info
   */
  public Class getMetaInfoClass()
  {
    return (new ImageMetaInfo().getClass());
  }
}

