package PREDATOR.ADT;

import java.io.*;
import PREDATOR.*;

/**
 * The pdate ADT.  
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see PdateObject
 * @see PdateMetaInfo
 */
public class ADT_pdate extends ADT {
  /**
   * Returns the class of the pdate ADT's object data: PdateObject
   * @param MetaInfo The meta-info for the object to be read
   * @return The class of the pdate ADT's object data
   */
  public Class getObjectClass(ADTMetaInfo MetaInfo)
  { 
    return (new PdateObject().getClass());
  }
  /**
   * Returns the class of the ADT's meta info.  For instance, the
   * audio ADT returns AudioMetaInfo.
   * @return The class of the ADT's meta info
   */
  public Class getMetaInfoClass()
  {
    return (new PdateMetaInfo().getClass());
  }
}

