package PREDATOR.ADT;

import java.io.*;
import PREDATOR.*;

/**
 * The raster ADT.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see RasterObject
 * @see RasterMetaInfo
 */
public class ADT_raster extends ADT {
  /**
   * Returns the class of the raster ADT's object data: RasterData
   * @param MetaInfo The meta-info for the object to be read
   * @return The class of the raster ADT's object data
   */
  public Class getObjectClass(ADTMetaInfo MetaInfo)
  { 
    return (new RasterObject().getClass());
  }
  /**
   * Returns the class of the ADT's meta info.  For instance, the
   * audio ADT returns AudioMetaInfo.
   * @return The class of the ADT's meta info
   */
  public Class getMetaInfoClass()
  {
    return (new RasterMetaInfo().getClass());
  }
}

