package PREDATOR.ADT;

import java.io.*;
import PREDATOR.*;

/**
 * The string ADT.  
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see StringObject
 */
public class ADT_string extends ADT {
  /**
   * Returns the class of the string ADT's object data
   * @param MetaInfo The meta-info for the object to be read
   * @return The class of the string ADT's object data
   */
  public Class getObjectClass(ADTMetaInfo MetaInfo)
  { 
    return (new StringObject().getClass());
  }
  /**
   * Determines if the binary version of the ADT is variable size
   * @param MetaInfo The meta-info for the object to be read
   * @return true if the in-record version of the ADT is variable size,
   *         false otherwise
   */
  public boolean isVariableSize(ADTMetaInfo MetaInfo) { return true; }
}

