package PREDATOR.ADT;

import java.applet.*;

/**
 * Extended by DataObject classes which can display themselves in some
 * fashion not captured by their toString() method, but require an applet
 * to do so.  For instance, an audio object can be played, but
 * there is no way to do so without an applet.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see DataObject
 */
public interface AppletDisplayObject {
  /**
   * Displays an object using an applet.
   * @param MetaInfo The meta-info for this object
   * @exception RequiresCallbackException when a callback is required
   *                                      before a display can be made
   */
  public void appletDisplay(Applet applet, ADTMetaInfo MetaInfo) 
    throws RequiresCallbackException;
}
