package PREDATOR.ADT;

/**
 * The meta-info for the Audio ADT.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see ADT_audio
 * @see ADT#newMetaInfo(byte[])
 */
public class AudioMetaInfo extends ADTMetaInfo {
  /// The format of the audios
  int Format;
  /// The .au format
  final static int AUDIO_AU = 0;
  /// The .wav format
  final static int AUDIO_WAV = 1;
  /// Mixed formats
  final static int AUDIO_MIXED = 2;
  /// The average size of the audios
  int AvgAudioSize;
  /**
   * Provides a textual version of this object suitable for user-display.
   * @return A textual version of this object
   */ 
  public String toString()
  {
    StringBuffer buffer = new StringBuffer("Format: ");
    switch (Format) {
    case AUDIO_AU:
      buffer.append("AU");
      break;
    case AUDIO_WAV:
      buffer.append("WAV");
      break;
    case AUDIO_MIXED:
      buffer.append("MIXED");
      break;
    default:
      buffer.append("UNKNOWN");
      break;
    }
    buffer.append(" Average Size: " + AvgAudioSize);
    return buffer.toString();
  }
}
