package PREDATOR.ADT;

/**
 * Encapsulates all in-memory data regarding an audio ADT object.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see ADT_audio
 */
public class AudioObject 
  extends DataObject implements CallbackObject, MIMETypeObject
 {
  /**
   * Prints the value of the audio
   * @param MetaInfo The meta-info for this object
   * @return A string holding the value of the audio
   */
  public String toString(ADTMetaInfo MetaInfo) {
    String tmp = super.toString(MetaInfo);
    if (tmp != null)
      return (tmp);
    return ("audio");
  }
  /**
   * Callback objects have the option of supplying a byte string
   * containing additional information about the callback.  For
   * instance, an image object might specify one of many stored
   * resolutions.
   * @return A binary message
   */
  public byte [] getMessage()
  {
    return null;
  }
  /**
   * Provides a filename extension suitable for files storing data of
   * this MIME type.  For instance, JPEG images will supply the extension
   * "jpg".
   * @return A suitable filename extension for files of this type
   */
  public String getFilenameExtension(ADTMetaInfo MetaInfo)
  {
    switch((int)(getBytes()[0])) {
    case AudioMetaInfo.AUDIO_AU:
      return "au";
    case AudioMetaInfo.AUDIO_WAV:
      return "wav";
    default:
      return "au";
    }
  }
}
