package PREDATOR.ADT;

/**
 * The exception thrown when a specified SubclassSelector selects a class
 * which is not a <I>direct</I> subclass of the DataObject's class nor the
 * class itself.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see SubclassSelector
 */
public class BadSubclassSelectorException extends Exception {
  /**
   * Constructs a BadSubclassSelectorException without a detail message.
   */
  public BadSubclassSelectorException()
  {
    super();
  }

  /**
   * Constructs a BadSubclassSelectorException with the specified message.
   */
  public BadSubclassSelectorException(String Message)
  {
    super(Message);
  }
}
