package PREDATOR.ADT;

import java.io.*;

/**
 * Encapsulates all in-memory data regarding an box ADT object.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see ADT_box
 */
public class BoxObject extends DataObject {
  /**
   * Prints the value of the box
   * @param MetaInfo The meta-info for this object
   * @return A string holding the value of the box
   */
  public String toString(ADTMetaInfo MetaInfo) {
	String tmp = super.toString(MetaInfo);
	if (tmp != null)
	  return (tmp);
    try {
      DataInputStream dataStream = 
        new DataInputStream(new ByteArrayInputStream(getBytes(), 8, 
                                                     getBytes().length - 8));
      double Xmin = dataStream.readDouble();
      double Ymin = dataStream.readDouble();
      double Xmax = dataStream.readDouble();
      double Ymax = dataStream.readDouble();
	  return new String("[(" + Xmin + ", " + Ymin + "), (" + Xmax + ", " + Ymax + ")]");
    } catch (IOException X) {
      throw new PREDATOR.InternalError(X);
    }
  }
}
