package PREDATOR.ADT;

/**
 * The interface extended by objects which can contact the server for
 * additional information; this includes those that must retrieve
 * additional information for display such as rasters, and those that
 * implement MIME types.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see DataObject
 * @see CachingObject
 * @see MIMETypeObject
 * @see DisplayObject
 */
public interface CallbackObject {
  /**
   * Callback objects have the option of supplying a byte string
   * containing additional information about the callback.  For
   * instance, an image object might specify one of many stored
   * resolutions.
   * @return A binary message
   */
  public byte [] getMessage();
}

