package PREDATOR.ADT;

import java.io.*;

/**
 * Encapsulates all in-memory data regarding a circle ADT object.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see ADT_circle
 */
public class CircleObject extends DataObject {
  /**
   * Prints the value of the circle
   * @param MetaInfo The meta-info for this object
   * @return A string holding the value of the circle
   */
  public String toString(ADTMetaInfo MetaInfo) {
	String tmp = super.toString(MetaInfo);
	if (tmp != null)
	  return (tmp);
    try {
	  // Because in server side, CircleStruct is inherited from XxxADTValue, we need 8 bytes of padding.
      DataInputStream dataStream = 
        new DataInputStream(new ByteArrayInputStream(getBytes(), 8, 
                                                     getBytes().length - 8));
      double X = dataStream.readDouble();
      double Y = dataStream.readDouble();
      double radius = dataStream.readDouble();
 	  return new String("("+ X + ", " + Y + "), " + radius);
    } catch (IOException X) {
      throw new PREDATOR.InternalError(X);
    }
  }
}
