package PREDATOR.ADT;
import java.io.*;

/**
 * The meta-info for the Counter ADT.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see ADT_counter
 * @see ADT#newMetaInfo(byte[])
 */
public class CounterMetaInfo extends ADTMetaInfo {
  /// The next value to be assigned
  int NextValue;
  /**
   * Provides a textual version of this object suitable for user-display.
   * @return A textual version of this object
   */ 
  public String toString()
  {
    // TODO: this stuff should be read earlier, not each time.
    // This is a flaw with the entire MetaInfo handling of JCL
    try {
      DataInputStream dataStream = 
	new DataInputStream(new ByteArrayInputStream(getBytes(), 0, 
						     getBytes().length));
      NextValue = (int)dataStream.readInt();
    } catch (IOException X) {
      throw new PREDATOR.InternalError(X);
    }
    return ("Next Value: " + NextValue);
  }
}
