package PREDATOR.ADT;

import java.io.*;

/**
* Encapsulates all in-memory data regarding a date ADT object.
* @author Mark A. Paskin, paskin@cs.cornell.edu
* @version 0.9
* @see ADT_date
*/
public class DateObject extends DataObject {
/**
* Prints the value of the date
* @param MetaInfo The meta-info for this object
* @return A string holding the value of the date
	*/
	public String toString(ADTMetaInfo MetaInfo) {
  	String tmp = super.toString(MetaInfo);
  	if (tmp != null)
  	  return (tmp);
		int Date = 0;
		try {
      DataInputStream dataStream = 
        new DataInputStream(new ByteArrayInputStream(getBytes(), 4, 
                                                     getBytes().length - 4));
			Date = dataStream.readInt();
		} catch (IOException X) {
			throw new PREDATOR.InternalError(X);
		}
		short Century = (short)(Date/(13*32*100));
		short Year = (short)((Date%(13*32*100))/(13*32));
		short Month = (short)(((Date%(13*32*100))%(13*32))/(32));
		short Day = (short)(((Date%(13*32*100))%(13*32))%(32));
		
		DateMetaInfo metaInfo = (DateMetaInfo)MetaInfo;
		char Format[];
		if (metaInfo == null)
			Format = DateMetaInfo.DefaultFormat;
		else 
			Format = new String(metaInfo.getBytes(), 0).toCharArray();
		int index = 0;
		StringBuffer buffer = new StringBuffer();
		while ((index < Format.length) && 
			(Format[index] != 'e')) {
			switch (Format[index]) {
			case 'w':
				buffer.append(' ');
				break;
			case 'C':
				if(Century < 10) {
					buffer.append(0);
				}
				buffer.append(Century);
				break;
			case 'Y':
				if(Year < 10) {
					buffer.append(0);
				}
				buffer.append(Year);
				break;
			case 'M':
				if (Month < 10) {
				  buffer.append(0);
				}
				buffer.append(Month);
				break;
			case 'D':
				if (Day < 10) {
				  buffer.append(0);
				}
				buffer.append(Day);
				break;
			case 'h':
			case 'm':
			case 's':
				// ignore these three for MDY domain
				break;
			default:
				// separator character: write it out
				buffer.append(Format[index]);
				break;
			}
			index++;
		}
    return buffer.toString();
  }
}

