package PREDATOR.ADT;

/**
 * The meta-info for the Document ADT.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see ADT_document
 * @see ADT#newMetaInfo(byte[])
 */
public class DocumentMetaInfo extends ADTMetaInfo {
  /// The ASCII format
  final static byte DOCUMENT_ASCII = 0;
  /// Microsoft Word format
  final static byte DOCUMENT_MSWORD = 1;
  /// HTML format
  final static byte DOCUMENT_HTML = 2;
  /// Postscript formats
  final static byte DOCUMENT_POSTSCRIPT = 3;
  /// Any format
  final static byte DOCUMENT_ANY = 4;
  /// The format of the rasters
  byte Format;
  /// Is the document inline, or is it stored as a URL/filename
  boolean IsInline;
  /**
   * Provides a textual version of this object suitable for user-display.
   * @return A textual version of this object
   */ 
  public String toString()
  {
    StringBuffer buffer = new StringBuffer("Format: ");
    switch (Format) {
    case DOCUMENT_ASCII:
      buffer.append("ASCII");
      break;
    case DOCUMENT_HTML:
      buffer.append("HTML");
      break;
    case DOCUMENT_MSWORD:
      buffer.append("MS Word");
      break;
    case DOCUMENT_POSTSCRIPT:
      buffer.append("PostScript");
      break;
    case DOCUMENT_ANY:
      buffer.append("Unrestricted");
      break;
    default:
      buffer.append("UNKNOWN");
      break;
    }
    if (IsInline)
      buffer.append(" In-line");
    else
      buffer.append(" via URL/filename");
    return buffer.toString();
  }
}
