package PREDATOR.ADT;

/**
 * The meta-info for the Image ADT.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see ADT_image
 * @see ADT#newMetaInfo(byte[])
 */
public class ImageMetaInfo extends ADTMetaInfo {
  /// The format of the rasters
  int Format;
  /// The JPEG format
  final static int IMAGE_JPEG = 0;
  /// The GIF format
  final static int IMAGE_GIF = 1;
  /// Both formats
  final static int IMAGE_MIXED = 2;
  /// The resolution of the 1st low-resolution copy
  int LowRes1Scale = 0;
  /// The resolution of the 2nd low-resolution copy
  int LowRes2Scale = 0;
  /**
   * Provides a textual version of this object suitable for user-display.
   * @return A textual version of this object
   */ 
  public String toString()
  {
    StringBuffer buffer = new StringBuffer("Format: ");
    switch (Format) {
    case IMAGE_JPEG:
      buffer.append("JPEG");
      break;
    case IMAGE_GIF:
      buffer.append("GIF");
      break;
    case IMAGE_MIXED:
      buffer.append("Mixed");
      break;
    default:
      buffer.append("UNKNOWN");
      break;
    }
    if (LowRes1Scale > 0)
      buffer.append(" Reduced resolution scales: " + LowRes1Scale);
    if (LowRes2Scale > 0)
      buffer.append(", " + LowRes2Scale);
    return buffer.toString();
  }
}
