package PREDATOR.ADT;

/**
 * The class extended by objects which represent MIME types.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 */
public interface MIMETypeObject {
  /**
   * Provides a filename extension suitable for files storing data of
   * this MIME type.  For instance, JPEG images will supply the extension
   * "jpg".
   * @return A suitable filename extension for files of this type
   */
  public String getFilenameExtension(ADTMetaInfo MetaInfo);
}
