package PREDATOR.ADT;

/**
 * The DataObject generated for objects whose ADT's have no
 * registered Java class to parse their binary representations.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see NullADT
 */
public class NullObject extends DataObject {
  /**
   * Prints a message saying the ADT is unavailable.
   * @param MetaInfo The meta-info for this object
   * @return An error message.
   */
  public String toString(ADTMetaInfo MetaInfo) {
    return ("No Java class registered.");
  }
}
