package PREDATOR.ADT;

import java.io.*;

/**
 * Encapsulates all in-memory data regarding a point ADT object.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see ADT_point
 */
public class PointObject extends DataObject {
  /**
   * Prints the value of the point
   * @param MetaInfo The meta-info for this object
   * @return A string holding the value of the point
   */
  public String toString(ADTMetaInfo MetaInfo) {
	String tmp = super.toString(MetaInfo);
	if (tmp != null)
	  return (tmp);
    try {
      DataInputStream dataStream = 
        new DataInputStream(new ByteArrayInputStream(getBytes(), 8, 
                                                     getBytes().length - 8));
      double x = dataStream.readDouble();
      double y = dataStream.readDouble();
	  return new String("(" + x + ", " + y + ")");
    } catch (IOException X) {
      throw new PREDATOR.InternalError(X);
    }
  }
}
