package PREDATOR.ADT;

/**
 * The meta-info for the Raster ADT.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see ADT_raster
 * @see ADT#newMetaInfo(byte[])
 */
public class RasterMetaInfo extends ADTMetaInfo {
  /// The format of the rasters
  int Format;
  /// The standard format
  final static int RASTER_AVHRR = 0;
  /// The JPEG format
  final static int RASTER_JPEG = 1;
  /// The average size of the rasters
  int AvgRasterSize;
  /**
   * Provides a textual version of this object suitable for user-display.
   * @return A textual version of this object
   */ 
  public String toString()
  {
    StringBuffer buffer = new StringBuffer("Format: ");
    switch (Format) {
    case RASTER_AVHRR:
      buffer.append("AVHRR");
      break;
    case RASTER_JPEG:
      buffer.append("JPEG");
      break;
    default:
      buffer.append("UNKNOWN");
      break;
    }
    buffer.append(" Average Size: " + AvgRasterSize);
    return buffer.toString();
  }
}
