package PREDATOR.ADT;

import java.io.*;
import PREDATOR.NullValueException;

/**
 * Encapsulates all in-memory data regarding a string ADT object.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see ADT_string
 */
public class StringObject extends DataObject {
  /**
   * Maps the value to a Java String
   * @param MetaInfo The meta-info for this object
   * @return A string that represents the value of the object
   */
  public String getValue(ADTMetaInfo MetaInfo) 
       throws NullValueException 
  {
    if(is(NULL))
      throw new NullValueException();
      byte[] bytes = getBytes();
      int i = 4;
      String tmp = new String("");
      tmp += '\"';
      while ((char)bytes[i] != '\0')
	tmp += (char)bytes[i++];
      tmp += '\"';
      return tmp;
  }
  /**
   * Prints the value of the string
   * @param MetaInfo The meta-info for this object
   * @return A string holding the value of the string
   */
  public String toString(ADTMetaInfo MetaInfo) {
    String tmp = super.toString(MetaInfo);
    if (tmp != null)
      return (tmp);
    try {
      return getValue(MetaInfo);
    } catch (NullValueException X) {
      return("Null");
    }
  }
}
