package PREDATOR;

import java.io.*;

/**
 * The error thrown when an internal error arises in the <TT>PREDATOR</TT> and
 * <TT>PREDATOR.ADT</TT> packages.  This error always signifies a bug, and 
 * should never be caught.  If this error is thrown in your application, please
 * contact <FONT COLOR="#CC0000"><FONT SIZE=+1>P</FONT>REDATOR</FONT> support.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 */
public class InternalError extends Error {
  // If an exception prompted the creation of this error, the exception
  Exception X;
  /**
   * Constructs an InternalError with a detail message.
   */
  public InternalError(String Reason)
  {
    super("Reason: " + Reason);
  }

  public InternalError(String Reason, int dummy)
  {
    super("Reason: " + Reason);
  }
  /**
   * Constructs an InternalError from a caught exception.
   */
  public InternalError(Exception X)
  {
    super("Fatal exception caught: " + X.toString());
    this.X = X;
  }
  /**
   * Prints the stack trace of this internal error on the supplied
   * PrintStream.
   */
  public void printStackTrace(PrintStream s)
  {
    super.printStackTrace(s);
    if (X != null) {
      X.printStackTrace(s);
    }
  }
  /**
   * Prints the stack trace of this internal error on the error stream.
   */
  public void printStackTrace()
  {
    printStackTrace(System.err);
  }
}
