package PREDATOR;

import java.util.*;

/**
 * This class represents a schema, or ordered sequence of attributes.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see Attribute
 */
public class Schema {
  /// A vector of attributes
  Vector attrs = new Vector();
  /**
   * Returns the number of attributes in the schema.
   * @return The number of attributes in the schema
   */
  public int getArity() {
    return attrs.size();
  }
  /**
   * Adds information about an attribute.
   * @param AttrId The index of the attribute in the schema
   * @param Attr The attribute to add
   */
  void addAttribute(int AttrId, Attribute Attr) {
    try {
      if (!(AttrId < attrs.size()))
	attrs.setSize(attrs.size() + 1);
      attrs.setElementAt(Attr, AttrId);
    } catch (Exception X) {  }
  }
  /**
   * Gets the attribute associated with a given attribute id.
   * @param AttrId The index of the attribute in the schema
   * @return The attribute associated with the index
   * @exception IndexOutOfBoundsException if the index is out of bounds
   */
  public Attribute getAttribute(int AttrId) throws IndexOutOfBoundsException
  {
    return ((Attribute)(attrs.elementAt(AttrId)));
  }
  /**
   * Creates a string representation of this schema.
   */
  public String toString() { 
    return (attrs.toString());
  }
}
