package PREDATOR;

import java.net.*;
import java.io.*;

/**
 * The object describing the location of a 
 * <FONT COLOR="#CC0000"><FONT SIZE=+1>P</FONT>REDATOR</FONT> server.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 */
public class ServerSite {
  /// The internet address of the server
  InetAddress internetAddress;
  /// The port number of the server
  int port;

  /**
   * Constructor.
   * @param InternetAddress The address of the 
   * <FONT COLOR="#CC0000"><FONT SIZE=+1>P</FONT>REDATOR</FONT> server
   * @param Port The port number of the server
   */
  public ServerSite(InetAddress InternetAddress, int Port) 
  {
    this.internetAddress = InternetAddress;
    this.port = Port;
  }
  /**
   * Constructor.
   * @param InternetAddress A string form of the address of the 
   * <FONT COLOR="#CC0000"><FONT SIZE=+1>P</FONT>REDATOR</FONT> server
   * @param Port The port number of the server
   * @except UnknownHostException if InternetAddress is not the name of
   *                              a known internet host
   */
  public ServerSite(String InternetAddress, int Port) 
    throws UnknownHostException 
  {
    this.internetAddress = InetAddress.getByName(InternetAddress);
    this.port = Port;
  }
  /**
   * Gets the host address of this server site.
   * @return The host address of this server site
   */
  public InetAddress getHostAddress()
  {
    return internetAddress;
  }
  /**
   * Gets the port number of this server site.
   * @return port number of this server site
   */
  public int getPortNumber()
  {
    return port;
  }
  /**
   * Creates a string version of this object.
   * @return A string version of this object
   */
  public String toString()
  {
    return (internetAddress.toString() + ":" + port);
  }
}
