package PREDATOR;

/**
 * The result returned by a call to Connection.processQuery when the results
 * are not records, but are not erroneous, either, e.g., "list rels".
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see Connection#processQuery(Query)
 */
public class UnformattedResult implements QueryResult {
  /// The contents of the unformatted result
  String result;

  /**
   * Constructor.
   * @param result The unformatted result
   */
  UnformattedResult(String result)
  {
    this.result = result;
  }
  /**
   * Produces a string form of the unformatted result.
   * @return A string form of the unformatted result
   */
  public String toString()
  {
    return result;
  }
}
