package PREDATOR;

/**
 * The exception thrown when a query has not yet been terminated, but
 * an attempt is made to close the connection or to process a new query.
 * @author Mark A. Paskin, paskin@cs.cornell.edu
 * @version 0.9
 * @see Connection#processQuery(Query)
 * @see Connection#close()
 */
public class UnterminatedQueryException extends Exception {
  /**
   * Constructs a UnterminatedQueryException without a detail message.
   */
  public UnterminatedQueryException()
  {
    super();
  }

  /**
   * Constructs a UnterminatedQueryException with the specified message.
   */
  public UnterminatedQueryException(String Message)
  {
    super(Message);
  }
}
