package JDBCGui;

import java.awt.*;

/**
* This class brings out a Dialog window into which the user
* enters a SQL statement inorder to make a query.
* @author Emre Tezel
* @version 1.0
* @see java.awt.Dialog
*/
public class QueryDialog extends Dialog {

	private PJGui parent;
	private Button ok;
	private Button cancel;
	private TextField text;

	/**
	* The constructor. It takes a Frame object as a parameter. 
	* In our case this Frame object 
	* is our PJGui object in which we create a new instance of QueryDialog. 
	* parent = (PJGui)f creates a link to the PJGui object, 
	* which allow us to use its methods whithin the QueryDialog class.
	* The layout of the Dialog is also created inside the constractor. 
	* @see PJGui#action(java.awt.Event, java.lang.Object)
	*/
	public QueryDialog (Frame f) {

		super(f, "Query String", true);
		parent = (PJGui)f;
		text = new TextField(40);
		ok = new Button("  OK  ");
		cancel = new Button("CANCEL");
		
		setLayout(new GridLayout(3,1));
		add(text);
		add(ok);
		add(cancel);
		resize(500,150);
	
		show();
	}

	public boolean handleEvent( Event e) {

		if ( e.id == Event.WINDOW_DESTROY ) {

			hide();
			dispose();
			return true;
		}

		return super.handleEvent(e);
	}

	/**
	* When the user hits ok, the makeQuery() method of PJGui is called.
	* @see PJGui#makeQuery(java.lang.String)
	*/
	
	public boolean action(Event e, Object o) {

		if ( e.target == ok) {
			String name = text.getText();
			parent.makeQuery(name);
			hide();
			dispose();
		}

		if ( e.target == cancel) {
			hide();
			dispose();
		}

		return true;
	}

			



}



