#include "gisadt.h"
#include "math.h"
#include "STransX.h"
#include <math.h>


// Synthetic data
#define RATE 1 //1 means 1 T/S, 0.1 means 10 T/S, 0.01 means  100 T/S ... Etc.
//#define RATE 0.2 //1 means 1 T/S, 0.1 means 10 T/S, 0.01 means  100 T/S ... Etc.
int TheSourceCnt = 250;
void *currBS;

int tmpCnt = 0;
int maxDelayMSec = 0;

struct timeval RefTime;

XxxBasicType XxxSTransXADT::STransXTypeId = XXX_UNKNOWN;

// Constructor for STransXADT
XxxSTransXADT::XxxSTransXADT(XxxBasicType TypeId) 
  : XxxSmallFixedADT (TypeId, "STransX", sizeof (STransXStruct))   
{
  STransXTypeId = TypeId;                         
  
  int PolygonId = XxxPolygonADT::PolygonTypeId;
  int PointId = XxxPointADT::PointTypeId;
  // Register the methods for the STransXADT
  NumMethods = 1; 
  MethArray = new FuncMethodInfo* [NumMethods]; 
  MethArray[0] = new FuncMethodInfo( "ItemN" , XXX_INT, 
				     0 , 0 , (ExecuteFunc)(PlanInfo::execItemN), 0 );
}


XxxErrCode XxxSTransXADT::ReadText(istream& InStream, 
				   XxxADTValue* ObjectRef, 
				   const XxxADTMetaInfo* MetaInfo) const 
{ 
  STransXStruct *BS = (STransXStruct *) ObjectRef;
  ASSERT((BS));
  BS->Init();

  // read file name 
  InStream >> BS->StreamFileName;
  BS->ItemN=0;
  BS->ScratchPad=NULL;
  BS->ScratchPadSize=0;
  return XXX_OK; 
}


XxxErrCode XxxSTransXADT::WriteText(ostream& OutStream, 
				    const XxxADTValue* Object, 
				    const XxxADTMetaInfo* MetaInfo) const 
{ 
  STransXStruct *BS = (STransXStruct *) Object;
  ASSERT((BS));

  struct timeval Time; 
  OutStream << BS->ItemN ;
  return XXX_OK; 
}
//SMostafa
//-------------------------------------------------------------------
XxxErrCode XxxSTransXADT::InitStream(XxxADTValue* ObjectRef){
  //				     const XxxADTMetaInfo* MetaInfo){
  ifstream *streamfile;
  STransXStruct *BS = (STransXStruct *) ObjectRef;
  
  // this is first time, open the file
  streamfile = new ifstream(BS->StreamFileName);
 
  if(streamfile==NULL)
    return XXX_NOT_OK;

  //  srand( (unsigned)time( NULL ) );

  BS->ScratchPad = (void *)streamfile;
  BS->ScratchPadSize = sizeof(FILE);

  return XXX_OK;
}

//-------------------------------------------------------------------
// Read stream that generates a random and Synthetic data stream
/*
XxxErrCode XxxSTransXADT::ReadStream(XxxADTValue* ObjectRef,
				     const XxxADTMetaInfo* MetaInfo,
				     int *retVal, struct timeval *TS){
  
  STransXStruct *BS = (STransXStruct *) ObjectRef;   
  ifstream *streamfile;
  
  streamfile = (ifstream*)BS->ScratchPad;
  if (streamfile==NULL)
    return XXX_NOT_OK;
  
  
  if(streamfile->eof()!=0){
    *retVal = STREAM_END; 
    return XXX_OK;
  }
  struct timezone Temp; 

  gettimeofday(TS, &Temp);

  BS->ItemN = 10;
  *retVal = STREAM_NEW_VALUE; 

  return XXX_OK;
}
*/
//-------------------------------------------------------------------
// Read stream that reside in an outside file

XxxErrCode XxxSTransXADT::ReadStream(XxxADTValue* ObjectRef,
				     //				     const XxxADTMetaInfo* MetaInfo,
				     int *retVal, struct timeval *TS){
  
  STransXStruct *BS = (STransXStruct *) ObjectRef;   
  ifstream *streamfile;
  
  streamfile = (ifstream*)BS->ScratchPad;
  if (streamfile==NULL)
    return XXX_NOT_OK;
  
  
  if(streamfile->eof()!=0){
    *retVal = STREAM_END; 
    return XXX_OK;
  }
  
  int storeN=0; 
  int TxnDate=0; 
  int TxnTime=0; 
  
  *streamfile >> storeN >> BS->ItemN >> TxnDate >> TxnTime;
  int hours   = TxnTime/1000000;
  ASSERT(hours>=0);
  ASSERT(hours<=23);

  int minutes = (TxnTime - hours*1000000)/10000;
  ASSERT(minutes>=0);
  ASSERT(minutes<=60);

  // Convert date
  int year = TxnDate / 10000;
  int month = (TxnDate - year*10000)/100;
  ASSERT(month>=0);
  ASSERT(month<=12)
  int day = TxnDate - year*10000 - month*100;
  ASSERT(day>=0);
  ASSERT(day<=31)
  int TotalDays = day;
  // data is relative to beginning of 1999 
  // get year-> day
  if((year-1999)==1)
    TotalDays = TotalDays + 365;
  if((year-1999)==2)
    TotalDays = TotalDays + 731;
  // get month day
  if(month>=2)
    TotalDays = TotalDays+31;
  if(month>=3){
    if ((year-1999)==1)
      TotalDays = TotalDays+29;
    else
      TotalDays = TotalDays+28;
  };
  if(month>=4)
    TotalDays = TotalDays+31;
  if(month>=5)
    TotalDays = TotalDays+30;
  if(month>=6)
    TotalDays = TotalDays+31;
  if(month>=7)
    TotalDays = TotalDays+30;
  if(month>=8)
    TotalDays = TotalDays+31;
  if(month>=9)
    TotalDays = TotalDays+31;
  if(month>=10)
    TotalDays = TotalDays+30;
  if(month>=11)
    TotalDays = TotalDays+31;
  if(month>=12)
    TotalDays = TotalDays+30;
  // update the time stamp

  TS->tv_sec = ((TotalDays*24+hours)*60 + minutes)*60;
  TS->tv_usec = 0;
  
  *retVal = STREAM_NEW_VALUE; 

  return XXX_OK;
}
//-------------------------------------------------------------------
XxxErrCode XxxSTransXADT::CloseStream(XxxADTValue* ObjectRef){
  //				      const XxxADTMetaInfo* MetaInfo){
  
  ifstream *streamfile;
  STransXStruct *BS = (STransXStruct *) ObjectRef;

  streamfile = (ifstream*)BS->ScratchPad;
  
  if (streamfile!=NULL)
    streamfile->close();

  // remove the scratchpad
  if(BS->ScratchPad)
    delete (void *)(BS->ScratchPad);

  return XXX_OK;

}
//EMostafa

XxxErrCode XxxSTransXADT::CopyHToN(const XxxADTValue* Object, 
				   XxxADTValue *ResultObject,
				   const XxxADTMetaInfo* MetaInfo) const
{
  XxxNetworkInt((int *)(&(((STransXStruct *) ResultObject)->ItemN)), ((STransXStruct *) Object)->ItemN);

  return XXX_OK;
}

XxxErrCode XxxSTransXADT::CopyNToH(const XxxADTValue* Object, 
				   XxxADTValue *ResultObject,
				   const XxxADTMetaInfo* MetaInfo) const
{
  XxxHostInt((int *)(&(((STransXStruct *) ResultObject)->ItemN)), ((STransXStruct *) Object)->ItemN);

  return XXX_OK;
}

XxxErrCode XxxSTransXADT::PlanInfo::execItemN(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
  ASSERT((Env->NumArgs == 0));
  ASSERT((Env->OwnerValPtr ));
  
  STransXStruct *BS = (STransXStruct * )(Env->OwnerValPtr);

  ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = BS->ItemN;
  return XXX_OK;
}
