#ifndef XXX_STRANSX_H
#define XXX_STRANSX_H
#include "genadt.h"
#include "optrules.h"
#include "geometry.h"
#include "adtfunc.h"

//SMostafa
#include "stream-mgr.h"
#include <sys/time.h>
//EMostafa


/**
 * XxxSTransXADT:  
 * A stream data typle for the Wal-Mart store transactions
 * the tuple contains the item number and other fields
 * such as item cnt, item description , item amount, date and time
 * the total size id 86 bytes, 
 * The actual size of the structure is around 200 bytes.
 */
class XxxSTransXADT : public XxxSmallFixedADT {
  friend class XxxGISModule;
  public : 
    static XxxBasicType STransXTypeId;
  
  
  
  class STransXStruct : public XxxADTValue { public:
  int ItemN;
  char StreamFileName[50];
  void *ScratchPad;
  int ScratchPadSize;
  };
 protected : 
  /**
   * PlanInfo:
   * Plan structure for methods on TransX
   */
 class PlanInfo : public XxxFuncPlanInfo {
    friend class XxxSTransXADT;
    XxxErrCode execItemN(XxxValueEnv* Env, 
			 XxxADTValue *ReturnValue) const; 
    public :
      PlanInfo(const XxxFuncParseInfo* FuncParse, int ArgCount)
      : XxxFuncPlanInfo(FuncParse , ArgCount) {}
 };
 friend class PlanInfo;
 
 virtual XxxErrCode methOptimize(XxxFuncParseInfo* FuncParse,
				 XxxValueExprPlan* OwnerPlan,
				 XxxValExprPlanList* ArgPlans,
				 XxxFuncPlanInfo*& FPlan) const{
   FPlan = new PlanInfo(FuncParse, (ArgPlans?ArgPlans->Count():0));
   return XXX_OK;
 }
 public:
  /// Constructor for XxxSTransXADT.
  XxxSTransXADT(XxxBasicType Id); 
  /// Destructor for XxxTransXADT.
  virtual ~XxxSTransXADT(){} 
  //******************************************************************
  //SMostafa
  // This function must be implemented be each stream data type to 
  // indicate that the data type is stream
  //******************************************************************
  
  virtual XxxBool IsStream() const
    { return XXX_TRUE; }


  /**
   * Display function for the txtclient protocol.
   *
   * @param OutStream Output stream to write to.
   * @param Object Buffer containing the TransX.
   * @param MetaInfo Meta info for TransX.
   * @return The status code.
   */
  virtual XxxErrCode WriteText(ostream& OutStream, 
			       const XxxADTValue* Object,
			       const XxxADTMetaInfo* MetaInfo) const;
  /**
   * Input function for loading TrransX into tables.
   *
   * @param is Input stream from which to read the transaction source 
   * (in our case a filename).
   * @param ObjectRef Buffer in which to store the TransX.
   * @param MetaInfo Meta info for TransX.
   * @return The status code.
   */
  virtual XxxErrCode ReadText(istream& InStream, 
			      XxxADTValue* ObjectRef,
			      const XxxADTMetaInfo* MetaInfo) const;

  virtual XxxErrCode CopyHToN(const XxxADTValue* SrcObject, 
			      XxxADTValue *ResultObject,
			      const XxxADTMetaInfo* MetaInfo) const;
  virtual XxxErrCode CopyNToH(const XxxADTValue* SrcObject, 
			      XxxADTValue *ResultObject,
			      const XxxADTMetaInfo* MetaInfo) const;

  //SMostafa
  virtual XxxErrCode InitStream(XxxADTValue* ObjectRef);
  //				const XxxADTMetaInfo* MetaInfo);

  virtual XxxErrCode ReadStream(XxxADTValue* ObjectRef,
				//const XxxADTMetaInfo* MetaInfo,
				int *retVal,
				struct timeval *TS);
  virtual XxxErrCode CloseStream(XxxADTValue* ObjectRef);
  //				 const XxxADTMetaInfo* MetaInfo);
  //EMostafa
  
};

#endif    /*  XXX_STransX_H */ 
