#include "box.h" 
#include "polygon.h"
#include "gisadt.h"

//---------------------------------------------------------------------------------
XxxErrCode XxxBoxADT :: PlanInfo :: 
execDisjointp(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
  XxxGISModule::PolygonStruct *poly1;
  XxxGISModule::InMemPolygon* InMemPolygon1 = NULL;
  XXX_POLYGON *poly = NULL;

  XxxGISModule::BoxStruct *BS = (XxxGISModule::BoxStruct*)Env->OwnerValPtr;
  XXX_BOX* box = &(BS->Box);
 
  poly = box_2_poly(box);
  poly1 = (XxxGISModule::PolygonStruct *) (Env->ArgValsPtrs[0]);
  InMemPolygon1 = NULL;
  if (XxxGISModule::GetMemPolygon(poly1, InMemPolygon1) != XXX_OK) {
      poly_free(poly);
      XXX_NOTE_ERROR(XXX_BADFUNC, "Error retrieving polygon!");
      return XXX_NOT_OK;
  }
  ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = (!(poly_overlap(poly,&(InMemPolygon1->polygon))));
  poly_free(poly);
  delete InMemPolygon1;
  return XXX_OK;
}

//---------------------------------------------------------------------------------
XxxErrCode XxxBoxADT :: PlanInfo :: 
execDisjointb(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
  XxxGISModule::BoxStruct *BS = (XxxGISModule::BoxStruct*)Env->OwnerValPtr;
  XXX_BOX* box = &(BS->Box);
  XxxGISModule::BoxStruct *BS2 = (XxxGISModule::BoxStruct*)(Env->ArgValsPtrs[0]);
  XXX_BOX* box2 = &(BS2->Box);

  ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = (!(box_overlap(box, box2)));
  return XXX_OK;
}
//---------------------------------------------------------------------------------
XxxErrCode XxxBoxADT :: PlanInfo :: 
execMeetsp(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
  XxxGISModule::PolygonStruct *poly1;
  XxxGISModule::InMemPolygon* InMemPolygon1 = NULL;
  XXX_POLYGON *poly = NULL;

  XxxGISModule::BoxStruct *BS = (XxxGISModule::BoxStruct*)Env->OwnerValPtr;
  XXX_BOX* box = &(BS->Box);

  poly = box_2_poly(box);
  poly1 = (XxxGISModule::PolygonStruct *) (Env->ArgValsPtrs[0]);
  InMemPolygon1 = NULL;
  if (XxxGISModule::GetMemPolygon(poly1, InMemPolygon1) != XXX_OK) {
      poly_free(poly);
      XXX_NOTE_ERROR(XXX_BADFUNC, "Error retrieving polygon!");
      return XXX_NOT_OK;
  }
  ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = 
	(poly_overlap(poly,&(InMemPolygon1->polygon)) && (!(poly_ooverlap(poly,&(InMemPolygon1->polygon)))));
  poly_free(poly);
  delete InMemPolygon1;
  return XXX_OK;
}
//---------------------------------------------------------------------------------
XxxErrCode XxxBoxADT :: PlanInfo :: 
execMeetsb(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
  XxxGISModule::BoxStruct *BS = (XxxGISModule::BoxStruct*)Env->OwnerValPtr;
  XXX_BOX* box = &(BS->Box);
  XxxGISModule::BoxStruct *BS2 = (XxxGISModule::BoxStruct*)(Env->ArgValsPtrs[0]);
  XXX_BOX* box2 = &(BS2->Box);
  ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = 
      ((box_overlap(box, box2))&&(!(box_ooverlap(box, box2))));
  return XXX_OK;
  
}

//---------------------------------------------------------------------------------
XxxErrCode XxxBoxADT :: PlanInfo :: 
execOverlapsp(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
  XxxGISModule::PolygonStruct *poly1;
  XxxGISModule::InMemPolygon* InMemPolygon1 = NULL;
  XXX_POLYGON *poly = NULL;

  XxxGISModule::BoxStruct *BS = (XxxGISModule::BoxStruct*)Env->OwnerValPtr;
  XXX_BOX* box = &(BS->Box);
 
  poly = box_2_poly(box);
  poly1 = (XxxGISModule::PolygonStruct *) (Env->ArgValsPtrs[0]);
  InMemPolygon1 = NULL;
  if (XxxGISModule::GetMemPolygon(poly1, InMemPolygon1) != XXX_OK) {
      poly_free(poly);
      XXX_NOTE_ERROR(XXX_BADFUNC, "Error retrieving polygon!");
      return XXX_NOT_OK;
  }

  ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = (poly_overlap(poly,&(InMemPolygon1->polygon)));
  poly_free(poly);
  delete InMemPolygon1;
  return XXX_OK;
}
//---------------------------------------------------------------------------------
XxxErrCode XxxBoxADT :: PlanInfo :: 
execOverlapsb(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
  XxxGISModule::BoxStruct *BS = (XxxGISModule::BoxStruct*)Env->OwnerValPtr;
  XXX_BOX* box = &(BS->Box);
  XxxGISModule::BoxStruct *BS2 = (XxxGISModule::BoxStruct*)(Env->ArgValsPtrs[0]);
  XXX_BOX* box2 = &(BS2->Box);
  ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = (box_overlap(box, box2));
  return XXX_OK;
}
//---------------------------------------------------------------------------------
XxxErrCode XxxBoxADT :: PlanInfo :: 
execCovered_byp(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
  XxxGISModule::PolygonStruct *poly1;
  XxxGISModule::InMemPolygon* InMemPolygon1 = NULL;
  XXX_POLYGON *poly = NULL;

  XxxGISModule::BoxStruct *BS = (XxxGISModule::BoxStruct*)Env->OwnerValPtr;
  XXX_BOX* box = &(BS->Box);

  poly = box_2_poly(box);
  poly1 = (XxxGISModule::PolygonStruct *) (Env->ArgValsPtrs[0]);
  InMemPolygon1 = NULL;
  if (XxxGISModule::GetMemPolygon(poly1, InMemPolygon1) != XXX_OK) {
      poly_free(poly);
      XXX_NOTE_ERROR(XXX_BADFUNC, "Error retrieving polygon!");
      return XXX_NOT_OK;
  }
  ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = (poly_in_poly(poly, &(InMemPolygon1->polygon)));
  poly_free(poly);
  delete InMemPolygon1;
  return XXX_OK;
}

//---------------------------------------------------------------------------------
XxxErrCode XxxBoxADT :: PlanInfo :: 
execCovered_byb(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
  XxxGISModule::BoxStruct *BS = (XxxGISModule::BoxStruct*)Env->OwnerValPtr;
  XXX_BOX* box = &(BS->Box);
  XxxGISModule::BoxStruct *BS2 = (XxxGISModule::BoxStruct*)(Env->ArgValsPtrs[0]);
  XXX_BOX* box2 = &(BS2->Box);
  ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = (box_in_box(box, box2));
  return XXX_OK;
}
//---------------------------------------------------------------------------------
XxxErrCode XxxBoxADT :: PlanInfo :: 
execInsidep(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
  XxxGISModule::PolygonStruct *poly1;
  XxxGISModule::InMemPolygon* InMemPolygon1 = NULL;
  XXX_POLYGON *poly = NULL;

  XxxGISModule::BoxStruct *BS = (XxxGISModule::BoxStruct*)Env->OwnerValPtr;
  XXX_BOX* box = &(BS->Box);

  poly = box_2_poly(box);
  poly1 = (XxxGISModule::PolygonStruct *) (Env->ArgValsPtrs[0]);
  InMemPolygon1 = NULL;
  if (XxxGISModule::GetMemPolygon(poly1, InMemPolygon1) != XXX_OK) {
      poly_free(poly);
      XXX_NOTE_ERROR(XXX_BADFUNC, "Error retrieving polygon!");
      return XXX_NOT_OK;
  }
  ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = (poly_iin_poly(poly,&(InMemPolygon1->polygon)));
  poly_free(poly);
  delete InMemPolygon1;
  return XXX_OK;
}
//---------------------------------------------------------------------------------
XxxErrCode XxxBoxADT :: PlanInfo :: 
execInsideb(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
  XxxGISModule::BoxStruct *BS = (XxxGISModule::BoxStruct*)Env->OwnerValPtr;
  XXX_BOX* box = &(BS->Box);
  XxxGISModule::BoxStruct *BS2 = (XxxGISModule::BoxStruct*)(Env->ArgValsPtrs[0]);
  XXX_BOX* box2 = &(BS2->Box);
  ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = (box_iin_box(box, box2));
  return XXX_OK;
}
//---------------------------------------------------------------------------------
XxxErrCode XxxBoxADT :: PlanInfo :: 
execEqualsp(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
  XxxGISModule::PolygonStruct *poly1;
  XxxGISModule::InMemPolygon* InMemPolygon1 = NULL;
  XXX_POLYGON *poly = NULL;

  XxxGISModule::BoxStruct *BS = (XxxGISModule::BoxStruct*)Env->OwnerValPtr;
  XXX_BOX* box = &(BS->Box);
 
  poly = box_2_poly(box);
  poly1 = (XxxGISModule::PolygonStruct *) (Env->ArgValsPtrs[0]);
  InMemPolygon1 = NULL;
  if (XxxGISModule::GetMemPolygon(poly1, InMemPolygon1) != XXX_OK) {
      poly_free(poly);
      XXX_NOTE_ERROR(XXX_BADFUNC, "Error retrieving polygon!");
      return XXX_NOT_OK;
  }
  ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = (poly_equals(poly,&(InMemPolygon1->polygon)));
  poly_free(poly);
  delete InMemPolygon1;
  return XXX_OK;
}
//---------------------------------------------------------------------------------
XxxErrCode XxxBoxADT :: PlanInfo :: 
execEqualsb(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
  XxxGISModule::BoxStruct *BS = (XxxGISModule::BoxStruct*)Env->OwnerValPtr;
  XXX_BOX* box = &(BS->Box);
  XxxGISModule::BoxStruct *BS2 = (XxxGISModule::BoxStruct*)(Env->ArgValsPtrs[0]);
  XXX_BOX* box2 = &(BS2->Box);
  ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = (box_equals(box, box2));
  return XXX_OK;
}
//---------------------------------------------------------------------------------
XxxErrCode XxxBoxADT :: PlanInfo :: 
execCoversp(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
  XxxGISModule::PolygonStruct *poly1;
  XxxGISModule::InMemPolygon* InMemPolygon1 = NULL;
  XXX_POLYGON *poly = NULL;

  XxxGISModule::BoxStruct *BS = (XxxGISModule::BoxStruct*)Env->OwnerValPtr;
  XXX_BOX* box = &(BS->Box);

  poly = box_2_poly(box);
  poly1 = (XxxGISModule::PolygonStruct *) (Env->ArgValsPtrs[0]);
  InMemPolygon1 = NULL;
  if (XxxGISModule::GetMemPolygon(poly1, InMemPolygon1) != XXX_OK) {
      poly_free(poly);
      XXX_NOTE_ERROR(XXX_BADFUNC, "Error retrieving polygon!");
      return XXX_NOT_OK;
  }
  ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = (poly_in_poly(&(InMemPolygon1->polygon),poly));
  poly_free(poly);
  delete InMemPolygon1;
  return XXX_OK;
}
//---------------------------------------------------------------------------------
XxxErrCode XxxBoxADT :: PlanInfo :: 
execCoversb(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
  XxxGISModule::BoxStruct *BS = (XxxGISModule::BoxStruct*)Env->OwnerValPtr;
  XXX_BOX* box = &(BS->Box);
  XxxGISModule::BoxStruct *BS2 = (XxxGISModule::BoxStruct*)(Env->ArgValsPtrs[0]);
  XXX_BOX* box2 = &(BS2->Box);
  ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = (box_in_box(box2, box));
  return XXX_OK;
}
//---------------------------------------------------------------------------------
XxxErrCode XxxBoxADT :: PlanInfo :: 
execCoverspt(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
  XxxGISModule::BoxStruct *BS = (XxxGISModule::BoxStruct*)Env->OwnerValPtr;
  XXX_BOX* box = &(BS->Box);
  XxxGISModule::PointStruct* PS = (XxxGISModule::PointStruct*)(Env->ArgValsPtrs[0]);
  XXX_POINT* p = &(PS->Point);
  ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = (point_in_box(p, box));
  return XXX_OK;
}
//---------------------------------------------------------------------------------
XxxErrCode XxxBoxADT :: PlanInfo :: 
execContainsp(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
  XxxGISModule::PolygonStruct *poly1;
  XxxGISModule::InMemPolygon* InMemPolygon1 = NULL;
  XXX_POLYGON *poly = NULL;

  XxxGISModule::BoxStruct *BS = (XxxGISModule::BoxStruct*)Env->OwnerValPtr;
  XXX_BOX* box = &(BS->Box);

  poly = box_2_poly(box);
  poly1 = (XxxGISModule::PolygonStruct *) (Env->ArgValsPtrs[0]);
  InMemPolygon1 = NULL;
  if (XxxGISModule::GetMemPolygon(poly1, InMemPolygon1) != XXX_OK) {
    poly_free(poly);
    XXX_NOTE_ERROR(XXX_BADFUNC, "Error retrieving polygon!");
    return XXX_NOT_OK;
  }
  ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = (poly_iin_poly(&(InMemPolygon1->polygon),poly));
  poly_free(poly);
  delete InMemPolygon1;
  return XXX_OK;
}
//---------------------------------------------------------------------------------
XxxErrCode XxxBoxADT :: PlanInfo :: 
execContainsb(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
  XxxGISModule::BoxStruct *BS = (XxxGISModule::BoxStruct*)Env->OwnerValPtr;
  XXX_BOX* box = &(BS->Box);
  XxxGISModule::BoxStruct *BS2 = (XxxGISModule::BoxStruct*)(Env->ArgValsPtrs[0]);
  XXX_BOX* box2 = &(BS2->Box);
  ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = (box_iin_box(box2, box));
  return XXX_OK;
}
//---------------------------------------------------------------------------------
XxxErrCode XxxBoxADT :: PlanInfo :: 
execContainspt(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
  XxxGISModule::BoxStruct *BS = (XxxGISModule::BoxStruct*)Env->OwnerValPtr;
  XXX_BOX* box = &(BS->Box);
  XxxGISModule::PointStruct* PS = (XxxGISModule::PointStruct*)(Env->ArgValsPtrs[0]);
  XXX_POINT* p = &(PS->Point);
  ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = (point_iin_box(p, box));
  return XXX_OK;
}
