#include "gisadt.h"
#include "math.h"
#include "BoundingBox.h"

XxxBasicType XxxCircleADT::CircleTypeId = XXX_UNKNOWN;

// Constructor for CircleADT
XxxCircleADT::XxxCircleADT(XxxBasicType TypeId) 
 : XxxSmallFixedADT ( TypeId, "circle",        
                      sizeof ( CircleStruct))   
{
  CircleTypeId = TypeId;                         
}

XxxErrCode XxxCircleADT::ReadText(istream& InStream, 
				  XxxADTValue* ObjectRef, 
				  const XxxADTMetaInfo* MetaInfo) const 
{ 
  CircleStruct* CS = (CircleStruct*)ObjectRef;
  ASSERT((CS));
  XXX_CIRCLE *circle = &(CS->Circle);
  
 InStream >> circle->center.x >> circle->center.y >> circle->radius;
  /*
  if (InStream.good()) return XXX_OK;
  else {
    XXX_NOTE_ERROR(XXX_BADPARSE, " Error reading circle ");
    return XXX_NOT_OK;
  }
  */
 return XXX_OK; 
}


XxxErrCode XxxCircleADT::WriteText(ostream& OutStream, 
				   const XxxADTValue* Object, 
                                   const XxxADTMetaInfo* MetaInfo) const 
{ 
  CircleStruct* CS = (CircleStruct*)Object;
  ASSERT((CS));
  XXX_CIRCLE *circle = &(CS->Circle);
  
  OutStream << "(" << circle->center.x << ", " << circle->center.y << ")" << ", " << circle->radius;
 return XXX_OK; 
}


XxxBool XxxCircleADT::Equals(const XxxADTValue* Obj1, 
			     const XxxADTMetaInfo* MInfo1,
			     const XxxADTValue* Obj2,
			     const XxxADTMetaInfo* MInfo2) const
{
  CircleStruct* CS1 = (CircleStruct*)Obj1;
  ASSERT((CS1));
  XXX_CIRCLE *c1 = &(CS1->Circle);
  CircleStruct* CS2 = (CircleStruct*)Obj2;
  ASSERT((CS2));
  XXX_CIRCLE *c2 = &(CS2->Circle);

  if (circle_equals(c1, c2)) return XXX_TRUE;
  else return XXX_FALSE;
}

// Index related methods.

XxxBool 
XxxCircleADT::GetBoundingBox(const XxxADTValue*& Object, 
			     XxxBoundingBox& Box) 
{
  CircleStruct* CS = (CircleStruct*)Object;
  ASSERT((CS));
  XXX_CIRCLE *c = &(CS->Circle);

  XXX_BOX *b = circle_MBR(c);

  int dim = 2;
  double bb_box[4];
  
  bb_box[0] = b->xl;
  bb_box[1] = b->yl;
  bb_box[2] = b->xh;
  bb_box[3] = b->yh;

  XxxBoundingBox tmp(dim, XXX_DOUBLE, (void *) bb_box);
  Box = tmp;

  delete b;
  return XXX_TRUE;
}

XxxErrCode XxxCircleADT::CopyHToN(const XxxADTValue* Object, 
				  XxxADTValue *ResultObject,
				  const XxxADTMetaInfo* MetaInfo) const
{
  XXX_CIRCLE *circ = &(((CircleStruct *) Object)->Circle);
  XXX_CIRCLE *Rcirc = &(((CircleStruct *) ResultObject)->Circle);
  XxxNetworkValue(Rcirc, *circ);
  return XXX_OK;
}

XxxErrCode XxxCircleADT::CopyNToH(const XxxADTValue* Object, 
				  XxxADTValue *ResultObject,
				  const XxxADTMetaInfo* MetaInfo) const
{
  XXX_CIRCLE *circ = &(((CircleStruct *) Object)->Circle);
  XXX_CIRCLE *Rcirc = &(((CircleStruct *) ResultObject)->Circle);
  XxxHostValue(Rcirc, *circ);
  return XXX_OK;
}

