#include "complex.h"
#include "aggrexpr.h"

XxxErrCode XxxComplexADT::PlanInfo::
execReal(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{
  ComplexStruct* CV = ( ComplexStruct* )(Env->OwnerValPtr);
  ASSERT((Env->NumArgs == 0));
  ((XxxCoreADTClass::DblValue *)ReturnValue)->Value = CV->Real;
  return XXX_OK;
}

XxxErrCode XxxComplexADT::PlanInfo::
execImag(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{
  ComplexStruct* CV = ( ComplexStruct* )(Env->OwnerValPtr);
  ASSERT((Env->NumArgs == 0));
  ((XxxCoreADTClass::DblValue *)ReturnValue)->Value = CV->Imag;
  return XXX_OK; 
}

XxxErrCode XxxComplexADT::PlanInfo::
execPlus(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{
  ComplexStruct* CV = ( ComplexStruct* )(Env->OwnerValPtr);
  ASSERT((Env->NumArgs == 1));
  ComplexStruct* ArgCV = ((ComplexStruct*)(Env->ArgValsPtrs[0]));
  ((ComplexStruct *)ReturnValue)->Real = CV->Real+ArgCV->Real ;
  ((ComplexStruct *)ReturnValue)->Imag = CV->Imag+ArgCV->Imag ;
  return XXX_OK;
}

XxxErrCode XxxComplexADT::PlanInfo::
execMinus(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{
  ComplexStruct* CV = ( ComplexStruct* )(Env->OwnerValPtr);
  ASSERT((Env->NumArgs == 1));
  ComplexStruct* ArgCV = ((ComplexStruct*)(Env->ArgValsPtrs[0]));
  ((ComplexStruct *)ReturnValue)->Real = CV->Real-ArgCV->Real ;
  ((ComplexStruct *)ReturnValue)->Imag = CV->Imag-ArgCV->Imag ;
  return XXX_OK;
}


XxxErrCode XxxComplexADT::PlanInfo::
execInvert(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{
  ComplexStruct* CV = ( ComplexStruct* )(Env->OwnerValPtr);
  ASSERT((Env->NumArgs == 0));
  ((ComplexStruct *)ReturnValue)->Real = CV->Imag ;
  ((ComplexStruct *)ReturnValue)->Imag = CV->Real ;
  return XXX_OK;
  
}

XxxErrCode XxxComplexADT::PlanInfo::
csumInit(XxxAggrOpHandle& Hndl) const
{
  Hndl.Started = XXX_TRUE;
 ((ComplexStruct *)(Hndl.AccumVal))->Real = 0;
 ((ComplexStruct *)(Hndl.AccumVal))->Imag = 0;
  return XXX_OK;
}

XxxErrCode XxxComplexADT::PlanInfo::
csumAccum(XxxValueEnv* Env, XxxAggrOpHandle& Hndl) const
{
  XxxADTValue* NewVal = Env->OwnerValPtr;
 ((ComplexStruct *)(Hndl.AccumVal))->Real += 
   ((ComplexStruct *)(NewVal))->Real;
 ((ComplexStruct *)(Hndl.AccumVal))->Imag += 
   ((ComplexStruct *)(NewVal))->Imag;
 return XXX_OK;
}

XxxErrCode XxxComplexADT::PlanInfo::
csumTerm(XxxAggrOpHandle& Hndl, XxxADTValue* FinalVal) const
{
 ((ComplexStruct *)(FinalVal))->Real = 
   ((ComplexStruct *)(Hndl.AccumVal))->Real;
 ((ComplexStruct *)(FinalVal))->Imag = 
   ((ComplexStruct *)(Hndl.AccumVal))->Imag;
 return XXX_OK;
}

