#ifndef XXX_GENTIMESERIES_H
#define XXX_GENTIMESERIES_H
#include "genadt.h"


/**
 * XxxGenTimeSeriesADT
 */
class XxxGenTimeSeriesADT : public XxxSmallVarADT 
{
  public:
  //// Type ID accessible without object
  static XxxBasicType GenTimeSeriesTypeId;
  
  protected:
  
  ////  Structure used to represent GenTimeSeriesADT within a record
  class GenTimeSeriesStruct : public XxxADTValue 
	{
    public : 
			int numDays;
		  int dataOfPeriod[ 501 ];

		  void Init( )
			{
				numDays = 0;
			}
  };
  
  //// meta Info for GenTimeSeries ADT  
  class GenTimeSeriesMetaInfo : public XxxADTMetaInfo 
	{
    public : 
    int numDays;
    void Init() 
		{
      numDays = 0;
    }

    GenTimeSeriesMetaInfo ()
		{
			Init();
		}

	GenTimeSeriesMetaInfo (GenTimeSeriesMetaInfo *origin)
	{	numDays = origin->numDays; }

    virtual ~GenTimeSeriesMetaInfo() {}
    
    virtual XxxErrCode Replicate(XxxADTMetaInfo*& NewMI) const{
      GenTimeSeriesMetaInfo* NewMetaInfo = new GenTimeSeriesMetaInfo(*this);
      NewMI = NewMetaInfo;
      return XXX_OK;
     }

    virtual void Print(ostream& OStr) const {
      OStr << "(\"" << numDays << ")\"";
     }

    virtual XxxBool IsCompatible(const XxxADTMetaInfo* OtherMI) const {
      GenTimeSeriesMetaInfo * ThatMI = (GenTimeSeriesMetaInfo *)OtherMI;
      return ((numDays == ThatMI->numDays) ? XXX_TRUE : XXX_FALSE);
     }

    /**
     * Returns the number of bytes necessary to hold the serialized version
     * of this meta-info object.
     * @param Size (out) The required number of bytes
     * @return XXX_NOT_OK if the object cannot be serialized, XXX_OK otherwise
     */
    virtual XxxErrCode SerializeCopySize(int &size) const {
      size = sizeof(numDays); 
			return XXX_OK;
    }

    /**
     * Creates a binary version of this meta-info object.
     * @param Data An array of bytes of at least the size specified by the
     *             SerializeCopySize() function.
     * @return XXX_NOT_OK if the object cannot be serialized, XXX_OK otherwise
     */
    virtual XxxErrCode SerializeCopy(char *Data) const {
      memcpy(Data, (char *)(&numDays), sizeof(numDays));  
			return XXX_OK;
    }
  };
  
  virtual XxxErrCode makeMetaInfo(const MetaInfoHandle& MIHandle,
				  XxxADTMetaInfo*& MI) const;
  virtual XxxErrCode parseMetaInfo(const char* MetaInfoString,
				   MetaInfoHandle& MIHandle) const;
  
 public:
  XxxGenTimeSeriesADT(XxxBasicType Id);
    
  virtual XxxErrCode WriteText(ostream& OutStream, 
				    const XxxADTValue* Object,
				    const XxxADTMetaInfo* MetaInfo) const;

  virtual XxxErrCode ReadText(istream& InStream, 
			      XxxADTValue* ObjectRef,
			      const XxxADTMetaInfo* MetaInfo) const;  

	virtual int TypeSize( const XxxADTValue*, 
					              const XxxADTMetaInfo* MetaInfo ) const;
	
	virtual int TypeCopy( const XxxADTValue* SrcObject,
												XxxADTValue *ResultObject,
												const XxxADTMetaInfo* MetaInfo ) const;

  virtual XxxErrCode SerializeCopySize(const XxxADTMetaInfo* MetaInfo,
				                unsigned int& Size) const;
  virtual XxxErrCode SerializeCopy(const XxxADTValue* Object,
				                const XxxADTMetaInfo* MetaInfo,
				                char* MemLocation) const;
  virtual XxxErrCode UnSerializeCopy(const char* MemLocation,
				                const XxxADTMetaInfo* MetaInfo,
				                XxxADTValue* Object) const;
	
  virtual XxxErrCode CopyHToN(const XxxADTValue* SrcObject, 
			      XxxADTValue *ResultObject,
			      const XxxADTMetaInfo* MetaInfo) const;
  virtual XxxErrCode CopyNToH(const XxxADTValue* SrcObject, 
			      XxxADTValue *ResultObject,
			      const XxxADTMetaInfo* MetaInfo) const;
 };


#endif    /*  XXX_GenTIMESERIES_H */ 
