#ifndef XXX_GISADT_H
#define XXX_GISADT_H

#include "geometry.h"
#include "box.h"
#include "polygon.h"
#include "point.h"
#include "circle.h"
#include "raster.h"

/***
  This file contains any information that
  spans the GIS types.
  ***/
/**
 * XxxGISModule
 */
class XxxGISModule {
  friend class XxxPointADT;
  friend class XxxBoxADT;
  friend class XxxRasterADT;
  friend class XxxCircleADT;
  friend class XxxPolygonADT;
 
public:
  XxxGISModule();
  ~XxxGISModule();

  typedef XxxPolygonADT::PolygonStruct PolygonStruct;
  typedef XxxBoxADT::BoxStruct BoxStruct;
  typedef XxxCircleADT::CircleStruct CircleStruct;
  typedef XxxPointADT::PointStruct PointStruct;

  typedef XxxPolygonADT::InMemPolygon InMemPolygon;
  static XxxErrCode GetMemPolygon(XxxPolygonADT::PolygonStruct *PS,
    XxxPolygonADT::InMemPolygon*& Polygon) 
  { return XxxPolygonADT::getMemPolygon(PS, Polygon);}

};

inline void XxxNetworkValue(XXX_POINT* NValue, XXX_POINT Value)
{
  XxxNetworkDouble(&(NValue->x), Value.x);
  XxxNetworkDouble(&(NValue->y), Value.y);
}
inline void XxxHostValue(XXX_POINT* NValue, XXX_POINT Value)
{
  XxxHostDouble(&(NValue->x), Value.x);
  XxxHostDouble(&(NValue->y), Value.y);
}

inline void XxxNetworkValue(XXX_CIRCLE* NValue, XXX_CIRCLE Value)
{
  XxxNetworkValue(&(NValue->center), Value.center);
  XxxNetworkDouble(&(NValue->radius), Value.radius);
}
inline void XxxHostValue(XXX_CIRCLE* NValue, XXX_CIRCLE Value)
{
  XxxHostValue(&(NValue->center), Value.center);
  XxxHostDouble(&(NValue->radius), Value.radius);
}

inline void XxxNetworkValue(XXX_BOX* NValue, XXX_BOX Value)
{
  XxxNetworkDouble(&(NValue->xl), Value.xl);
  XxxNetworkDouble(&(NValue->yl), Value.yl);
  XxxNetworkDouble(&(NValue->xh), Value.xh);
  XxxNetworkDouble(&(NValue->yh), Value.yh);
}
inline void XxxHostValue(XXX_BOX* NValue, XXX_BOX Value)
{
  XxxHostDouble(&(NValue->xl), Value.xl);
  XxxHostDouble(&(NValue->yl), Value.yl);
  XxxHostDouble(&(NValue->xh), Value.xh);
  XxxHostDouble(&(NValue->yh), Value.yh);
}

inline void XxxNetworkValue(XXX_LINE* NValue, XXX_LINE Value)
{
  XxxNetworkDouble(&(NValue->A), Value.A);
  XxxNetworkDouble(&(NValue->B), Value.B);
  XxxNetworkDouble(&(NValue->C), Value.C);
  XxxNetworkDouble(&(NValue->m), Value.m);
}
inline void XxxHostValue(XXX_LINE* NValue, XXX_LINE Value)
{
  XxxHostDouble(&(NValue->A), Value.A);
  XxxHostDouble(&(NValue->B), Value.B);
  XxxHostDouble(&(NValue->C), Value.C);
  XxxHostDouble(&(NValue->m), Value.m);
}

inline void XxxNetworkValue(XXX_POLYGON* NValue, XXX_POLYGON Value)
{
  XxxNetworkLong(&(NValue->npts), Value.npts);
  XxxNetworkValue(&(NValue->mbr), Value.mbr);
  // ignore pts : since this field is not used in the usual repr
}
inline void XxxHostValue(XXX_POLYGON* NValue, XXX_POLYGON Value)
{
  XxxHostLong(&(NValue->npts), Value.npts);
  XxxHostValue(&(NValue->mbr), Value.mbr);
  // ignore pts : since this field is not used in the usual repr
}


#endif
