#include "point.h" 
#include "polygon.h"
#include "gisadt.h"


//-------------------------------------------------------------------
XxxErrCode XxxPointADT :: PlanInfo :: 
execX(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
    ASSERT((Env->NumArgs == 0));
    ASSERT((Env->OwnerValPtr ));
    PointStruct *point = (PointStruct * )(Env->OwnerValPtr);
    ((XxxCoreADTClass::DblValue *)ReturnValue)->Value = point->Point.x;
    return XXX_OK;
}
//-------------------------------------------------------------------
XxxErrCode XxxPointADT :: PlanInfo :: 
execY(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
    ASSERT((Env->NumArgs == 0));
    ASSERT((Env->OwnerValPtr ));
    PointStruct *point = (PointStruct * )(Env->OwnerValPtr);
    ((XxxCoreADTClass::DblValue *)ReturnValue)->Value = point->Point.y;
    return XXX_OK;
}
//-------------------------------------------------------------------
XxxErrCode XxxPointADT :: PlanInfo :: 
execMake_box(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
    ASSERT((Env->NumArgs == 1));
    ASSERT((Env->OwnerValPtr ));
    PointStruct *point = (PointStruct * )(Env->OwnerValPtr);

    double slen = ((XxxCoreADTClass::DblValue *) (Env->ArgValsPtrs[0]))->Value;
    XxxGISModule::BoxStruct* BS = (XxxGISModule::BoxStruct*)ReturnValue;
    XXX_BOX* b = &(BS->Box);
  
    b->xl = (point->Point.x - slen/2.);
    b->yl = (point->Point.y - slen/2.);
    b->xh = (point->Point.x + slen/2.);
    b->yh = (point->Point.y + slen/2.);

    return XXX_OK;
}
//-------------------------------------------------------------------
XxxErrCode XxxPointADT :: PlanInfo :: 
execMake_circle(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
    ASSERT((Env->NumArgs == 1));
    ASSERT((Env->OwnerValPtr ));
    PointStruct *point = (PointStruct * )(Env->OwnerValPtr);

    double slen = ((XxxCoreADTClass::DblValue *)(Env->ArgValsPtrs[0]))->Value;
    XxxGISModule::CircleStruct* CS = (XxxGISModule::CircleStruct*)ReturnValue;
    XXX_CIRCLE* c = &(CS->Circle);
  
    c->center.x = point->Point.x;
    c->center.y = point->Point.y;
    c->radius = slen;
    return XXX_OK;
}
//-------------------------------------------------------------------
XxxErrCode XxxPointADT :: PlanInfo :: 
execInsidep(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
    ASSERT((Env->NumArgs == 1));
    ASSERT((Env->OwnerValPtr ));
    PointStruct *PS = (PointStruct * )(Env->OwnerValPtr);
    ASSERT((PS));
    XXX_POINT* point = &(PS->Point);
    XxxGISModule::PolygonStruct *poly = (XxxGISModule::PolygonStruct *) (Env->ArgValsPtrs[0]);
    XxxGISModule::InMemPolygon* InMemPolygon1 = NULL;
    if (XxxGISModule::GetMemPolygon(poly, InMemPolygon1) != XXX_OK) {
	XXX_NOTE_ERROR(XXX_BADFUNC, "Error retrieving polygon!");
	return XXX_NOT_OK;
     }
    ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = (point_in_poly(point, &(InMemPolygon1->polygon)));
    delete InMemPolygon1;
    return XXX_OK;
}
//-------------------------------------------------------------------
XxxErrCode XxxPointADT :: PlanInfo :: 
execInsideb(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
    ASSERT((Env->NumArgs == 1));
    ASSERT((Env->OwnerValPtr ));
    PointStruct *PS = (PointStruct * )(Env->OwnerValPtr);
    ASSERT((PS));
    XXX_POINT* point = &(PS->Point);

    XxxGISModule::BoxStruct *BS = (XxxGISModule::BoxStruct*)Env->ArgValsPtrs[0];
    XXX_BOX* b = &(BS->Box);

    ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = point_in_box(point,b);
    return XXX_OK;
}
//-------------------------------------------------------------------
XxxErrCode XxxPointADT :: PlanInfo :: 
execOutsidep(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
    ASSERT((Env->NumArgs == 1));
    ASSERT((Env->OwnerValPtr ));
    PointStruct *PS = (PointStruct * )(Env->OwnerValPtr);
    ASSERT((PS));
    XXX_POINT* point = &(PS->Point);

    XxxGISModule::PolygonStruct *poly = (XxxGISModule::PolygonStruct *) (Env->ArgValsPtrs[0]);
    XxxGISModule::InMemPolygon* InMemPolygon1 = NULL;
    if (XxxGISModule::GetMemPolygon(poly, InMemPolygon1) != XXX_OK) {
	XXX_NOTE_ERROR(XXX_BADFUNC, "Error retrieving polygon!");
	return XXX_NOT_OK;
      }
    ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = (!point_in_poly(point, &(InMemPolygon1->polygon)));
    delete InMemPolygon1;
    return XXX_OK;
    
}
//-------------------------------------------------------------------
XxxErrCode XxxPointADT :: PlanInfo :: 
execOutsideb(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
    ASSERT((Env->NumArgs == 1));
    ASSERT((Env->OwnerValPtr ));
    PointStruct *PS = (PointStruct * )(Env->OwnerValPtr);
    ASSERT((PS));
    XXX_POINT* point = &(PS->Point);

    XxxGISModule::BoxStruct *BS = (XxxGISModule::BoxStruct*)Env->ArgValsPtrs[0];
    XXX_BOX* b = &(BS->Box);
    ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = (!(point_in_box(point,b)));
    return XXX_OK;
}
//-------------------------------------------------------------------
XxxErrCode XxxPointADT :: PlanInfo :: 
execEquals(XxxValueEnv* Env, XxxADTValue *ReturnValue) const{ 
    ASSERT((Env->NumArgs == 1));
    ASSERT((Env->OwnerValPtr ));
    PointStruct *PS = (PointStruct * )(Env->OwnerValPtr);
    ASSERT((PS));
    XXX_POINT* point = &(PS->Point);

    PointStruct *PS2 = (PointStruct * )(Env->ArgValsPtrs[0]);
    ASSERT((PS2));
    XXX_POINT* point2 = &(PS2->Point);
    
    ((XxxCoreADTClass::IntValue *)ReturnValue)->Value = (point_equals(point, point2));
    
    return XXX_OK;    
}

