/*#include "xxx_thread.h"
#include "values.h"
#include "engines.h"
*/
#include <stdio.h>
#include "error.h"
extern int dump(char *);

XxxErrCode XxxErrInfo::Note(XxxErrCond Cond, const char* Message, 
							int Engine, const char* FileName, int LineNumber)
{
	XxxErrInfo* NewInfo = new XxxErrInfo(Cond, Message, Engine,
		FileName, LineNumber);
	NewInfo->Next = NULL;
	
	XxxErrInfo* Tmp = this;
	while (Tmp->Next) Tmp = Tmp->Next;
	Tmp->Next = NewInfo;
	return XXX_OK;
}

XxxErrCode XxxErrInfo::Get(XxxErrInfo* Error)
{
	Error = this;
	return XXX_OK;
}

void XxxErrInfo::Clear()
{
	while (Next) {
		XxxErrInfo* tmp = Next;
		Next = Next->Next;
		delete tmp;
	}
}

void XxxErrInfo::Size(int& length) 
{
	XxxErrInfo* Tmp = Next;
	length = 10;
	while (Tmp) {
		length += strlen(Tmp->Message)+strlen(FileName)+30;
		Tmp = Tmp->Next;
	}
}


void XxxErrInfo::Print(char *message,
					   const char *title) const
{
	XxxErrInfo* Tmp = Next;
	sprintf(message,"Error:%s\n",title);
	while (Tmp) {
		Tmp->printThis(message);
		Tmp = Tmp->Next;
	}
}

void XxxErrInfo::printThis(char * message) const
{
	char tmp[20];
	strcpy(tmp,":");
	tmp[1] = 0;
	strcat(message,tmp);
	strcat(message,Message);
	sprintf(tmp,"\n:File");
	strcat(message,tmp);
	strcat(message,FileName);
	sprintf(tmp,"\nLine %d\n",LineNumber);
	strcat(message,tmp);
}

