// Dummy wrapper for prd-error.h
// Can't use error.h because VC++ ignores it in
// computing dependencies
#include <strstrea.h>
#include <string.h>

const int XXX_ERRMESSAGE_MAX = 200; 
enum XxxErrCode { 
  XXX_OK = 0, 
  XXX_NOT_OK = 1, 
  XXX_QUIT = 2, // doesnt get used yet
  XXX_INTR = 3}; // doesnt get used yet

typedef char XxxBool;
const XxxBool XXX_TRUE  = 1;
const XxxBool XXX_FALSE = 0;
const XxxBool XXX_DONTCARE = -1;

typedef char XxxErrCond;
const XxxErrCond XXX_BADJVM = 28;
const XxxErrCond XXX_BADDEV = 27;
const XxxErrCond XXX_BADHANDLE = 26;
const XxxErrCond XXX_BADSCAN = 25;
const XxxErrCond XXX_BADCURSOR = 24;
const XxxErrCond XXX_BADADT = 23;
const XxxErrCond XXX_BADTYPE = 22;
const XxxErrCond XXX_BADRECORD = 21;
const XxxErrCond XXX_BADFUNC = 20;
const XxxErrCond XXX_BADVALUE = 19;
const XxxErrCond XXX_BADEXPR = 18;
const XxxErrCond XXX_BADQUERY = 17;
const XxxErrCond XXX_BADCMD = 16;
const XxxErrCond XXX_BADEXEC = 15;
const XxxErrCond XXX_BADOPT = 14;
const XxxErrCond XXX_BADPARSE = 13;
const XxxErrCond XXX_SHOREERR = 12;
const XxxErrCond XXX_BADENG = 11;
const XxxErrCond XXX_BADSERVER = 10;
const XxxErrCond XXX_SETDUPL = 9;
const XxxErrCond XXX_OVFLO = 8;
const XxxErrCond XXX_BADREG = 7;
const XxxErrCond XXX_BADSOCK = 6;
const XxxErrCond XXX_BADPIPE = 5 ;
const XxxErrCond XXX_BADFILE = 4;
const XxxErrCond XXX_BADFLAG = 3;
const XxxErrCond XXX_INTERNAL = 2;
const XxxErrCond XXX_INCOMPL = 1;
const XxxErrCond XXX_ALLWELL = 0;

class XxxErrInfo {
 private:
  void printThis(char *) const;
 public:
  int SourceEngine;
  XxxErrCond Condition;
  char Message[XXX_ERRMESSAGE_MAX];
  char FileName[XXX_ERRMESSAGE_MAX];
  int LineNumber;
  XxxErrInfo* Next;

  XxxErrInfo(XxxErrCond Condn, const char *Msg, int Engine,
	     const char *FileNm, int LnNum){
    Condition = Condn;
    strcpy(Message, Msg);
    SourceEngine = Engine;
    strcpy(FileName, FileNm);
    LineNumber = LnNum;
    Next = NULL;
   }
  XxxErrInfo() { Condition = XXX_ALLWELL; Next = NULL;}
  XxxErrCode Get(XxxErrInfo* Error);
  XxxErrCode Note(XxxErrCond Cond, const char *Message, int Engine,
		  const char* FileName, int LineNumber);
  void XxxErrInfo::Size(int& length); 
  void Clear();
  void Print(char *, const char* Msg) const;
  XxxBool IsError() const { return (Next?XXX_TRUE:XXX_FALSE);}
 };
