#ifndef HANDLE_H
#define HANDLE_H

#include <iostream.h>
#include <strstream.h>
#include <fstream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
//#include "time2.h"
#include <sys/resource.h>
#include "predconnect.h"

#ifndef RECORD_H
#include "record2.h"
#endif
#include "sql.h"
#include "sqlext.h"
#include "error.h"
#include <windows.h>

// change, add a handle for each object, where the handle is allocated globally.
// This is tricky because DLL need to access global stuffs.
class EnvHandle {
public:

	int count;
	unsigned long version;
	EnvHandle(){count = 0;};
	~EnvHandle(){};
	SQLRETURN Free(){ 
		if (count > 0)
			return SQL_ERROR;
		else {
			delete this;
			return SQL_SUCCESS;
		}
	};
};

typedef struct EnvTag {
	EnvHandle * env;
} Env;



class ConnectionHandle  {
public:
	PredConnection * predConnection;
	HANDLE  hMutex; // Mutex for this connection handle, only one statement handle may use
	char version[20];
	char dataSourceName[20];
	char dataBaseName[20];
	short errorGot; // a flag indicate whether there is no error

	XxxSocketStarter * DummyStarter;
	EnvHandle * Env;
	int count; // Number of associated statement handle

	SQL_API ConnectionHandle();
	~ConnectionHandle();
	SQLRETURN FreeConnectionHandle();
	int	SQL_API Connect(SQLCHAR *		ServerName,
	SQLSMALLINT	NameLength1,
	SQLCHAR *		UserName,
	SQLSMALLINT	NameLength2,
	SQLCHAR *		Authentication,
	SQLSMALLINT	NameLength3);
	int VarSize(int typeId);
	void PrintADTs();
	
};

typedef struct ConnTag {
	ConnectionHandle * conn;
} Conn;


class Columns {
public:
	SQLUSMALLINT	columnNumber;
	SQLSMALLINT		targetType;
	SQLPOINTER		targetValuePtr;
	SQLINTEGER		bufferLength;
	SQLINTEGER *		strLen_or_IndPtr;
	
	Columns * next;

	Columns();
	Columns(SQLUSMALLINT	ColumnNumber,SQLSMALLINT	TargetType,SQLPOINTER	TargetValuePtr,SQLINTEGER	BufferLength,SQLINTEGER *	StrLen_or_IndPtr);
	~Columns();
};

extern SQLRETURN SQL_API AllocDesc(HSTMT InputHandle,SQLHDESC * App_Row_Desc, SQLHDESC * App_Param_Desc,
							SQLHDESC * Imp_Row_Desc, SQLHDESC * Imp_Param_Desc);
/** Cheating, only contain a pointer to the statement handler
 */
class StatementHandle;

class DescHandle {
public:
	StatementHandle * stmt;
	DescHandle(StatementHandle *st){stmt = st;}
	~DescHandle(){}
};

typedef struct DescTag {
	DescHandle * desc;
}Desc;

class StatementHandle {


public:
	Columns * columns;
	ConnectionHandle * 		connectionHandle;
	Desc * App_Row_Desc; // Four implicit description handlers
	Desc * App_Param_Desc;
	Desc * Imp_Row_Desc;
	Desc * Imp_Param_Desc;
	XxxErrInfo * errorInfo;
	char errorMessage[XXX_ERRMESSAGE_MAX];
	int preProcessed;
	char *buf;// buffer for command
	char *result; // buffer for result
	char *ptr;
	short special; // 1 if executing special commands returning lines of data ( each only has
	// one field of string. 2 if executing no result commands such as create, drop,load,...
	short done; // whether need to read result
	short errorGot; // a flag indicate whether there is no error

	RecordSchema * schema;
	Record * record; // temporary record for one row of data

	SQLRETURN AddColumns(SQLUSMALLINT	ColumnNumber,SQLSMALLINT	TargetType,SQLPOINTER	TargetValuePtr,SQLINTEGER	BufferLength,SQLINTEGER *	StrLen_or_IndPtr);
	StatementHandle(ConnectionHandle * 	ptr);
	~StatementHandle();
	SQLRETURN SendRequest(SQLCHAR *		StatementText);
	SQLRETURN SQLBindCol(SQLUSMALLINT	ColumnNumber,SQLSMALLINT	TargetType,SQLPOINTER	TargetValuePtr,SQLINTEGER	BufferLength,SQLINTEGER *	StrLen_or_IndPtr);
	SQLRETURN GetSchema();
	SQLRETURN GetRecord();
	SQLRETURN GetFields();
	SQLRETURN SQLFetch();
	SQLRETURN ReadErrors();
	int VarSize(int type);
	char *TypeName(int type);
	void Free();
};

typedef struct StmtTag {
	StatementHandle * stmt;
} Stmt;



#endif