#include <ctype.h>
#include <iostream.h>
#include <string.h>
#include "socket.h"

#ifdef XXX_WIN32
#include <strstrea.h>
#else
#include <strstream.h>
#endif





/**
 PredConnection class encapsulates all functionality necessary for dialog
 with a PREDATOR server
 **/
class PredConnection {
	#define RESULT_BUFFER_MAX 5000
public: 
  static const char *initString;

  int portNumber;
  int portNumber2;
  char* hostName;
  char* userName;
  char* password;
  XxxSocketConnection* socket;
  XxxSocketConnection * socket2;
  bool binaryMode;
  bool getSchemas;

  bool valid;
  int	numADTs;
  char** ADTs; //ATD names

  //// nullify all pointers
  void init() {
    valid = false;
    hostName = NULL;
    userName = NULL;
    password = NULL;
    socket = NULL;
    binaryMode = false;
    getSchemas = true;
   }
  //// reclaim all allocated pointers
  void reclaim() {
    if (hostName) delete [] hostName;
    if (userName) delete [] userName;
    if (password) delete [] password;
    if (socket) delete socket;
   }
  
  //// returns 0 if protocol setup fails, else returns 1
  int setupProtocol();
  //// returns true if no more data is expected from the server
  bool requestTerminated(const char* RecvdData, int BytesRead) const;
  //// returns 0 if protocol temination fails, else returns 1
  int terminateProtocol();
 public:
  PredConnection(const char* HostName, int PortNumber,
		 const char* UserName, const char* Password, bool& success,
		 bool Binary = false, bool GetSchemas = false);
  ~PredConnection();
  bool IsValid() const { return valid;}
  //// return 0 if error occurs, else returns 1
  int SendRequest(const char* Buf);



 };


