#ifndef RECORD_H
#define RECORD_H

#include <stdlib.h>
#include <stdio.h>
/**
  * Represents a single named and typed field.
  * @see XxxRecordSchema
  */
class Attribute {
 public:
  /// name of the attribute
  char         *  Name;
  /// type of attribute
  int   Type;       
  /// further type info if available
  char  * TypeCatInfo;

  // Couple of attributes used in type checking only.
  // TODO: Will eventually be moved out of here.
  /// which input relation does this come from

};

/**
  * Defines the schema of a record.
  * @see XxxAttribute, XxxRecord
  */
class RecordSchema {
 public:
  int                          RecArity;
  int                          RecordSize;
  int                          *RecordOffsets;
  int                          ExtraAreaOffset;
  Attribute*                Attrs;   // list of typed attributes
  RecordSchema(){RecArity = 0; }
  ~RecordSchema(){ delete RecordOffsets; delete Attrs;}
};

/**
 * The definition of a record in memory.
 */
class Record {
public:
	unsigned long size;



  char *  DataArea;

  Record() {
	size = 0;
    DataArea = NULL;
   }
  Record(unsigned int Size) {
    size = Size;
    DataArea = new char[size];
   }
  Record(unsigned int Size, char *Data) {
    size = Size;
    DataArea = Data;
  }
 
  ~Record() {
     delete [] DataArea;
   }
};

#endif