#ifndef REL_RELENG_H
#define REL_RELENG_H

#include "engines.h"
#include "gensrc.h"
XXX_EXTERN_CLASS_DECL(RelViewClass);
XXX_EXTERN_CLASS_DECL(RelHandle);

XXX_EXTERN_CLASS_DECL(RelOptEngine);
XXX_EXTERN_CLASS_DECL(RelExecEngine);
XXX_EXTERN_CLASS_DECL(RelCommandEngine);
XXX_EXTERN_CLASS_DECL(RelQueryEngine);
XXX_EXTERN_CLASS_DECL(RelDataEngine);
XXX_EXTERN_CLASS_DECL(RelSpecParameters);

// global initialized in XxxRelationEngine constructor
extern int RelationEngineId;
class XxxRelationEngine : public XxxDBEngine {
  static const int NumErrorConds;
  static const char *const ErrorTable[];

  XxxErrCode establishRegistry();
  // class used for parsing meta-info
  struct RelEngCatParse {
    XxxGenDataSrc::AttrTypeList* Attrs;
    XxxGenDataSrc::KeyList* Keys;
    int* SrcType;
    char* DevName;
    char* ImplType;
   };
 public:
  struct parseStruct {
    istream* IStr;
    void *LexerPtr;
    void *InArg;
    void *OutArg;
    parseStruct(istream* InStr, void* InValue) {
      LexerPtr = NULL;
      OutArg = NULL;
      InArg = InValue;
      IStr = InStr;
     }
   };
  // parse input stream
  //Bjarke, sep. 17 2001: added static qualifier
  int sqlparse(parseStruct& PDS) const;  
  // execute a query
  XxxErrCode execQuery(RelViewClass* QueryView,
		       RelSpecParameters& Params) const;

 public:
  RelOptEngine* Optimizer;    // query optimizer
  RelExecEngine* ExecEng;     // execution engine
  RelCommandEngine* CommandEng; // utility command execution
  RelQueryEngine* QueryEng;   // plan storage
  RelDataEngine* DataEng;     // data server

  XxxRelationEngine(const int Id);
  virtual ~XxxRelationEngine();

  virtual XxxErrCode ExprParse(char* ExprString,
			       const XxxArgEnv* ArgEnv,
			       XxxBasicType& ReturnType,
			       XxxGenericParse*& ParseStructure);

  virtual XxxErrCode ExprOptimize(XxxGenericParse* ParseStructure,
				  XxxGenericPlan*& PlanStructure);

  virtual XxxErrCode ExprEvaluate(XxxGenericPlan* PlanStructure,
				  const XxxValueEnv* ArgEnv,
				  XxxADTValue *ReturnValue);

  virtual const char* ErrorString(XxxErrCond Condition) const;

  // added to process nested catalog definitions
  // weitsang
  virtual XxxErrCode ParseValueExpression (const char *ExprString, 
  	XxxValueExpression *&Expr);

  virtual XxxErrCode ParseBoolExpression (const char *ExprString, 
    XxxBooleanExpression *&Expr);

  // added to process nested catalog definitions
  virtual XxxErrCode ParseMetaInfo(const char* MetaInfoString,
				   XxxGenDataSrc::AttrTypeList*& Attrs,
				   XxxGenDataSrc::KeyList*& Keys,
				   int* SrcType,
				   char*& DeviceName,
				   char*& RelImplType);

  virtual XxxErrCode CreateEnv( XxxEngineEnv* &Env ) const;
  virtual XxxErrCode DeleteEnv( XxxEngineEnv* Env ) const;

  virtual void PrintStats(ostream& OStr) const;
 };

#endif
