#ifndef REL_ERROR_H
#define REL_ERROR_H
#include "error.h"
//
// local error codes for relation ADT
//
extern int RelationEngineId;
#define REL_NOTE_ERROR(X, Msg) (XXX_ERROR(__FILE__, __LINE__, X, Msg, RelationEngineId))

#define REL_CALL_FN(X, Y, Z) \
      if (X != XXX_OK) { \
        REL_NOTE_ERROR(Y, Z); \
        return XXX_NOT_OK; \
      } 

#define REL_CALL_RCFN(X, RC, Y, Z) \
      if (X != XXX_OK) { \
        REL_NOTE_ERROR(Y, Z); \
        RC = XXX_NOT_OK; \
        return; \
      } 

const XxxErrCond REL_MSSNGREL = 0;
const XxxErrCond REL_BADDEV = 1;
const XxxErrCond REL_DUPVIEW = 2;
const XxxErrCond REL_BADQUERY = 3;
const XxxErrCond REL_BADOPT = 4;
const XxxErrCond REL_BADPLAN = 5;
const XxxErrCond REL_BADEXEC = 6;
const XxxErrCond REL_BADOP = 7;
const XxxErrCond REL_MSSNGCAT = 8;
const XxxErrCond REL_BADCAT = 9;
const XxxErrCond REL_BADTXTFILE = 10;
const XxxErrCond REL_BADSHOREREL = 11;
const XxxErrCond REL_BADTABLE = 12;
const XxxErrCond REL_BADINDEX = 13;
const XxxErrCond REL_BADSRC = 14;
const XxxErrCond REL_BADCURSOR = 15;
const XxxErrCond REL_NOVIEW = 16;

#endif  /* REL_ERROR_H */
