%{
#include "sql.tab.h"
#define YY_DECL int yyFlexLexer::yylex(void *lvalp)
%}

%start NAMES
%start COMMENT

%%

<NAMES>[a-z_]([a-z0-9_@]*[a-z0-9_@])? {
                           ((YYSTYPE *)lvalp)->string = 
                               new char[strlen(yytext)+1];
                           strcpy(((YYSTYPE *)lvalp)->string,yytext);
                           BEGIN INITIAL;
                           return XXX_TOK_STRING;
			}

<NAMES>"*"            { BEGIN INITIAL;
                        return XXX_TOK_STAR; }

<NAMES>"#"            { BEGIN INITIAL;
                        return XXX_TOK_POUND; }


<INITIAL>"CLUSTERED"    { return XXX_TOK_CLUSTERED; }
<INITIAL>"DATABASE"     { return XXX_TOK_DATABASE; }
<INITIAL>"DISTINCT"     { return XXX_TOK_DISTINCT; }
<INITIAL>"IMPLTYPE"     { return XXX_TOK_IMPLTYPE; }
<INITIAL>"RUNSTATS"     { return XXX_TOK_RUNSTATS; }
<INITIAL>"DUMPREL"      { return XXX_TOK_RUNSTATS; }
<INITIAL>"BETWEEN"      { return XXX_TOK_BETWEEN; }
<INITIAL>"SELECT"	{ return XXX_TOK_SELECT; }
<INITIAL>"UNIQUE"       { return XXX_TOK_UNIQUE; }
<INITIAL>"HAVING"	{ return XXX_TOK_HAVING; }
<INITIAL>"CREATE"       { return XXX_TOK_CREATE; }
<INITIAL>"DELETE"	{ return XXX_TOK_DELETE; }
<INITIAL>"DEVICE"	{ return XXX_TOK_DEVICE; }
<INITIAL>"INSERT"	{ return XXX_TOK_INSERT; }
<INITIAL>"UPDATE"	{ return XXX_TOK_UPDATE; }
<INITIAL>"SOURCE"	{ return XXX_TOK_SOURCE; }
<INITIAL>"VALUES"	{ return XXX_TOK_VALUES; }
<INITIAL>"EXISTS"	{ return XXX_TOK_EXISTS; }
<INITIAL>"CLOSE"        { return XXX_TOK_CLOSE; }
<INITIAL>"GROUP"	{ return XXX_TOK_GROUP; }
<INITIAL>"INDEX"        { return XXX_TOK_INDEX; }
<INITIAL>"ORDER"	{ return XXX_TOK_ORDER; }
<INITIAL>"TABLE"        { return XXX_TOK_TABLE; }
<INITIAL>"WHERE"	{ return XXX_TOK_WHERE; }
<INITIAL>"ALIAS"	{ return XXX_TOK_ALIAS; }
<INITIAL>"DESC"         { return XXX_TOK_DESC; }
<INITIAL>"DROP"         { return XXX_TOK_DROP; }
<INITIAL>"FROM" 	{ return XXX_TOK_FROM; }
<INITIAL>"WINDOW" 	{ return XXX_TOK_WINDOW; }
<INITIAL>"KEYRJOIN"   { return XXX_TOK_KRJ; }
<INITIAL>"STOP"       { return XXX_TOK_STOP; }
<INITIAL>"AFTER"      { return XXX_TOK_AFTER; }
<INITIAL>"INTO"         { return XXX_TOK_INTO; }
<INITIAL>"LOAD"         { return XXX_TOK_LOAD; }
<INITIAL>"NULL"         { return XXX_TOK_NULL; }
<INITIAL>"OPEN"         { return XXX_TOK_OPEN; }
<INITIAL>"VIEW" 	{ return XXX_TOK_VIEW; }
<INITIAL>"WITH"  	{ return XXX_TOK_WITH; }
<INITIAL>"TYPE"		{ return XXX_TOK_TYPE; }
<INITIAL>"ENUM"		{ return XXX_TOK_ENUM; }
<INITIAL>"ASC"          { return XXX_TOK_ASC; }
<INITIAL>"KEY"          { return XXX_TOK_KEY; }
<INITIAL>"ALL"          { return XXX_TOK_ALL; }
<INITIAL>"ANY"	        { return XXX_TOK_ANY; }
<INITIAL>"SOME"	        { return XXX_TOK_ANY; }
<INITIAL>"SET"	        { return XXX_TOK_SET; }
<INITIAL>"AS"           { return XXX_TOK_AS; }
<INITIAL>"BY"           { return XXX_TOK_BY; }
<INITIAL>"ON"           { return XXX_TOK_ON; }
<INITIAL>"IN"           { return XXX_TOK_IN; }
<INITIAL>"IS"           { return XXX_TOK_IS; }
<INITIAL>"CASE"         { return XXX_TOK_CASE; }
<INITIAL>"WHEN"         { return XXX_TOK_WHEN; }
<INITIAL>"THEN"         { return XXX_TOK_THEN; }
<INITIAL>"ELSE"         { return XXX_TOK_ELSE; }
<INITIAL>"END"          { return XXX_TOK_END; }
<INITIAL>"COUNT"        { return XXX_TOK_COUNT; }

<INITIAL>"CAST"         { return XXX_TOK_CAST; }
<INITIAL>"CHAR"         { return XXX_TOK_CHAR; }
<INITIAL>"CHARACTER"    { return XXX_TOK_CHAR; }
<INITIAL>"VARYING"      { return XXX_TOK_VARYING; }
<INITIAL>"VARCHAR"      { return XXX_TOK_VARCHAR; }
<INITIAL>"DATE"         { return XXX_TOK_DATE; }
<INITIAL>"INTERVAL"     { return XXX_TOK_INTERVAL; }
<INITIAL>"YEAR"         { return XXX_TOK_YEAR; }
<INITIAL>"MONTH"        { return XXX_TOK_MONTH; }
<INITIAL>"DAY"          { return XXX_TOK_DAY; }
<INITIAL>"HOUR"         { return XXX_TOK_HOUR; }
<INITIAL>"MINUTE"       { return XXX_TOK_MINUTE; }
<INITIAL>"SECOND"       { return XXX_TOK_SECOND; }

<INITIAL>"ABSOLUTE"	{ return XXX_TOK_ABSOLUTE; }
<INITIAL>"UPPER"	{ return XXX_TOK_UPPER; }
<INITIAL>"LOWER"	{ return XXX_TOK_LOWER; }
<INITIAL>"TRIM"         { return XXX_TOK_TRIM; }
<INITIAL>"LEADING"      { return XXX_TOK_LEADING; }
<INITIAL>"TRAILING"     { return XXX_TOK_TRAILING; }
<INITIAL>"BOTH"         { return XXX_TOK_BOTH; }
<INITIAL>"||"           { return XXX_TOK_CONCAT; }

<INITIAL>";"            { return XXX_TOK_SEMICOLON; }
<INITIAL>","            { return XXX_TOK_COMMA; }
<INITIAL>"("            { return XXX_TOK_L_PAREN; }
<INITIAL>")"            { return XXX_TOK_R_PAREN; }
<INITIAL>"["            { return XXX_TOK_L_BRACE; }
<INITIAL>"]"            { return XXX_TOK_R_BRACE; }
<INITIAL>"{"            { return XXX_TOK_L_CBRACE; }
<INITIAL>"}"            { return XXX_TOK_R_CBRACE; }
<INITIAL>"$"            { return XXX_TOK_DOLLAR; }

<INITIAL>"*"            { return XXX_TOK_STAR; }
<INITIAL>"-"            { return XXX_TOK_MINUS; }
<INITIAL>"+"            { return XXX_TOK_PLUS; }
<INITIAL>"/"            { return XXX_TOK_DIV; }
<INITIAL>">="           { return XXX_TOK_GEQ; }
<INITIAL>"<="           { return XXX_TOK_LEQ; }
<INITIAL>"<>"           { return XXX_TOK_NEQ; }
<INITIAL>"!="           { return XXX_TOK_NEQ; }
<INITIAL>">"            { return XXX_TOK_GT; }
<INITIAL>"<"            { return XXX_TOK_LT; }
<INITIAL>"=="           { return XXX_TOK_EQ; }
<INITIAL>"="            { return XXX_TOK_EQ; }
<INITIAL>"LIKE"         { return XXX_TOK_LIKE; }
<INITIAL>"OR"           { return XXX_TOK_OR; }
<INITIAL>"AND"          { return XXX_TOK_AND; }
<INITIAL>"&&"           { return XXX_TOK_AND; }
<INITIAL>"NOT"          { return XXX_TOK_NOT; }
<INITIAL>"!"            { return XXX_TOK_NOT; }

<INITIAL>[+-]?[0-9]+	{
                           ((YYSTYPE *)lvalp)->intNum = atoi(yytext);
                           return XXX_TOK_INTEGER;
			}
<INITIAL>[+-]?[0-9]+"E"[-+]?[0-9]+		|
<INITIAL>[+-]?[0-9]+"."[0-9]+			|
<INITIAL>[+-]?[0-9]+"."[0-9]+"E"[-+]?[0-9]+	{
                           ((YYSTYPE *)lvalp)->doubleNum = atof(yytext);
                           return XXX_TOK_DOUBLE;
                        }
<INITIAL>[a-z_]([a-z0-9_@]*[a-z0-9_@])? {
                           ((YYSTYPE *)lvalp)->string = 
                               new char[strlen(yytext)+1];
                           strcpy(((YYSTYPE *)lvalp)->string,yytext);
                           return XXX_TOK_STRING;
			}
<INITIAL>\"[^\"]*\"     |
<INITIAL>\^[^\^]*\^     |
<INITIAL>\'[^\']*\'     {
                           ((YYSTYPE *)lvalp)->string = 
                               new char[strlen(yytext)];
                           strcpy(((YYSTYPE *)lvalp)->string, yytext+1);
                           ((YYSTYPE *)lvalp)->string[strlen(yytext+1)-1] = 0;
                           return XXX_TOK_QUOTESTRING;
			}
<INITIAL>"." 		{ BEGIN NAMES;
                          return XXX_TOK_DOT;
                          }
<INITIAL>"#"            { BEGIN COMMENT;}
<INITIAL>"%"            { BEGIN COMMENT;}

<COMMENT>[^\n]          ;

<COMMENT>"\n"           { BEGIN INITIAL;} /* comment terminated by newline */

[ \t\n\r]  		;	 /* space/tab/newline => ignore */

<<EOF>>                {
                         yy_delete_buffer( YY_CURRENT_BUFFER );
                         yyterminate();
                       }


%%
int yywrap()
{
  return 1;
}



