#ifndef XXX_GREEDYSPJ_H
#define XXX_GREEDYSPJ_H

#include "seminaivespj.h"

/**
 * Varies from the naive optimizer in that it uses a greedy algorithm
 * based on intermediate tables cardinality to determine the join order.
 */
class RelSPJGreedyOpt : public RelSPJSemiNaiveOpt {
 protected:
  XxxErrCode determineGreedyJoinOrder(int NumChildren, int *JoinOrder, 
				      RelOptEngine::JoinMethod *JoinMethods,
				      RelOptEngine::Cost&Cost, const int First) const;
  
  //// Estimate the properties and cost of joining with CurrentRel
  XxxErrCode includeNewRel(int CurrentRel, // index of rel to join in
			   int CurrentRelPos, // position in join order
			   const RelOptEngine::Cost& InputCost,
			   const RelOptEngine::LogProperties& InputLProps,
			   const RelOptEngine::PhysProperties& InputPProps,
			   RelOptEngine::Cost& OutputCost,
			   RelOptEngine::LogProperties& OutputLProps,
			   RelOptEngine::PhysProperties& OutputPProps,
			   RelOptEngine::JoinMethod& JM) const;

  virtual XxxErrCode 
  determineJoinStrategy(int NumChildren, int* JoinOrder,
			RelOptEngine::JoinMethod* JoinMethods) const;  
 public:
  RelSPJGreedyOpt(XxxErrCode& RC,
		  XxxValueExprList* TargetList,
		  XxxBooleanExpression* Condition,
		  XxxBool Unique,
		  RelSPJBlockPlan* SPJPlan,
		  RelOptEngine::OptQueryEnv* QEnv) :
  RelSPJSemiNaiveOpt(RC, TargetList, Condition, Unique, SPJPlan, QEnv) 
  {  alwaysTrySM = XXX_FALSE; }
  virtual ~RelSPJGreedyOpt() {}

 };


#endif
