#include <iostream.h>

#include "relerror.h"
#include "relquery.h"
#include "dynspj.h"
#include "relplanop.h"

// move this somewhere else: TODO:L_OPT
static double PRUNINGTOLERANCE = 0.0;

//
// Methods of RelSPJCostBasedOpt::LogicalPlan
//
XxxErrCode RelSPJCostBasedOpt::
LogicalPlan::AddPlan(const XxxDBEnv& Env,
		     PhysicalPlan* NewPlan,
		     int& NumPlansAdded,
		     int& NumPlansPruned)
{
 // step thru existing plans
 RelOptEngine::PlanObjectList *CurrentList;
 CurrentList = &PPlanList;

 XxxBool AddPlan = XXX_TRUE; // should this plan be added
 NumPlansAdded = NumPlansPruned = 0;

 while (CurrentList->Next) {   
   PhysicalPlan* CurrentPlan = 
     (PhysicalPlan *)(CurrentList->Next->Plan);

   if (NewPlan->Usage.FullCost() >= 
       CurrentPlan->Usage.FullCost() + PRUNINGTOLERANCE) {
     // check physical props to see if any interesting orders exist
     if (0) { // TODO:L_OPT
      }
     else {
       AddPlan = XXX_FALSE;
       NumPlansPruned++;
       break;
      }
    } // if the new plan is more expensive
   else if (CurrentPlan->Usage.FullCost() >= 
	    NewPlan->Usage.FullCost() + PRUNINGTOLERANCE) {
     // check physical props to see if any interesting orders exist
     if (0) { // TODO:L_OPT
      }
     else {
       // delete CurrentPlan from List
       NumPlansPruned++;
       RelOptEngine::PlanObjectList *TmpNext = 
	 CurrentList->Next;
       CurrentList->Next = CurrentList->Next->Next;
       delete CurrentPlan;
       delete TmpNext;
      }
    } // if the new plan is significantly cheaper

   // CurrentList = CurrentList->Next;
  } // loop over all physical plans

 if (AddPlan) {
   // if it reaches here, the new plan must be added
   PPlanList.Add(NewPlan); 
   NumPlansAdded++;
  }
 return XXX_OK;
}
// scan over plans options
XxxErrCode RelSPJCostBasedOpt::
LogicalPlan::OpenPlanScan(XxxSetCursor& Csr) const
{
 RelOptEngine::PlanObjectList *CurrentList;
 Csr.NumberRead = 0;
 Csr.AtEnd = XXX_FALSE;

 CurrentList = PPlanList.Next;
 Csr.State = new planScanHandle(CurrentList);

 return XXX_OK;
}
XxxErrCode RelSPJCostBasedOpt::
LogicalPlan::GetNextPlan(XxxSetCursor& Csr,
			 PhysicalPlan*& Plan) const
{
  struct planScanHandle* ScanHandle = 
    (struct planScanHandle *)(Csr.State);

 if (!ScanHandle || !ScanHandle->CurrPPlanList) {
   Csr.AtEnd = XXX_TRUE;
   return XXX_OK;
  }
 Plan = (PhysicalPlan*)(ScanHandle->CurrPPlanList->Plan);

 ScanHandle->CurrPPlanList = ScanHandle->CurrPPlanList->Next;
 Csr.NumberRead++;
 return XXX_OK;
}
XxxErrCode RelSPJCostBasedOpt::
LogicalPlan::ClosePlanScan(XxxSetCursor& Csr) const
{
  struct planScanHandle* ScanHandle = 
    (struct planScanHandle *)(Csr.State);
  if (ScanHandle) delete ScanHandle;
 return XXX_OK;
}

void RelSPJCostBasedOpt::
LogicalPlan::Print(ostream& OStr) const
{
 // TODO:L_OPT
 return;
}

RelSPJCostBasedOpt::
LogicalPlan::LogicalPlan(const RelOptEngine::LogProperties& LProps)
: LogProps(LProps)
{
}

RelSPJCostBasedOpt::
LogicalPlan::~LogicalPlan()
{
}
