//
// Note: this class is nested within RelSPJCostBasedOpt (see costspjopt.h)
// Do not include this header file directly.
//
#ifndef XXX_LOGPLAN_H
#define XXX_LOGPLAN_H

  /**
   * @name  LogicalPlan
   *
   * Several physical plans representing the same logical properties
   */
  class LogicalPlan { public:
    // handle for scan over physical plans in this logical plan
    struct planScanHandle : public XxxSetCursor::CursorState {
      RelOptEngine::PlanObjectList* CurrPPlanList;
      planScanHandle(RelOptEngine::PlanObjectList* List = NULL) 
	{ CurrPPlanList = List;}
     };

    RelOptEngine::LogProperties LogProps;

    // list of Physical Plans
    class RelOptEngine::PlanObjectList PPlanList;
    
    XxxErrCode AddPlan(const XxxDBEnv& Env,
		       PhysicalPlan* NewPlan,
		       int& NumPlansAdded,
		       int& NumPlansPruned);
    // scan over plans options
    XxxErrCode OpenPlanScan(XxxSetCursor& Csr) const;
    XxxErrCode GetNextPlan(XxxSetCursor& Csr,
			   PhysicalPlan*& Plan) const;
    XxxErrCode ClosePlanScan(XxxSetCursor& Csr) const;

    LogicalPlan(const RelOptEngine::LogProperties& LProps);
    ~LogicalPlan();
    void Print(ostream& OStr) const;
   };

#endif
