#ifndef XXX_PLANBASE_H
#define XXX_PLANBASE_H

#include "relopt.h"

/**
 * This models plans for base relations.
 * Each base relation may have several possible
 * actual plans, each differentiated by physical
 * properties.
 */
class RelBaseBlockPlan : public RelBlockPlan {
 public:
  /**
   * simple file scan, with the decision about 
   * using an index left to the run time
   */
  class RelAccessPlan : public RelOptEngine::PlanObject { 
   public:
    RelAccessPlan(int PlanIdent,
		  unsigned char BlockIdent)
      :RelOptEngine::PlanObject(PlanIdent, BlockIdent) {
       }
    virtual XxxErrCode GeneratePlanOp(const char* RelName,
				      RelCatalogInfo* CatInfo,
				      RelPlanOp*& PlanOp) const;
    virtual void Print(ostream& OStr) const;
   };

  char RelName[REL_RELNAME_MAX];

  RelBaseBlockPlan(XxxErrCode& RC,
		   unsigned char BlockIdent,
		   const char* Name,
		   RelCatalogInfo* CatInfo,
		   RelOptEngine::OptQueryEnv* Env);
  virtual ~RelBaseBlockPlan();
  virtual void Print(ostream& OStr) const;
  virtual XxxErrCode GeneratePlanOp(int PlanId,
				    RelPlanOp*& PlanOp) const;
  // This method replaces the dependencies of all correlation
  // variables (i.e XxxUnknownVars) within this plan.
  virtual XxxErrCode RedirectDependencies(const XxxValueExprPlan::VarRemapping& Remap,
					  int CorrelationHt = 0);
 };

#endif
