#ifndef XXX_PLANGBY_H
#define XXX_PLANGBY_H

#include "relopt.h"
 
/**
 * Plan for GroupBy block
 */
class RelGrpByBlockPlan : public RelBlockPlan { 
public:
  /**
   * Plan for groupby block
   */
  class GbyPlan : public RelOptEngine::PlanObject { 
  public:
    int ChildPlanId; 
    
    GbyPlan(int PlanIdent,
	    unsigned char BlockIdent,
	    int ChildPlan,
	    XxxGenericPlan::PlanUsage& ChildUsage);
    virtual void Print(ostream& OStr) const;
  };
  
  XxxValExprPlanList *TargetExprPlanList;
  XxxValExprPlanList *AggrExprPlanList;
  XxxValExprPlanList *GroupExprPlanList;

  int SubPlanId; // id of subplan in lower query block

  virtual void Print(ostream& OStr) const;
  virtual XxxErrCode GeneratePlanOp(int PlanId,
				    RelPlanOp*& PlanOp) const;
  RelGrpByBlockPlan(XxxErrCode& RC,
		    unsigned char BlockIdent,
		    RelOperator*, RelBlockPlan* Child,
		    RelCatalogInfo* CatInfo,
		    RelOptEngine::OptQueryEnv* Env);
  virtual ~RelGrpByBlockPlan();

  // This method replaces the dependencies of all correlation
  // variables (i.e XxxUnknownVars) within this plan.
  virtual XxxErrCode RedirectDependencies(const XxxValueExprPlan::VarRemapping& Remap,
					  int CorrelationHt = 0);
 };


#endif
