/*
Ihab
seminaiive optimizer (pipelining) for KRJ logical operator
*/
#ifndef XXX_SEMINAIVEKRJ_H
#define XXX_SEMINAIVEKRJ_H

#include "naiveKRJ.h"

/**
 * Varies from Naive optimizer only in that it breaks
 * the pipelined join into a series of joins
 */
class RelKRJSemiNaiveOpt : public RelKRJNaiveOptimizer {
 public:
  RelKRJSemiNaiveOpt(XxxErrCode& RC,
		    XxxValueExprList* TargetList,
		    XxxBooleanExpression* Condition,
		    XxxValueExprList* Ordering,
		    XxxBool Unique,
		    RelKRJBlockPlan* KRJPlan,
		    RelOptEngine::OptQueryEnv* QEnv) :
    RelKRJNaiveOptimizer(RC, TargetList, Condition, Ordering, Unique, KRJPlan, QEnv)  { }
  virtual ~RelKRJSemiNaiveOpt() {}
  
  virtual XxxErrCode GeneratePlanOp(RelOptEngine::PlanObject* Plan,
				    RelPlanOp*& PlanOp) const;
 protected:
  XxxErrCode makeOutputInfo(int CurrentJoinPos,
			    int NumJoins,
			    XxxExprPlan::VarRemapping& Remap,
			    RelPlanOp** TmpPlanOps,
			    XxxValExprPlanList*& TmpPlanList,
			    RelCatalogInfo*& TmpCatInfo,
			    XxxBool& ReclaimCat) const;

  XxxErrCode checkKRJ(int NumChildren,
		    RelKRJOptimizer::PredPlanStruct& TmpPredPlan,
		    XxxExprPlan::VarRemapping& Remap,
		    RelOptEngine::JoinMethod& JoinMethod) const;
  //// Modify the Remap to reflect a new temporary planop.
  XxxErrCode changeRemap(XxxExprPlan::VarRemapping& Remap,
			 int NumChildren,
			 int SourceToChange,
			 int NewSourceValue,
			 int AttrIncrement,
			 int* InputArity) const;
 };

#endif // XXX_SEMINAIVEKRJ_H
