#ifndef XXX_SEMINAIVESPJ_H
#define XXX_SEMINAIVESPJ_H

#include "naivespj.h"

/**
 * Varies from Naive optimizer only in that it breaks
 * the pipelined join into a series of joins
 */
class RelSPJSemiNaiveOpt : public RelSPJNaiveOptimizer {
 protected:
  XxxBool alwaysTrySM; // should sort-merge join be chosen whenever possible
 public:
  RelSPJSemiNaiveOpt(XxxErrCode& RC,
		     XxxValueExprList* TargetList,
		     XxxBooleanExpression* Condition,
		     XxxBool Unique,
		     RelSPJBlockPlan* SPJPlan,
		     RelOptEngine::OptQueryEnv* QEnv) :
  RelSPJNaiveOptimizer(RC, TargetList, Condition, Unique, SPJPlan, QEnv) 
  { alwaysTrySM = XXX_TRUE; }
  virtual ~RelSPJSemiNaiveOpt() {}

  virtual XxxErrCode GeneratePlanOp(RelOptEngine::PlanObject* Plan,
				    RelPlanOp*& PlanOp) const;
 protected:
  XxxErrCode makeOutputInfo(int CurrentJoinPos,
			    int NumJoins,
			    XxxExprPlan::VarRemapping& Remap,
			    RelPlanOp** TmpPlanOps,
			    XxxValExprPlanList*& TmpPlanList,
			    RelCatalogInfo*& TmpCatInfo,
			    XxxBool& ReclaimCat) const;

  XxxErrCode checkSortMerge(int NumChildren,
			    RelSPJOptimizer::PredPlanStruct& TmpPredPlan,
			    XxxExprPlan::VarRemapping& Remap,
			    RelOptEngine::JoinMethod& JoinMethod) const;
  //// Modify the Remap to reflect a new temporary planop.
  XxxErrCode changeRemap(XxxExprPlan::VarRemapping& Remap,
			 int NumChildren,
			 int SourceToChange,
			 int NewSourceValue,
			 int AttrIncrement,
			 int* InputArity) const;
 };

#endif // XXX_SEMINAIVESPJ_H
