#ifndef XXX_RELIDX_MATCH_H
#define XXX_RELIDX_MATCH_H

#include "types.h" 

/**
 * Holds information about an index match
 */
class XxxMatchInfo {
 public:
  enum MatchInfoType {BOOL, REL};
  enum MatchInfoType Type;
  XxxBool Exact;
  XxxMatchInfo(enum MatchInfoType MType) { Type = MType; Exact = XXX_FALSE;}
  virtual ~XxxMatchInfo() {}
 };
/**
 * Holds information about an index that matches a boolean expression
 * (one with AND, OR or NOT). Currently used only for AND
 */
class XxxBoolMatchInfo : public XxxMatchInfo {
 public:
  int Arity;
  XxxMatchInfo** MatchInfoArray;
  XxxBoolMatchInfo(int arity);
  virtual ~XxxBoolMatchInfo();
  };
/**
 * Holds information about an index that matches a relational expression
 */
class XxxRelMatchInfo : public XxxMatchInfo {
 public:
  XxxBool LeftConstant;
  XxxRelMatchInfo() : XxxMatchInfo(REL) {}
  virtual ~XxxRelMatchInfo() {}
 };

#endif
