#ifndef REL_SHORERELIMPL_H
#define REL_SHORERELIMPL_H

//
// This is included from within shorerel.h.
// RelShoreImplInfo is a nested class within RelShoreDataSrc
//

/**
 * Implementation information for a shore relation
 */
class RelShoreImplInfo : public RelImplInfo { 
 public:
  /// Subclass of index impl information
  class ShoreIndexImplInfo : public RelImplInfo::IndexImplInfo { 
   public:
    // store the index id
    XxxShoreObjectId IndexId;
    ShoreIndexImplInfo(const XxxShoreObjectId & Id, 
		       const char *IndxStr,
		       const char *IndxName,
		       const XxxIndexType type,
		       XxxBool IsUnique,
		       XxxBool IsClustered,
		       const XxxRecordSchema *RecordSchema)
      :IndexImplInfo (IndxStr, IndxName, type, IsUnique, 
		      IsClustered, RecordSchema)
      {
	IndexId = Id;
       }
    //// copy constructor needed for Replicate
    ShoreIndexImplInfo(const ShoreIndexImplInfo& IInfo)
      : IndexImplInfo(IInfo) {
	IndexId = IInfo.IndexId;
       }
    virtual ~ShoreIndexImplInfo() {}
    virtual IndexImplInfo* Replicate() const {
      return new ShoreIndexImplInfo(*this);
     }
    virtual void Print(ostream& OStr) const;
  };

  RelShoreImplType ImplType;
  int DeviceIndex;
  RelShoreImplInfo() {}
  // copy constructor (needed for Replicate)
  RelShoreImplInfo(const RelShoreImplInfo& IInfo, XxxBool CopyIndexes) 
    : RelImplInfo(IInfo, CopyIndexes) {
      ImplType = IInfo.ImplType;
      DeviceIndex = IInfo.DeviceIndex;
     }
  virtual ~RelShoreImplInfo() {}
  virtual void Print(ostream& OStr) const;
  virtual RelImplInfo* Replicate(XxxBool CopyIndexes) const {
    return new RelShoreImplInfo(*this, CopyIndexes);
   }
 };

#endif

