/***************************************************************************
 Author: Moustafa Hammad
 Date: 10/31/2001

 The SM (Stream Manager is responsible for 
 servicing stream requests 
****************************************************************************/
#include "stream-mgr.h"
#include "values.h"
#include "adtfunc.h"
#include "genadt.h"


Tuple::Tuple(XxxShoreObjectId* RecId, XxxRecord* Rec){
  RecordId = RecId;
  Record = Rec;
};

//TODO: Latter on  you may need this????
//-------------------------------------------------------------------
// The deadline table methods
// Methods of ResultQueue
//-------------------------------------------------------------------
/*
LargeObjectTable::QueueEntry::QueueEntry (struct timeval TS, 
					  XxxShoreLogicalOID LOID,
					  QueueEntry *Next, 
					  QueueEntry *Prev):
  TimeStamp(TS), LargeObjectId(LOID), NextEntry(Next), PrevEntry(Prev){
  
  if (NextEntry != NULL)
    NextEntry->PrevEntry = this;
  if (PrevEntry != NULL)
    PrevEntry->NextEntry = this;
}

XxxErrCode LargeObjectTable::AddTuple(struct timeval TS, 
				      XxxShoreLogicalOID LOID){

  // Insert at Tail of the table
  // Search from tail to head for a tuple with timestamp < TS
  if (TailTable==NULL){
    // first entry
      TailTable = new QueueEntry(TS, LOID);
      HeadTable = TailTable;
      return XXX_OK;
  };
  // table has entries
  QueueEntry* tmpPtr = TailTable;
  while (tmpPtr!=NULL){
    if (TimeStampsGreater(TS, tmpPtr->TimeStamp)){
      //tmpPtr->TimeStamp < TS){
      tmpPtr->NextEntry= new QueueEntry(TS, LOID, tmpPtr->NextEntry, tmpPtr);
      if (tmpPtr==TailTable)
	TailTable = tmpPtr;
      return XXX_OK;
    } 
    else
      tmpPtr = tmpPtr->PrevEntry;
  };

  if (tmpPtr == NULL){ // must be
    // insert at head of the table
    HeadTable = new QueueEntry(TS, LOID, HeadTable, NULL);
  }
  else
    ASSERT(0);

  return XXX_OK;
}

XxxErrCode LargeObjectTable::RemoveTuple(struct timeval TS, 
						   XxxShoreLogicalOID LOID){

  // start from head towards tail
  
  QueueEntry *tmpPtr = HeadTable;
  
  while(tmpPtr != NULL){
    if ((TimeStampsEqual(tmpPtr->TimeStamp,TS))&&(tmpPtr->LargeObjectId == LOID)){
      // delete this entry
      if (tmpPtr->PrevEntry!=NULL)
	tmpPtr->PrevEntry->NextEntry = tmpPtr->NextEntry;
      if (tmpPtr->NextEntry!=NULL)
	tmpPtr->NextEntry->PrevEntry = tmpPtr->PrevEntry;
      if (tmpPtr==HeadTable)
	HeadTable = tmpPtr->NextEntry;
      if (tmpPtr==TailTable)
	TailTable = tmpPtr->PrevEntry;
      delete tmpPtr;
      tmpPtr = NULL;
    }
    else
      tmpPtr = tmpPtr->NextEntry;
  }
  return XXX_OK;
}
// initilize an iterator in both dirctions depending on
// the flag head
void LargeObjectTable::initQIter(XxxBool Head){
  if(Head){
    currPos = HeadTable;
    ValidScan = (currPos == NULL? XXX_FALSE:XXX_TRUE);
  }
  else{
    currPos = TailTable;
    ValidScan = (currPos == NULL? XXX_FALSE:XXX_TRUE);
  }
};

void LargeObjectTable::getNext(struct timeval *TS, XxxShoreLogicalOID *LOID){

  if(currPos!=NULL){
    TimeStampsAssign(TS, currPos->TimeStamp);
    *LOID = currPos->LargeObjectId;
    currPos = currPos->NextEntry;
    ValidScan = (currPos == NULL? XXX_FALSE:XXX_TRUE);
  };
};

void LargeObjectTable::getPrevious(struct timeval *TS, XxxShoreLogicalOID *LOID){

  if(currPos!=NULL){
    TimeStampsAssign(TS, currPos->TimeStamp);
    *LOID = currPos->LargeObjectId;
    currPos = currPos->PrevEntry;
    ValidScan = (currPos == NULL? XXX_FALSE:XXX_TRUE);
  };
};
*/
//---------------------------------------------------------------------------
StreamRequest::StreamRequest(Tuple *t, ResultQueue *q, XxxRecordSchema* RecSchema, int SfPos){
  OrgTuple = t;
  ResQ = q;
  RecordSchema = new XxxRecordSchema(*RecSchema);
  StrmFldPos = SfPos;
  //  donePrefetching = false;
  //  doneStreaming = false;
};

StreamRequest&
StreamRequest::operator=(const StreamRequest& R)
{
  if (this == &R)    return *this;
  OrgTuple = R.OrgTuple;
  ResQ = R.ResQ;
  RecordSchema = R.RecordSchema;
  StrmFldPos = R.StrmFldPos;
  return *this;
};


/**************************************************************************/
// Methods of ReqQueue

ReqQueue::QueueEntry::QueueEntry (StreamRequest *sr, 
				  QueueEntry *Next,
				  QueueEntry *Prev):
  Req(sr), NextEntry(Next), PrevEntry(Prev){

  if (NextEntry != NULL)
    NextEntry->PrevEntry = this;
  if (PrevEntry != NULL)
    PrevEntry->NextEntry = this;
}

XxxErrCode ReqQueue::enqueue(StreamRequest *Req){

  XxxUseMutex AutoMutex(Latch);
  Entries = new QueueEntry(Req, Entries, NULL);
  return XXX_OK;
}

XxxErrCode ReqQueue::dequeue(StreamRequest *&Req){

  XxxUseMutex AutoMutex(Latch);

  QueueEntry *Tmp,*Tmp1;
  Req = NULL;
  if(Entries != NULL){
    Tmp = Entries;
    while(Tmp->NextEntry != NULL)
      Tmp = Tmp->NextEntry;
    Req = Tmp->Req;
    Tmp1 = Tmp->PrevEntry;
    if (Tmp1!=NULL)
      Tmp1->NextEntry = NULL;
    if (Entries==Tmp){
      Entries = Entries->NextEntry;
    }
    delete Tmp;
  }
  return XXX_OK;
}

XxxErrCode ReqQueue::removeEntry(StreamRequest *strm){

  XxxUseMutex AutoMutex(Latch);

  QueueEntry *Tmp,*Tmp1;

  if(Entries != NULL){
    Tmp = Entries;
    while((Tmp->NextEntry != NULL)&&(Tmp->Req!=strm))
      Tmp = Tmp->NextEntry;
    
    if (Tmp->Req==strm){
      if (Tmp->PrevEntry!=NULL)
	Tmp->PrevEntry->NextEntry = Tmp->NextEntry;
      if (Tmp->NextEntry!=NULL)
	Tmp->NextEntry->PrevEntry = Tmp->PrevEntry;
      if (Entries==Tmp){
	Entries = Entries->NextEntry;
      }
      delete Tmp;
    }
  }

  return XXX_OK;
}

void ReqQueue::initQIter(){

  XxxUseMutex AutoMutex(Latch);
  
  currPos = Entries;
  if(currPos != NULL)
    while(currPos->NextEntry != NULL)
      currPos = currPos->NextEntry;
};

ReqQueue::QueueEntry* ReqQueue::getNext(){

  XxxUseMutex AutoMutex(Latch);
  QueueEntry* Tmp = currPos;
  
  if(currPos!=NULL)
    currPos = currPos->PrevEntry;
  
  return Tmp;
};


/**************************************************************************/


// Methods of ResultQueue

ResultQueue::QueueEntry::QueueEntry (Tuple *ResT,
				     QueueEntry *Next,
				     QueueEntry *Prev):
  ResultTuple(ResT), NextEntry(Next), PrevEntry(Prev){

  if (NextEntry != NULL)
    NextEntry->PrevEntry = this;
  if (PrevEntry != NULL)
    PrevEntry->NextEntry = this;
}

XxxErrCode ResultQueue::enqueue(Tuple *ResT){

  XxxUseMutex AutoMutex(Latch);
  if (TailEntries==NULL){
    // first entry
    TailEntries = new QueueEntry(ResT, NULL, NULL);
    HeadEntries = TailEntries;
    CurrSize++;
    return XXX_OK;
  };
  // table has entries
  TailEntries = new QueueEntry(ResT, NULL, TailEntries);
  CurrSize++;
  return XXX_OK;
}

XxxErrCode ResultQueue::dequeue(Tuple *&ResT){

  XxxUseMutex AutoMutex(Latch);

  QueueEntry *currEntry = HeadEntries;
  ResT = NULL;

  if(currEntry != NULL){
    HeadEntries = currEntry->NextEntry;
    if(HeadEntries!=NULL)
      HeadEntries->PrevEntry=NULL;
    else
      // list with single item
      TailEntries = NULL;

    ResT = currEntry->ResultTuple;

    delete currEntry;
	//cerr << this <<" StreamQueueSize is :" << CurrSize << endl;
    CurrSize--;
  }

  return XXX_OK;
}

XxxErrCode ResultQueue::flush(XxxRecordSchema* Schema){
  XxxUseMutex AutoMutex(Latch);

  QueueEntry *tmp = NULL;
  Tuple * tmpTuple;
  tmp = HeadEntries;
  while(tmp!=NULL){
    // delete all the queue
    HeadEntries = tmp->NextEntry;
    tmpTuple = tmp->ResultTuple;
    delete tmpTuple->RecordId;
    tmpTuple->Record->Reclaim(Schema);
    delete tmpTuple;
    delete tmp;
    tmp = HeadEntries;
  }
  CurrSize = 0;
  return XXX_OK;
  
}
//----------------------------------------------------------------------
StreamManagerThread::StreamManagerThread(int n):XxxBaseThread("SM_thread"){
  nMax = n;
  finish = 0;
  W_COERCE(fork());
};
//----------------------------------------------------------------------
void StreamManagerThread::ExecCode(){
  streamScheduler();
}

//----------------------------------------------------------------------
// end of streaming for this request
// put the request in a zombie state until the streaming
// client call getNextSeg, in order to release its last segment

void StreamManagerThread::finishCurrStream(StreamRequest *&strm){

  StreamRequest* tmpStrReq=NULL;
 
  CloseRequest(strm); // call CloseStream function

  strm->ResQ->RemoveStream(); // detach stream from result queue.

  currStreamQueue.removeEntry(strm);  //remove from current stream queue

  cntStream--;
  // delete strm
  // call CloseStream of the data type, 
  //  int retVal = STREAM_NO_VALUE;
  //  GetNewTuple(strm, &retVal);
  delete strm->OrgTuple->RecordId;
  //  strm->OrgTuple->Record->reclaim(strm->RecordSchema);
  delete strm->OrgTuple->Record;

  delete strm->OrgTuple;
  delete strm->RecordSchema;
  delete strm;

  inputStreamQueue.dequeue(tmpStrReq); //add one stream from the input stream queue if any 
  if (tmpStrReq!=NULL){
    cntStream++;
    currStreamQueue.enqueue(tmpStrReq);
  }
  
};

//----------------------------------------------------------------------
// Called by SScan when closing the cursor
// delete all stream request that are attached to the resultqueue

void StreamManagerThread::RemoveStreams(ResultQueue *Q){
  
  ReqQueue::QueueEntry* Tmp;
  StreamRequest *strm;
  //start with inputStreamQueue
  inputStreamQueue.initQIter();         //getNext from input stream queue
  while((Tmp=inputStreamQueue.getNext())!=NULL){
    strm=Tmp->Req;
    if(strm->ResQ == Q){
      // delete this stream
      finishCurrStream(strm);
      inputStreamQueue.initQIter();       
    };
  }


  currStreamQueue.initQIter();         //getNext from current stream queue
  while((Tmp=currStreamQueue.getNext())!=NULL){
    strm=Tmp->Req;
    if(strm->ResQ == Q){
      // delete this stream
      finishCurrStream(strm);
      currStreamQueue.initQIter();    
    };
  }
  
};
//----------------------------------------------------------------------
// InitNewRequest
// Initializes the new steam request

XxxErrCode StreamManagerThread::InitNewRequest(StreamRequest *strm){

  // call stream_read for the stream field of this tuple 
  XxxUseMutex AutoMutex(*XxxADTClass::Latch);
  const Tuple* tuple = strm->OrgTuple;
  const char *data = NULL; // must declare it as const before the call to GetField
  XxxADTValue *FldValue = NULL;
  XxxAttribute *attr = NULL;
  XxxADTClass* AttrClass = NULL;

  XXX_CALL_RET(tuple->Record->GetField(strm->StrmFldPos, (const XxxRecordSchema*)(strm->RecordSchema), data), XXX_BADRECORD,
	       "Cannot get field of a record");
  
  FldValue = (XxxADTValue*)data;
  attr = (XxxAttribute *)(strm->RecordSchema->Attrs+strm->StrmFldPos);
  AttrClass = XxxADTArray[attr->Type];

  if (!XxxCoreADTClass::IsCoreADT(attr->Type)){
    if(AttrClass->IsSmall(NULL)){
      XXX_CALL_RET(((XxxSmallADT*)AttrClass)->InitStream(FldValue), 
		   XXX_BADRECORD,
		   "Cannot Initialize Stream");
    }
    else{
      XXX_CALL_RET(((XxxLargeADT*)AttrClass)->InitStream(FldValue), 
		   XXX_BADRECORD,
		   "Cannot Initialize Stream");
    }
  }
  else
    return XXX_NOT_OK;

  return XXX_OK;
};

//----------------------------------------------------------------------
// GetNewTuple
// contact StreamRead of the streaming field and updates the value of the 
// field if any. It also sets the value returned from the StreamRead function

XxxErrCode StreamManagerThread::GetNewTuple(StreamRequest *strm, int *retV){

  // call stream_read for the stream field of this tuple 
  Tuple* tuple = strm->OrgTuple;
  const char *data; // must declare it as const before the call to GetField
  XxxADTValue *FldValue = NULL;
  XxxAttribute *attr = NULL;
  XxxADTClass* AttrClass = NULL;

  XXX_CALL_RET(tuple->Record->GetField(strm->StrmFldPos, strm->RecordSchema, data), XXX_BADRECORD,
	       "Cannot get field of a record");
  
  FldValue = (XxxADTValue*)data;
  attr = (XxxAttribute *)(strm->RecordSchema->Attrs+strm->StrmFldPos);
  

  AttrClass = XxxADTArray[attr->Type];
  if (!XxxCoreADTClass::IsCoreADT(attr->Type)){
    
    // allocate time stamp for the record
    struct timeval tupleTimeStamp;
    if(AttrClass->IsSmall(NULL))
      ((XxxSmallADT*)AttrClass)->ReadStream(FldValue, retV, &tupleTimeStamp);
    else
      ((XxxLargeADT*)AttrClass)->ReadStream(FldValue, retV, &tupleTimeStamp);
      
    if(tuple->Record->TSVec==NULL)
      tuple->Record->TSVec = new TheTimeStampVector(tupleTimeStamp);
    else{
      tuple->Record->TSVec->TheVec[0].tv_sec  = tupleTimeStamp.tv_sec;
      tuple->Record->TSVec->TheVec[0].tv_usec  = tupleTimeStamp.tv_usec;
    }
  }
  else
    return XXX_NOT_OK;


  return XXX_OK;
};
//----------------------------------------------------------------------
// CloseRequest
// Close the steam request

XxxErrCode StreamManagerThread::CloseRequest(StreamRequest *strm){

  // call CloseStream for the stream field of this tuple 
  Tuple* tuple = strm->OrgTuple;
  const char *data;  // must declare it as const before the call to GetField
  XXX_CALL_RET(tuple->Record->GetField(strm->StrmFldPos, strm->RecordSchema, data), XXX_BADRECORD,
	       "Cannot get field of a record");
  
  XxxADTValue *FldValue = (XxxADTValue*)data;
  XxxAttribute *attr = (XxxAttribute *)(strm->RecordSchema->Attrs+strm->StrmFldPos);
  
  XxxADTClass* AttrClass = XxxADTArray[attr->Type];
  if (!XxxCoreADTClass::IsCoreADT(attr->Type)){
    if(AttrClass->IsSmall(NULL)){
      XXX_CALL_RET(((XxxSmallADT*)AttrClass)->CloseStream(FldValue), 
		   XXX_BADRECORD,
		   "Cannot Close Stream");
    }
    else{
      XXX_CALL_RET(((XxxLargeADT*)AttrClass)->CloseStream(FldValue), 
		   XXX_BADRECORD,
		   "Cannot Close Stream");
    }
  }
  else
    return XXX_NOT_OK;


  return XXX_OK;
};
//----------------------------------------------------------------------
void StreamManagerThread::addNewStream(XxxShoreObjectId* RecId, XxxRecord* Rec, ResultQueue *resQueue, XxxRecordSchema* Schema, int StrmFldPos){
  
  Tuple* tempT = new Tuple(RecId, Rec);
  StreamRequest* s = new StreamRequest(tempT, resQueue, Schema, StrmFldPos);
  assert(s!=NULL);

  s->ResQ->AddStream(); // to count number of streams attached to this queue
  s->newReq = true;
  if(inputStreamQueue.isEmpty()){
    if(cntStream<nMax){
      cntStream++;
      currStreamQueue.enqueue(s);
    }
    else
      inputStreamQueue.enqueue(s);
  }
  else
    inputStreamQueue.enqueue(s);
};
//----------------------------------------------------------------------
void StreamManagerThread::streamScheduler(){

  struct timeval startTime; 
  struct timeval currTime; 
  struct timezone Temp; 
  StreamRequest *strm;
  ReqQueue::QueueEntry* Tmp;
  int waitTime;
  // SM runs as a long running transaction which serves 
  // all other threads
  // start a transaction if none exists already
  if (XxxBeginTrans() != XXX_OK) {
    XXX_NOTE_ERROR(XXX_BADEXEC, "Cannot begin a transaction");
    return ;
  }
  while(!finish){
    gettimeofday(&startTime, &Temp);     // record start time of a period
    //clock_t tmpTime = clock();
    //    startTime.tv_sec = tmpTime/CLOCKS_PER_SEC;
    //    startTime.tv_usec = tmpTime%CLOCKS_PER_SEC * 1000;
    currStreamQueue.initQIter();         //getNext from current stream queue
    while((Tmp=currStreamQueue.getNext())!=NULL){
      strm=Tmp->Req;
      ResultQueue* resQueue = strm->ResQ;
      // Here check if bending any stop streaming requests
      if(resQueue->IsEnough()){
	//	RemoveStreams(resQueue);
	//	resQueue->flush(strm->RecordSchema);
	RemoveStreams(resQueue);
	delete resQueue;
	break;
      }
      if(strm->newReq){	        // new commer
	// intiialize new request
	strm->newReq = false;
	InitNewRequest(strm); // call InitStream of the stream field
      };

	
      //cerr << "Stream Result Queue Length is: "<<  QSize()->CurrSize << endl;  
      if(!resQueue->isFull()){
	//	break; // skip this stream as its result queue is full
	
	int retValue;
	
	GetNewTuple(strm, &retValue); // call StreamRead of the stream field
	
	if (retValue == STREAM_NEW_VALUE){
	  // copy the returned tuple to the ResultQueue of this request
	  //make a new record
	  XxxRecord*& ReturnRec=strm->OrgTuple->Record;
	  XxxRecord* resRec = new XxxRecord(*ReturnRec);
	  // copy the time stamp as well
	  if(resRec->TSVec==NULL)
	    resRec->TSVec = new TheTimeStampVector(strm->OrgTuple->Record->TSVec);
	  XxxShoreObjectId* resRecId = new XxxShoreObjectId(*(strm->OrgTuple->RecordId));
	  // copy it to the ResultQueue
	  Tuple* tmp = new Tuple(resRecId, resRec);
	  strm->ResQ->enqueue(tmp);
	}
	else if (retValue == STREAM_NO_VALUE){
	  
	}
	else if (retValue == STREAM_END){
	  // finish this request
	  finishCurrStream(strm);
	}
	else {//error
	}
      }
    }
    // to speed up execution: just start the next round if no streams to serve
    me()->yield();

  }
  // commit a transaction
  if (XxxCommitTrans() != XXX_OK) {
    XXX_NOTE_ERROR(XXX_BADEXEC, "Cannot Commit a transaction");
    return ;
  }
};
