#include <stdio.h>
#include <string.h>
#include <iostream.h>
#include "templates.h"
#include "values.h"
#include "engines.h"
#include "defeng.h"
#include "shoresm.h"
#ifdef XXX_DEF_RELADT
#include "releng.h"
#endif
#ifdef XXX_DEF_SEQADT
#include "seqeng.h"
#endif

/// array of database engines
XxxDBEngine* XxxDBEngineArray[XXX_ENGINE_MAX];
int XxxNumDBEngines;
XxxBaseMutex* XxxDBEngine::Latch = new XxxBaseMutex();

// This function gets invoked by the InitThread to set up all the DB engines
void XxxInitializeEngines()
{
 // Latch is used to synchronize access to the ADT array
 XxxUseMutex AutoMutex(*XxxDBEngine::Latch);

 for (int i = 0; i < XXX_ENGINE_MAX; XxxDBEngineArray[i++] = NULL);
 XxxNumDBEngines = 0;

 // each ADT constructor inserts itself into the XxxADTArray
 int EngNum = XxxNumDBEngines++;
 new XxxDefaultEngine(EngNum);

#ifdef XXX_DEF_RELADT
 EngNum = XxxNumDBEngines++;
 new XxxRelationEngine(EngNum);
#endif

#ifdef XXX_DEF_SEQADT
 EngNum = XxxNumDBEngines++;
 new XxxSequenceEngine(EngNum);
#endif
}

// This function gets invoked by the InitThread to close all the DB engines
void XxxTerminateEngines()
{
 XxxUseMutex AutoMutex(*XxxDBEngine::Latch);
 for (int i = 0; i < XxxNumDBEngines; i++) {
   delete XxxDBEngineArray[i];
   XxxDBEngineArray[i] = NULL;
 }
}

void XxxDBEngine::Print(ostream& OStr) const
{
 OStr << Name ;
 if (NumLanguages) {
   OStr << " : Languages - ";
   for (int i = 0; i < NumLanguages; i++) {
     OStr << LanguageNames[i];
     if (i < NumLanguages-1) OStr << ", " ;
    }
  }
 else
   OStr << " No Language";
 OStr << endl;
}












