#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <signal.h>
#include <new.h>
#include <string.h>
#include <netdb.h>

#ifdef __GNUG__
#pragma implementation
#endif

#include "xxx_thread.h"
#include "engines.h"
#include "shoresm.h"
#include "JavaVM.h"

#include "JavaPlans.h"
#include "proxyserver.h"

#include "suspcomp.h"

#include "options.h"

const char* XXX_ERROR_FILE_NAME_DEF = "stderr";
const char* XXX_INPUT_FILE_NAME_DEF = "stdin";
const char* XXX_OUTPUT_FILE_NAME_DEF = "stdout";
//Bjarke, aug. 8: variables commented out, are apparently unused
//char* XXX_REG_FILE_NAME_DEF = ".xxxreg";
//char* XXX_RC_FILE_NAME_DEF = ".xxxrc";

//
// XxxEnvironment
//
XxxEnvironment::XxxEnvironment()
{
 StorageManager = 0;
 HostName = NULL;
 Port = 0;

 VerboseLevel = 2; // default: error stack with file/line info

 Interrupt = XXX_FALSE;
 InterruptSignal = 0;

 ErrorStr = &(cerr);
 OutputStr = &(cout);

 EngineEnvs = NULL;
 ADTEnvs = NULL;
 NumEngineEnvs = NumADTEnvs = 0;
 TempFileDeleteDelay = 300000;
#ifdef XXX_JAVA_VIRTUAL_MACHINE
 JVM = NULL;
 RemoteEE = NULL;
#endif
#ifdef XXX_DEF_COUGAR
 PSM = NULL;
#endif
}

#ifdef XXX_JAVA_VIRTUAL_MACHINE
XxxErrCode XxxEnvironment::StartJVM()
{
  // create a JVM wrapper object
  JVM = new XxxJavaVM;
  if (JVM->IsValid()) {
    if (XXX_THISENV().DebugFlags.JavaVM) 
      cerr << "XxxJavaVM successfully created.\n";
    return XXX_OK;
  }
  else return XXX_NOT_OK;
}

XxxErrCode XxxEnvironment::ShutJVM()
{
 // reclaim the JVM wrapper object
 if (JVM) delete JVM;
 JVM = NULL;
 return XXX_OK;
}


XxxErrCode XxxEnvironment::StartRemoteExecEngine()
{
	// TODO: list of remote hosts in config file
	XxxJavaRemoteConnections::RemoteHosts *HostsList = new XxxJavaRemoteConnections::RemoteHosts();
	HostsList->Add("osprey", 5000);

	XxxJavaRemoteConnections *JConn = new XxxJavaRemoteConnections(HostsList);

	RemoteEE = new XxxRemoteExecEngine(JConn);

	return XXX_OK;
}

XxxErrCode XxxEnvironment::ShutRemoteExecEngine()
{
	delete RemoteEE;

	return XXX_OK;
}
#endif


#ifdef XXX_DEF_COUGAR
XxxErrCode XxxEnvironment::StartProxyServers()
{
	// temp hack
	XxxProxyServerManager::PSList *HostsList = new XxxProxyServerManager::PSList();
	
    char* Host1       =  XXX_THISENV().Options->getopt("XXX_PS1_HOST");
    char* Port1String =  XXX_THISENV().Options->getopt("XXX_PS1_PORT");
	int Port1;
    if (Port1String)
	  Port1 = atoi(Port1String);

	//char* Host2       =  XXX_THISENV().Options->getopt("XXX_PS2_HOST");
    //char* Port2String =  XXX_THISENV().Options->getopt("XXX_PS2_PORT");
	//int Port2;
	//if (Port2String)
		//Port2 = atoi(Port2String);

	HostsList->Add(Host1, Port1);

	//HostsList->Add(Host2, Port2);

	
	PSM = new XxxProxyServerManager(HostsList);

	if (PSM->IsValid()) {
		return XXX_OK;
	} else {
		return XXX_NOT_OK;
	}
}


XxxErrCode XxxEnvironment::ShutProxyServers()
{
	if (PSM) delete PSM;
	PSM = NULL;
	return XXX_OK;
}

#endif

XxxEnvironment::XxxEnvironment(const XxxEnvironment& Env)
{
 StorageManager = Env.StorageManager;  
 if (Env.HostName != NULL) {
   HostName = new char[strlen(Env.HostName) + 1];
   strcpy(HostName, Env.HostName);
 }
 Port = Env.Port;

 Options = Env.Options;

 VerboseLevel = Env.VerboseLevel;

 ErrorStr = Env.ErrorStr;
 OutputStr = Env.OutputStr;

 MultiStmtXact = XXX_FALSE;

 if (Env.TmpDataDir != NULL) {
   TmpDataDir = new char[strlen(Env.TmpDataDir) + 1];
   strcpy(TmpDataDir, Env.TmpDataDir);
 }

 StorageVolume = Env.StorageVolume;
 StorageFile = Env.StorageFile;
 TempFileId = Env.TempFileId;
 TempFileDeleteDelay = Env.TempFileDeleteDelay;

 EngineEnvs = NULL;
 ADTEnvs = NULL;
 NumEngineEnvs = NumADTEnvs = 0;

#ifdef XXX_JAVA_VIRTUAL_MACHINE
 JVM = NULL;
 RemoteEE = Env.RemoteEE;
#endif

#ifdef XXX_DEF_COUGAR
 PSM = Env.PSM;
#endif

}

XxxEnvironment::~XxxEnvironment()
{
  if (TmpDataDir != NULL)
    delete [] TmpDataDir;
  if (HostName != NULL)
    delete [] HostName;

#ifdef XXX_JAVA_VIRTUAL_MACHINE
  if (JVM) {
    cerr << "JVM should be NULL in XxxEnv destructor" << endl;
  }
#endif
}

XxxErrCode XxxEnvironment::CreateEnvs()
{
  SuspendedComputations = new XxxSuspCompLib();
  XxxErrCode rc = XXX_OK;
  int i;
  {
    XxxUseMutex AutoMutex(*XxxDBEngine::Latch);
    EngineEnvs = new XxxEngineEnv*[XxxDBEngine::NumDBEngines];
    for (i = 0; i < XxxDBEngine::NumDBEngines; i++) {
      XXX_CALL_RET(XxxDBEngine::DBEngineArray[i]->CreateEnv(EngineEnvs[i]),
		   XXX_BADENG, "Error creating Engine env")
    }
    NumEngineEnvs = XxxDBEngine::NumDBEngines;
  }
  {
    XxxUseMutex AutoMutex(*XxxADTClass::Latch);
    ADTEnvs = new XxxADTEnv*[XxxADTClass::NumADTs];
    for (i = 0; i < XxxADTClass::NumADTs; i++) {
      XXX_CALL_RET(XxxADTClass::ADTArray[i]->CreateEnv(ADTEnvs[i]),
		   XXX_BADADT, "Error creating ADT env");
    }
    NumADTEnvs = XxxADTClass::NumADTs;
  }
  return rc;
}

XxxErrCode XxxEnvironment::DeleteEnvs()
{
 delete SuspendedComputations;

 XxxErrCode rc = XXX_OK;
 int i;
 for (i = 0; i < NumEngineEnvs; i++) {
   XxxDBEngineArray[i]->DeleteEnv(EngineEnvs[i]);
  }
 {   
   XxxUseMutex AutoMutex(*XxxADTClass::Latch);
   for (i = 0; i < NumADTEnvs; i++)  {
     if (XxxADTClass::ADTArray[i]->DeleteEnv(ADTEnvs[i]) != XXX_OK) {
       char buf[100];
       sprintf(buf, "Error deleting env for %s", XxxADTClass::ADTArray[i]->TypeName);
       XXX_NOTE_ERROR(XXX_BADADT, buf);
       rc = XXX_NOT_OK;
     }
   }
 }

 delete [] EngineEnvs;
 delete [] ADTEnvs;
 return rc;
}

void XxxEnvironment::enableExceptionHandlers(XxxSigHandlerType SignalHandler,
					     XxxNewHandlerType NewHandler)
{
 // Catch signals that might otherwise cause termination
#ifdef XXX_WIN32
  signal(SIGABRT, (SignalHandler));
  signal(SIGFPE, (SignalHandler));
  signal(SIGINT, (SignalHandler));
  /******
  // the next three are defunct for NT
  signal(SIGILL, (SignalHandler));
  signal(SIGSEGV, (SignalHandler));
  signal(SIGTERM, (SignalHandler));
  ****/
#else
  for (int i = SIGINT; i < SIGPIPE; i++) {
    // SIGKILL should not be caught
    if (i != SIGKILL) {
#ifdef __GNUC__
      signal(i, (SignalHandler)) ;
#else
      signal(i, (XxxSigHandlerType)(SignalHandler)) ;
#endif
    } // if !SIGKILL
  } // for all signals
 // have to ignore SIGPIPE
 signal(SIGPIPE, SIG_IGN) ;
#endif
 
 // Provide exception handler for new()
#ifndef XXX_WIN32
  // PRD_W32 : TODO : fix new signal handler using _set_new_handler()
 set_new_handler(NewHandler) ;
#endif
}

void XxxEnvironment::Initialize(XxxSigHandlerType SignalHandler,
				XxxNewHandlerType NewHandler,
				int Port)
{
  // signal handling
  enableExceptionHandlers(SignalHandler, NewHandler);

  // any initialization code 
  this->Port = Port;
  HostName = NULL;
  // OLD: char *Host = getenv("HOST");
  char *Host = Options->getopt("HOST");
  if (Host != NULL) {
    struct hostent *HostEntity = gethostbyname(Host);
    if (HostEntity) {
      HostName = new char[strlen(HostEntity->h_name) + 1];
      strcpy(HostName, HostEntity->h_name);
    }
  }
  if (!HostName) {
    HostName = new char[strlen("localhost") + 1];
    strcpy(HostName, "localhost");
  }
}

XxxErrCode XxxEnvironment::InitStorage() 
{
 StorageVolume = XxxShoreSM->DefaultVol();
 StorageFile = XxxShoreSM->PersistentFileId();
 // Create the default temporary file
 XxxBool XctStartedHere = XXX_FALSE;
 if (!XXX_THISTHREAD()->xct())
   XctStartedHere = XXX_TRUE;
 if (XctStartedHere && (XxxBeginTrans() != XXX_OK)) {
   XXX_NOTE_ERROR(XXX_SHOREERR, "Cannot begin transaction");
   return XXX_NOT_OK;
  }
 XxxBool ToAbort = XXX_FALSE;
 XxxErrCode rc = XXX_OK;
 if (XxxShoreSM->CreateFile(StorageVolume,
			    TempFileId, 
			    XxxShoreSM->XXX_SHORE_LOAD) != XXX_OK) {
   XXX_NOTE_ERROR(XXX_SHOREERR, 
		  "Cannot create global temp file for env");
   ToAbort = XXX_TRUE;
   rc = XXX_NOT_OK;
  }
 if (!ToAbort && XctStartedHere && (XxxCommitTrans() != XXX_OK)) {
   XXX_NOTE_ERROR(XXX_SHOREERR, "Cannot commit transaction");
   ToAbort = XXX_TRUE;
   rc = XXX_NOT_OK;
  }
 if (XctStartedHere && ToAbort && (XxxAbortTrans() != XXX_OK)) {
   XXX_NOTE_ERROR(XXX_SHOREERR, "Cannot abort transaction");
  }
 return rc;
}

XxxErrCode XxxEnvironment::DumpStorage()
{
  // Enqueue the temporary file for deletion
  if (XxxShoreSM->DeletionQueue.
      EnqueueFile(StorageVolume, TempFileId, ShoreFileDeletionQueue::
		  GetTimeFromNow(TempFileDeleteDelay)) != XXX_OK) {
    XXX_NOTE_ERROR(XXX_SHOREERR, "Cannot enqueue temp file for deletion");
    return XXX_NOT_OK;
  }
  if (XxxShoreSM->DeletionQueue.GarbageCollect() != XXX_OK) {
    XXX_NOTE_ERROR(XXX_SHOREERR, "Cannot flush the queue");
    return XXX_NOT_OK;
  }
  return XXX_OK;
}

void XxxEnvironment::Clear()
{
 ErrorInfo.Clear();
 Interrupt = XXX_FALSE;
 InterruptSignal = 0;
 // do not reset MultiStmtXact
}

void XxxEnvironment::print(ostream& OStr) const
{
 char buf[100];
 sprintf(buf, " XXX Environment\n");
 OStr << buf;
 sprintf(buf, "-----------------\n");
 OStr << buf;
 }

// open the file and connect it to the input file stream
static XxxErrCode OpenFileWithComments(ifstream& InFStream, 
				       const char *FileName)
{
 char* buf1;
 char buf[1000];

 // TODO: get rid of this!!!
 const char* CPP_COMMAND= "gcc -x c -E -P -undef -Umips -Uunix %s | grep \"[^ ]\" > %s";

 // OLD: const char* cpp_command = getenv("XXX_CPP_COMMAND");
 const char* cpp_command = XXX_THISENV().Options->getopt("XXX_CPP_COMMAND");
 if (!cpp_command)
   cpp_command = CPP_COMMAND;

 buf1 = tmpnam(NULL);
 sprintf(buf, cpp_command, FileName, buf1);
 if (system(buf)) {
   //delete buf1;
   unlink(buf1);
   return XXX_NOT_OK;
  }
 InFStream.open(buf1);
 //delete buf1;
 unlink(buf1);
 if (InFStream.good()) return XXX_OK;
 else return XXX_NOT_OK;
}

static XxxErrCode OpenFile(ofstream& OutFStream, 
			   const char *FileName)
{
 OutFStream.open(FileName);
 if (OutFStream.good()) return XXX_OK;
 else return XXX_NOT_OK;
}

XxxErrCode CheckFileExists(ifstream& InFStream,
			   const char *FileName,
			   const char *DirPath, 
			   char WithComments)
{
 XxxErrCode rc = XXX_OK;
 if (!DirPath) {
   // Check if FileName or $(HOME)/FileName exist
   InFStream.open(FileName);
   if (!InFStream.good()) {
     // OLD: char *homePath = getenv("HOME") ;
	 char *homePath = XXX_THISENV().Options->getopt("HOME") ;
     if (!homePath) return XXX_NOT_OK;
     char *tmpName = new char[strlen(homePath) + 100] ;
     strcpy(tmpName, homePath);
     strcat(tmpName, "/");
     strcat(tmpName, FileName);
     InFStream.open(tmpName);
     if (!InFStream.good()) {
       delete [] tmpName ;
       return XXX_NOT_OK;
      }
     if (WithComments) {
       InFStream.close();
       rc  =  OpenFileWithComments(InFStream, tmpName);
      }
     delete [] tmpName ;
     return rc;
    }
   if (WithComments) {
     InFStream.close();
     rc = OpenFileWithComments(InFStream, FileName);
    }
   return rc;
  }
 else {
   char *tmpName = new char[strlen(DirPath) + 50] ;
   strcpy(tmpName, DirPath);
   strcat(tmpName, "/");
   strcat(tmpName, FileName);
   InFStream.open(tmpName);
   if (!InFStream.good()) {
     delete [] tmpName ;
     return XXX_NOT_OK;
    }
   if (WithComments) {
     InFStream.close();
     rc = OpenFileWithComments(InFStream, tmpName);
    }
   delete [] tmpName ;
   return rc;
  }
}

/*
 * Function Name : PrintHelp
 */
void XxxEnvironment::PrintHelp(ostream& OStr) const
{
 OStr << " Predator Server" << endl;
 OStr << "    -o <string> : [mandatory] Path of the option file" << endl;
 OStr << "    -s <int>    : [mandatory] Size of buffer mgr" << endl;
 OStr << "    -d          : display defaults" << endl;
 OStr << "    -t <int>    : delay (in seconds) for temporary results removal" 
      << endl;
 OStr << "    -c <string> : Additional classpath for the JVM" << endl;


}

/*********************************************************************
 * Function Name : GetCommandLineFlags
 * Purpose : obvious
 -d  : display defaults
 -s <int> : size of SHORE storage manager
 -c : classpath extensions
 -t : temp file delete delay
 -v <int> : verbose level (default 1)
 -o : options file path
*********************************************************************/
XxxBool XxxEnvironment::ProcessCommandLine(int argc, char** argv)
{
 int i;
 XxxBool OptionsSet = XXX_FALSE;
 XxxBool BufferSet  = XXX_FALSE;

 for (i = 1; i < argc; i++){
   char *flag = argv[i];
   if (flag[0] != '-') {
     cerr << "Bad command line flag "<< argv[i] << endl;
     continue;
    }
   switch (flag[1]) {
    case 'd' :
     Display();
     break; 

    case 's' :
     if (!(i+1 < argc && ((StorageManager = atoi(argv[++i])) >= 0))) {
       cerr << "Bad command line flag " << flag << endl;
       StorageManager = 0;
	 } 
	 else
	 {
		 BufferSet = XXX_TRUE;
	 }
     break; 

    case 't' :
     if (!(i+1 < argc && 
	   ((TempFileDeleteDelay = atoi(argv[++i]) * 1000) >= 0))) {
       cerr << "Bad command line flag " << flag << endl;
       TempFileDeleteDelay = 300000;
      }
     break; 

    case 'c' :  // ClassPath extension for the Java Virtual Machine
      if (!(i+1 < argc)) {
        cerr << "Bad command line flag " << flag << endl;
      } else {
        XxxJavaVM::AddToClasspath(argv[++i]);
      }
      break;

    case 'v' :
     if (!(i+1 < argc && ((VerboseLevel = atoi(argv[++i])) >= 0))) {
       cerr << "Bad command line flag " << flag << endl;
       VerboseLevel = 2;
      }
     break; 

	case 'o' :
     if (!(i+1 < argc)) {
        cerr << "Bad command line flag " << flag << endl;
     } else {
        Options = new options();
		if (Options->load(argv[++i]) != XXX_OK)
		{
			cerr << "Option file does not exist" << flag << endl;
		}
		else 
		{
			OptionsSet = XXX_TRUE;

			TmpDataDir = new char[100];
			// OLD: if (getenv("XXXTMPDATADIR"))
			if (Options->getopt("XXXTMPDATADIR"))
			{
				// OLD: strcpy(TmpDataDir, getenv("XXXTMPDATADIR"));
				strcpy(TmpDataDir, Options->getopt("XXXTMPDATADIR"));
			}
			else 
			{
				strcpy(TmpDataDir, "/tmp");
				cerr << "The option XXXTMPDATADIR was not set; using "
					<< TmpDataDir << endl;
			}
		}
      }	
	  break;


     default :
     PrintHelp(cerr);
     exit(1);
    }
  }

 if (!(OptionsSet && BufferSet))
 {
	 PrintHelp(cerr);
     exit(1);
 }

 return XXX_TRUE;
}

/**
 * This = operator is used to make two environments identical, so callback
 * threads can share the same environment as their main thread.  It borrows
 * the adt environments, and SHOULD NOT DELETE THEM when it is destroyed.
 */
const XxxEnvironment & XxxEnvironment::operator=(const XxxEnvironment &other)
{
 StorageManager = other.StorageManager;  

 ErrorStr = other.ErrorStr;
 // OutputStr = other.OutputStr;

 MultiStmtXact = other.MultiStmtXact;

 TmpDataDir = new char[100];
 strcpy(TmpDataDir, other.TmpDataDir);

 StorageVolume = other.StorageVolume;
 StorageFile = other.StorageFile;
 TempFileId = other.TempFileId;
 SuspendedComputations = other.SuspendedComputations;

 EngineEnvs = other.EngineEnvs;
 NumEngineEnvs = other.NumEngineEnvs;
 ADTEnvs = other.ADTEnvs;
 NumADTEnvs = other.NumADTEnvs;

 return (*this);
}

XxxErrCode XxxEnvironment::
SetValue(const char* ValName, char NewVal) 
{
  if (!strncmp(ValName, "dbg_", 4))
    return DebugFlags.SetValue(ValName+4, NewVal);
  else if (!strncmp(ValName, "env_", 4))
    return DBEnv.SetValue(ValName+4, NewVal);
  else if ((!strcmp(ValName, "sc_flush")) && NewVal)
    return SuspendedComputations->Flush();
  return XXX_NOT_OK;
}

void XxxEnvironment::GeneralStats::Print(ostream& OStr) const
{
 OStr << " General Statistics : " << endl;
 Record.Print(OStr);
 Shore.Print(OStr);
 Expr.Print(OStr);
}
void XxxEnvironment::GeneralStats::RecordStats::Print(ostream& OStr) const
{
 OStr << "   Record-Level Statistics : " << endl;
 OStr << "\t RecCreated : " << RecCreated << endl;
 OStr << "\t RecDeleted  " << RecDeleted << endl;
 OStr << "\t RecConcat  " << RecConcat << endl;
 OStr << "\t RecGetField  " << RecGetField << endl;
 OStr << "\t RecReclaim  " << RecReclaim << endl;
 OStr << "\t RecPrint  " << RecPrint << endl;
 OStr << "\t AttrCreated  " << AttrCreated << endl;
 OStr << "\t AttrDeleted  " << AttrDeleted << endl;
 OStr << "\t SchemaCompStats  " << SchemaCompStats << endl;
 OStr << "\t GetAttr0  " << GetAttr0 << endl;
 OStr << "\t GetAttr1  " << GetAttr1 << endl;
 OStr << "\t GetAttr2  " << GetAttr2 << endl;
 OStr << "\t GetOffset  " << GetOffset << endl;
 OStr << "\t AvgSizeRecCreated  " << AvgSizeRecCreated << endl;
 OStr << "\t AvgSizeRecDeleted  " << AvgSizeRecDeleted << endl;
}

XxxEnvironment::DebugFlags::DebugFlags()
{
  XxxBool Val = XXX_FALSE;
  /** Too much junk put on screen : off by default
    #ifdef XXX_DEBUG
    Val = XXX_TRUE;
    #endif  
    **/
  Connection = Socket = Callback = SuspComp = Server = Protocol = ADTRules = Memory = Shore = JavaVM = Expression = FutureUse0 = FutureUse1 = FutureUse2 = FutureUse3 = FutureUse4 = Val;

  // Connection = Server = Protocol = XXX_TRUE;
  Connection = Server = Protocol = Val;
  JavaVM = XXX_TRUE;
}

XxxErrCode XxxEnvironment::
DebugFlags::SetValue(const char* ValName, char NewVal) 
{
 if (!strcmp(ValName, "connection")) {
   Connection = (NewVal ? XXX_TRUE: XXX_FALSE);
  } 
 else if (!strcmp(ValName, "socket")) {
   Socket = (NewVal ? XXX_TRUE: XXX_FALSE);
  } 
 else if (!strcmp(ValName, "callback")) {
   Callback = (NewVal ? XXX_TRUE: XXX_FALSE);
  } 
 else if (!strcmp(ValName, "suspcomp")) {
   SuspComp = (NewVal ? XXX_TRUE: XXX_FALSE);
  } 
 else if (!strcmp(ValName, "server")) {
   Server = (NewVal ? XXX_TRUE: XXX_FALSE);
  } 
 else if (!strcmp(ValName, "protocol")) {
   Protocol = (NewVal ? XXX_TRUE: XXX_FALSE);
  } 
 else if (!strcmp(ValName, "adtrules")) {
   ADTRules = (NewVal ? XXX_TRUE: XXX_FALSE);
  } 
 else if (!strcmp(ValName, "memory")) {
   Memory = (NewVal ? XXX_TRUE: XXX_FALSE);
  } 
 else if (!strcmp(ValName, "shore")) {
   Shore = (NewVal ? XXX_TRUE: XXX_FALSE);
  } 
 else if (!strcmp(ValName, "jvm")) {
   JavaVM = (NewVal ? XXX_TRUE: XXX_FALSE);
  } 
 else if (!strcmp(ValName, "expression")) {
   Expression = (NewVal ? XXX_TRUE: XXX_FALSE);
  } 
 else if (!strcmp(ValName, "future0")) {
   FutureUse0 = (NewVal ? XXX_TRUE: XXX_FALSE);
  } 
 else if (!strcmp(ValName, "future1")) {
   FutureUse1 = (NewVal ? XXX_TRUE: XXX_FALSE);
  } 
 else if (!strcmp(ValName, "future2")) {
   FutureUse2 = (NewVal ? XXX_TRUE: XXX_FALSE);
  } 
 else if (!strcmp(ValName, "future3")) {
   FutureUse3 = (NewVal ? XXX_TRUE: XXX_FALSE);
  } 
 else if (!strcmp(ValName, "future4")) {
   FutureUse4 = (NewVal ? XXX_TRUE: XXX_FALSE);
  } 
 else {
   return XXX_NOT_OK;
 }
 return XXX_OK;
}

//
// XxxEngineEnv
//
XxxEngineEnv::XxxEngineEnv()
{
}
XxxEngineEnv::~XxxEngineEnv()
{
}
//
// XxxADTEnv
//
const char* const XxxADTEnv::APPLY_TOPDOWN = "topdown";
const char* const XxxADTEnv::APPLY_BOTTOMUP = "bottomup";
const char* const XxxADTEnv::ADT_PIPE = "adt_pipe";
const char* const XxxADTEnv::SUSPEND_COMPUTATION = "susp_comp";
const char* const XxxADTEnv::METHOD_CACHE = "method_cache";
const char* const XxxADTEnv::METHOD_SCRATCH = "method_scratch";

XxxADTEnv::XxxADTEnv()
{
 ApplyTopDown = XXX_TRUE;
 ApplyBottomUp = XXX_TRUE;
 AdtPipe = XXX_TRUE;
 SuspendComputation = XXX_FALSE;
 MethodCache = XXX_TRUE;
 MethodScratchArea = XXX_TRUE;
}

XxxADTEnv::~XxxADTEnv()
{
}

void XxxADTEnv::Print(ostream& OStr) const
{
  // print out the current settings
 OStr << APPLY_TOPDOWN << ": should top-down rules be applied in function expression optimizations? " << (ApplyTopDown?"yes":"no") << endl;
 OStr << APPLY_BOTTOMUP << ": should bottom-up rules be applied in function expression optimizations? " << (ApplyBottomUp?"yes":"no") << endl;
 OStr << ADT_PIPE << ": should output of one adt operation be piped into input of the next?" << (AdtPipe?"yes":"no") << endl;
 OStr << SUSPEND_COMPUTATION << ": should method computation be suspended until callbacks?" << (SuspendComputation?"yes":"no") << endl;
 OStr << METHOD_CACHE << ": is a cache allowed for the results of method computations?" << (MethodCache?"yes":"no") << endl;
 OStr << SUSPEND_COMPUTATION << ": is there a persistent scratch area for method computations?" << (MethodScratchArea?"yes":"no") << endl;
}

XxxErrCode XxxADTEnv::SetValue(const char *ValName, void *NewVal)
{
  if (!strcmp(ValName, APPLY_TOPDOWN)) {
    ApplyTopDown = (*((char*)NewVal)-'0')?XXX_TRUE:XXX_FALSE;
  }
  else if (!strcmp(ValName, APPLY_BOTTOMUP)) {
    ApplyBottomUp = (*((char*)NewVal)-'0')?XXX_TRUE:XXX_FALSE;
  }
  else if (!strcmp(ValName, ADT_PIPE)) {
    AdtPipe = (*((char*)NewVal)-'0')?XXX_TRUE:XXX_FALSE;
  }
  else if (!strcmp(ValName, SUSPEND_COMPUTATION)) {
    SuspendComputation = (*((char*)NewVal)-'0')?XXX_TRUE:XXX_FALSE;
  }
  else if (!strcmp(ValName, METHOD_CACHE)) {
    MethodCache = (*((char*)NewVal)-'0')?XXX_TRUE:XXX_FALSE;
  }
  else if (!strcmp(ValName, METHOD_SCRATCH)) {
    MethodScratchArea = (*((char*)NewVal)-'0')?XXX_TRUE:XXX_FALSE;
  }
  else {
    XXX_NOTE_ERROR(XXX_BADCMD, "Unknown argument to Set");
    return XXX_NOT_OK;
  }
  return XXX_OK;
}

