#include "xxx_thread.h"
#include "values.h"
#include "engines.h"

XxxErrCode XxxErrInfo::Note(XxxErrCond Cond, const char* Message, 
			    int Engine, const char* FileName, int LineNumber)
{
 XxxErrInfo* NewInfo = new XxxErrInfo(Cond, Message, Engine,
				      FileName, LineNumber);
 NewInfo->Next = NULL;

 XxxErrInfo* Tmp = this;
 while (Tmp->Next) Tmp = Tmp->Next;
 Tmp->Next = NewInfo;
 return XXX_OK;
}

XxxErrCode XxxErrInfo::Get(XxxErrInfo* Error)
{
 Error = this;
 return XXX_OK;
}

void XxxErrInfo::Clear()
{
 while (Next) {
   XxxErrInfo* tmp = Next;
   Next = Next->Next;
   delete tmp;
  }
}

void XxxErrInfo::Print(ostream& OStr,
		       const char *Msg) const
{
 XxxErrInfo* Tmp = Next;
 OStr << "Error: " << Msg << endl;
 while (Tmp) {
   Tmp->printThis(OStr);
   Tmp = Tmp->Next;
  }
 OStr << flush;
}

void XxxErrInfo::printThis(ostream& OStr) const
{
  if ((SourceEngine >= 0) && (SourceEngine < XxxNumDBEngines) &&
      (XxxDBEngineArray[SourceEngine])) {
    if (XXX_THISENV().VerboseLevel > 0) {
      OStr << XxxDBEngineArray[SourceEngine]->ErrorString(Condition);
      OStr << ":" << Message;
      if (XXX_THISENV().VerboseLevel > 1) {
	OStr << ":File " << FileName << ", Line " << LineNumber ;
      }
      OStr << endl;
    }
  }
  else {
    if (XXX_THISENV().VerboseLevel > 0) {
      OStr << "Error from Engine " << SourceEngine << ": " << Message;
      if (XXX_THISENV().VerboseLevel > 1) {
	OStr << "(" << FileName << " line " << LineNumber << ") ";
      }
      OStr << endl;
    }
  }
  OStr << flush;
}

