#ifndef XXX_TEMPLATES_C
#define XXX_TEMPLATES_C

//Bjarke, aug. 6: #pragma interface/implementation not needed any longer
//#pragma implementation "templates.h"

/* June 26 - explicit templates
#ifdef __GNUG__
#pragma implementation "templates.h"
#pragma implementation "prd-config.h"
#pragma implementation "error.h"
#pragma implementation "types.h"
#pragma implementation "../utils/record.h"
#ifdef XXX_DEF_SEQADT
#pragma implementation "../seqadt/execute/commands.h"
#pragma implementation "../seqadt/storage/unixascii.h"
#pragma implementation "../seqadt/storage/shoreseq.h"
#pragma implementation "../seqadt/basic/order.h"
#pragma implementation "../seqadt/storage/seqcat.h"
#pragma implementation "../seqadt/storage/seqdata.h"
#pragma implementation "../seqadt/compile/seqquery.h"
#endif
#ifdef XXX_DEF_RELADT
#pragma implementation "../reladt/execute/commands.h"
#pragma implementation "../reladt/storage/relcat.h"
#pragma implementation "../reladt/storage/reldata.h"
#pragma implementation "../reladt/compile/relquery.h"
#pragma implementation "../reladt/basic/relenv.h"
#pragma implementation "../reladt/storage/shorerel.h"
#endif
#pragma implementation "../server/env.h"
#pragma implementation "../server/defeng.h"
#endif
*/

/* June 26 - explicit templates
//#ifdef __GNUG__
#if 0
// SHORE implementation pragmas : see shore/src/sm/ssh/template.C
#define TEMPLATE_C

#pragma implementation "w_hash.h"
#define IMPLEMENTATION_W_HASH_H

#pragma implementation "w_list.h"
#define IMPLEMENTATION_W_LIST_H

#pragma implementation "w_cirqueue.h"
#pragma implementation "w_minmax.h"

#pragma implementation "rsrc.h"
#define IMPLEMENTATION_RSRC_H

#pragma implementation "hash_lru.h"
#define IMPLEMENTATION_HASH_LRU_H

#pragma implementation "auto_release.h"
#pragma implementation "w_autodel.h"

#include "sm_templates.h"
#endif
*/

// This nasty business arises because this file is
// #included from templates.h for WIN32.
// In so doing, there are cases where the following
// code is seen before xxx_thread.h (where XXX_NOTE_ERROR
// is defined). So we may need to put in a temp definition.
#ifndef XXX_TEMPLATES_H
#include "templates.h"
#endif
#ifndef XXX_NOTE_ERROR
#include "types.h"
inline void XXX_NOTE_ERROR(XxxErrCond X, const char*Y) 
{
  cerr << "Error no: " << X << ":" << Y << " in file " << __FILE__ << endl;
}
#endif

//
// Here are the various method definitions
//

// Methods of Stack
template <class Type> 
void XxxStack<Type>::PopStack(Type& TopValue) 
{
  ASSERT((!(IsEmpty()))); 
  TopValue = top->item;
  XxxStackFrame<Type> *tmp = top;
  top = top->next;
  height--;
  delete tmp;
  return;
 };

template <class Type> void XxxStack<Type>::PushStack(const Type& item) {
  XxxStackFrame<Type> *frame = new XxxStackFrame<Type>(item);
  if (IsEmpty()) top = frame;
  else {
    frame->next = top;
    top = frame;
   }
  height++;
 };
template <class Type> void XxxStack<Type>::ApplyToDepth
 (int Depth, void (*Func)(Type&, void *), void *Arg) {
  XxxStackFrame<Type> *temp = top;
  
  while (temp && (Depth != 0)) {
    Func(temp->item, Arg);
    temp = temp->next;
    Depth--;
   }
 }

// Methods of Array

template <class Type>
int XxxRootArray<Type>::Find(const Type& Match) const
{
 for (int i = 0; i < arraySize; i++)
   if (Equal(Match, memberArray[i]))
     return i;
 return -1;
}

// Methods of Array
template <class Type>
void XxxRootArray<Type>::Grow()
{
 // need to reallocate
 int OldArraySize = arraySize;
 arraySize = arraySize*incrRatio;
 Type* newArray = new Type[arraySize];
 for (int i = 0; i < OldArraySize; i++)
   newArray[i] = memberArray[i];
 delete [] memberArray;
 memberArray = newArray;
}

// Move this here so that the Stack definitions in env.h go thru okay
#include "xxx_thread.h"
// Methods of MultiSet
template <class Type> 
XxxBool XxxMultiSet<Type>::FindItem(int (*Func)(const Type&, void*), 
				    void* Arg, 
				    Type& ReturnItem) const 
{
 XxxSetCursor SCsr; Type TestItem;
 XxxErrCode rc = XXX_OK;
 XxxBool Found = XXX_FALSE;

 if ((rc = InitCursor(SCsr)) != XXX_OK) {
   XXX_NOTE_ERROR(XXX_BADCURSOR, "Inside FindItem");
   return XXX_FALSE;
  }
 for (rc = NextItem(SCsr, TestItem); 
      (rc == XXX_OK) && (SCsr.IsValid() == XXX_TRUE) ; 
      rc = NextItem(SCsr, TestItem)){
   if (Func(TestItem, Arg) == XXX_TRUE) {
     ReturnItem = TestItem;
     Found = XXX_TRUE;
     break;
    }
  }

 if (((rc==XXX_OK)?rc = CloseCursor(SCsr):rc) != XXX_OK) {
   XXX_NOTE_ERROR(XXX_BADCURSOR, "Inside ApplyAll");
   Found = XXX_FALSE;
  }

 return Found;
}

template <class Type> 
void XxxMultiSet<Type>::ApplyAll(int (*Func)(Type&, void*),
				 void* Arg)
{
 XxxSetCursor SCsr; Type TestItem;
 XxxErrCode rc = XXX_OK;
 if ((rc = InitCursor(SCsr)) != XXX_OK) {
   XXX_NOTE_ERROR(XXX_BADCURSOR, "Inside ApplyAll");
   return;
  }
 for (rc = NextItem(SCsr, TestItem); (SCsr.IsValid()==XXX_TRUE) && (rc==XXX_OK); 
      rc = NextItem(SCsr, TestItem))
   Func(TestItem, Arg);
 
 if (((rc==XXX_OK)?rc = CloseCursor(SCsr):rc) != XXX_OK) {
   XXX_NOTE_ERROR(XXX_BADCURSOR, "Inside ApplyAll");
  }
}

template <class Type> 
int XxxMultiSet<Type>::ApplyFirst(int (*Func)(Type&, void*), 
				  void* Arg)
{
 XxxSetCursor SCsr; Type TestItem;
 int Applied = 0;

 XxxErrCode rc = XXX_OK;
 if ((rc = InitCursor(SCsr)) != XXX_OK) {
   XXX_NOTE_ERROR(XXX_BADCURSOR, "Inside ApplyFirst");
   return 0;
  }
 for (rc = NextItem(SCsr, TestItem); 
      (rc == XXX_OK) && (SCsr.IsValid() == XXX_TRUE); 
      rc = NextItem(SCsr, TestItem))
   if (Func(TestItem, Arg)) {
     Applied = 1;
     break;
    }

 if (((rc==XXX_OK)?rc = CloseCursor(SCsr):rc) != XXX_OK) {
   XXX_NOTE_ERROR(XXX_BADCURSOR, "Inside ApplyAll");
   Applied = 0;
  }
 return Applied;
}

template <class Type> 
XxxErrCode XxxMultiSet<Type>::AddItem(const Type& item) {
  if (checkDupl) {
    if (IsMember(item) == XXX_TRUE) {
      XXX_NOTE_ERROR(XXX_SETDUPL, "");
      return XXX_NOT_OK;
     }
   }
  setCount++;
  return addItem(item);
 }

// Methods of Table
template <class Type>
XxxRootTable<Type>::~XxxRootTable()
{
 // delete all valid entries
 // PRD_W32 : uncommenting this causes a memory error (crops up on NT)
 // TODO:L1
 // delete [] regItems; 
 delete [] valid;
}

template <class Type>
void XxxRootTable<Type>::Init() 
{
 for (int i = 0; i < regMax; valid[i++] = XXX_FALSE);
}

template <class Type> 
XxxErrCode XxxRootTable<Type>::addItem(const Type &Item)
{
 XxxErrCode rc = XXX_NOT_OK;

 if (regCount >= regMax-1) {
   // Extend this to do extensible hashing
   XXX_NOTE_ERROR(XXX_OVFLO, "No more space in hash table!");
   return XXX_NOT_OK;
  }
 else {
   // use open hashing on registry item
   //int hashPos = Item.Hash();
   int hashPos = Hash(Item);
   int i = hashPos;
   while ((valid[(i % regMax)] == XXX_TRUE) && 
	  (((i+1) % regMax) != (hashPos % regMax))) {
     i++;
    }
   if (valid[(i % regMax)] == XXX_FALSE) {
     valid[(i % regMax)] = XXX_TRUE;
     regItems[(i%regMax)].fill(Item);
     //regCount++; Use when extend for extensible hashing. should RemoveItem decrement regCount then?
     rc = XXX_OK;
    }
   // NOTE: The else case should never happen
  }
 return rc;
}

template <class Type> 
XxxErrCode XxxRootTable<Type>::RemoveItem(const Type &Item)
{
 int hashPos = Hash(Item);
 int i = hashPos;
 for (; ((i%regMax != hashPos%regMax)||(i==hashPos)); i++) {
   //PHILIPPE: WHEN AN ITEM IS REMOVED - SHOULDN'T THE HASH TABLE BE REORGANIZED?
	 if (valid[i%regMax] == XXX_FALSE) {
     XXX_NOTE_ERROR(XXX_SETDUPL, "Deleting non-existent element");
     return XXX_NOT_OK;
   }
   if (Equal(regItems[i%regMax].item,Item)) {
     valid[i%regMax] = XXX_FALSE;
	 setCount--;
     return XXX_OK;
    }
  }
 return XXX_NOT_OK;
}

struct tableCsrState : public XxxSetCursor::CursorState {
  int Index;
  tableCsrState() { Index = 0;}
};

template <class Type> 
XxxErrCode XxxRootTable<Type>::InitCursor(XxxSetCursor& SCsr) const 
{
  SCsr.State = new tableCsrState;
  SCsr.AtEnd = XXX_FALSE;
  return XXX_OK;
}

template <class Type> 
XxxErrCode XxxRootTable<Type>::CloseCursor(XxxSetCursor& SCsr) const 
{
  if (SCsr.State) delete SCsr.State;
  SCsr.AtEnd = XXX_TRUE;
  return XXX_OK;
}

template <class Type> 
XxxErrCode XxxRootTable<Type>::NextItem(XxxSetCursor& SCsr, 
					Type& ReturnItem) const
{
 if (SCsr.IsValid() != XXX_TRUE) {
   XXX_NOTE_ERROR(XXX_BADCURSOR, "");
   return XXX_NOT_OK;
 }

 tableCsrState* CsrState = (tableCsrState *)(SCsr.State);
 for (int i = CsrState->Index; i < regMax; i++) {
   if (valid[i] == XXX_TRUE) {
     ReturnItem = regItems[i].item;
     CsrState->Index = i+1;
     return XXX_OK;
    }
  }
 SCsr.AtEnd = XXX_TRUE;
 return XXX_OK;
}

template <class Type>
XxxBool XxxRootTable<Type>::FindTableItem(const Type& PatternItem, 
					  Type& ReturnItem) const
{
 int hashPos = Hash(PatternItem);
 int i = hashPos;
 for (; ((i%regMax != hashPos%regMax)||(i==hashPos)); i++) {
   // Philippe: 05/25
   if (valid[(i % regMax)] == XXX_FALSE)
     return XXX_FALSE;
   if (Equal(regItems[(i % regMax)].item,PatternItem)) {
     ReturnItem = regItems[(i % regMax)].item;
     return XXX_TRUE;
    }
  }
 return XXX_FALSE;
}


template <class Type>
XxxPtrTable1<Type>::XxxPtrTable1(int Size):XxxRootTable<Type>(Size)
{
  int i;
  // create and initialize to NULL
  for (i = 0; i < Size; i++) {
	  valid[i] = XXX_FALSE;
  }


  key = new int[Size];
  for (i = 0; i < Size; i++) {
	  key[i] = -1;
  }

  dupl = new XxxBool[Size];
  for (i = 0; i < Size; i++) {
	  dupl[i] = XXX_FALSE;
  }

  lastpos = new int[Size];
  for (i = 0; i < Size; i++) {
	  lastpos[i] = -1;
  }
}

template <class Type>
XxxPtrTable1<Type>::~XxxPtrTable1()
{
  delete [] key;
  delete [] dupl;
  delete [] lastpos;
}

template <class Type>
XxxErrCode XxxPtrTable1<Type>::addItem(const Type &Item)
{
  XxxErrCode rc = XXX_NOT_OK;

 //if (regCount >= regMax-1) {
   // Extend this to do extensible hashing
   //XXX_NOTE_ERROR(XXX_OVFLO, "No more space in hash table!");
   //return XXX_NOT_OK;
  //}
 //else {
   // use open hashing on registry item
   //int hashPos = Item.Hash();
   int hashPos = (Hash(Item))%regMax;
   int i = hashPos;

   while ((valid[(i % regMax)] == XXX_TRUE) && 
	  (((i+1) % regMax) != (hashPos % regMax))) {
     i++;
   }

   if (valid[(i % regMax)] == XXX_FALSE) {
      valid[(i % regMax)] = XXX_TRUE;
	  key[(i % regMax)]   = hashPos;
	  if (lastpos[hashPos] == -1) {
		//there are no duplicates
		lastpos[hashPos] = (i % regMax);
	  } else {
		// there are duplicates
		dupl[hashPos] = XXX_TRUE;
		lastpos[hashPos] = (i % regMax);
	  }
      regItems[(i%regMax)].fill(Item);
      //regCount++; Use when extend for extensible hashing. should RemoveItem decrement regCount then?
      rc = XXX_OK;
   }
   // NOTE: The else case should never happen
 //}
 return rc;
}

template <class Type>
XxxErrCode XxxPtrTable1<Type>::RemoveItem(const Type&Item) 
{
 int hashPos = (Hash(Item))%regMax;
 
 int deletePos;
 int FoundItem = 0;
 XxxBool ReorgLastPos = XXX_FALSE;
 
 if (lastpos[hashPos] == -1) return XXX_NOT_OK;

 if (lastpos[hashPos] == hashPos) {
   int i = hashPos;
   if (valid[i%regMax]) {
     if (Equal(regItems[i%regMax].item,Item)) {
       valid[i%regMax] = XXX_FALSE;
       key[i%regMax]   = -1;
       setCount--;

       dupl[hashPos] = XXX_FALSE;
       lastpos[hashPos] = -1;
       return XXX_OK;
     }
   }
 } else if (lastpos[hashPos] > hashPos) {
   // iterate from lastpos down to hashpos
   for (int i = lastpos[hashPos]; i >= hashPos; i--) {
     if (valid[i%regMax]) {
       if (Equal(regItems[i%regMax].item,Item)) {
         valid[i%regMax] = XXX_FALSE;
	 key[i%regMax]   = -1;
	 setCount--;

	 deletePos = i;
		
	 if (deletePos == lastpos[hashPos]) {
	   if (dupl[hashPos] == XXX_FALSE) {
	     lastpos[hashPos] = -1;
	     return XXX_OK;
	   } else {
	     ReorgLastPos = XXX_TRUE;
	   }
	 }

	 for (int j = lastpos[hashPos]; j >= hashPos; j--) {
	   if (key[j] == hashPos) {
	     if (FoundItem == 0 && ReorgLastPos) lastpos[hashPos] = j;
	     FoundItem ++;
	   }
	 }

	 if (FoundItem > 1) {
	   dupl[hashPos] = XXX_TRUE;
	 } else {
	   dupl[hashPos] = XXX_FALSE;
	 }
	 return XXX_OK;
       }
     }
   } // end for
 } else {
   // iterate from lastpos down to 0 and then from regMax down to hashPos
   for (int i = lastpos[hashPos]; i >= 0; i--) {
     if (valid[i%regMax]) {
       if (Equal(regItems[i%regMax].item,Item)) {
         valid[i%regMax] = XXX_FALSE;
	 key[i%regMax]   = -1;
	 setCount--;

	 deletePos = i;

	 if (deletePos == lastpos[hashPos]) {
	   lastpos[hashPos] = -1;
	   return XXX_OK;
	 } else {
	   ReorgLastPos = XXX_TRUE;
	 }

	 for (int j = lastpos[hashPos]; j > 0; j--) {
	   if (key[j] == hashPos) {
	     if (FoundItem == 0 && ReorgLastPos) lastpos[hashPos] = j;
	     FoundItem ++;
	   }
	 }
	 for (int j = (regMax -1); j > hashPos; j--) {
	   if (key[j] == hashPos) {
	     if (FoundItem == 0 && ReorgLastPos) lastpos[hashPos] = j;
	     FoundItem ++;
	   }
	 }

	 if (FoundItem > 1) {
	   dupl[hashPos] = XXX_TRUE;
	 } else {
	   dupl[hashPos] = XXX_FALSE;
	 }

	 return XXX_OK;
       }
     }
   } // end from lastpos down to 0
   for (int i = (regMax -1); i >= hashPos; i--) {
     if (valid[i%regMax]) {
       if (Equal(regItems[i%regMax].item,Item)) {
         valid[i%regMax] = XXX_FALSE;
	 key[i%regMax]   = -1;
	 setCount--;

	 deletePos = i;

	 if (deletePos == lastpos[hashPos]) {
	   lastpos[hashPos] = -1;
	   return XXX_OK;
	 } else {
	   ReorgLastPos = XXX_TRUE;
	 }

	 for (int j = lastpos[hashPos]; j > 0; j--) {
	   if (key[j] == hashPos) {
	     if (FoundItem == 0 && ReorgLastPos) lastpos[hashPos] = j;
	     FoundItem ++;
	   }
	 }
	 for (int j = (regMax -1); j > hashPos; j--) {
	   if (key[j] == hashPos) {
	     if (FoundItem == 0 && ReorgLastPos) lastpos[hashPos] = j;
	     FoundItem ++;
	   }
	 }

	 if (FoundItem > 1) {
	   dupl[hashPos] = XXX_TRUE;
	 } else {
	   dupl[hashPos] = XXX_FALSE;
	 }

	 return XXX_OK;
       }
     }
   } // end from regMax -1 downto hashPos
 }
 return XXX_NOT_OK;
}


template <class Type>
XxxBool XxxPtrTable1<Type>::FindTableItem(const Type& PatternItem, 
					                       Type& ReturnItem) const
{
 int hashPos = (Hash(PatternItem))%regMax;
 int i = hashPos;

 if (lastpos[hashPos] == -1) return XXX_FALSE;
 if (dupl[hashPos] == XXX_FALSE) {
	 ReturnItem = regItems[lastpos[hashPos]].item;
	 return XXX_TRUE;
 }

 for (; (((lastpos[i]>hashPos)&&((i % regMax)<lastpos[i])) || 
	     ((lastpos[i]<hashPos)&&(((i % regMax)>lastpos[i])&&((i % regMax)<hashPos)))); i++) {
	 if (valid[(i % regMax)] == XXX_TRUE) {
		 if (key[(i % regMax)] == hashPos && Equal(regItems[i%regMax].item,PatternItem)) {
			 ReturnItem = regItems[(i % regMax)].item;
		 }
       return XXX_TRUE;
    }
  }
  return XXX_FALSE;
}

template <class Type>
XxxBool XxxPtrTable1<Type>::FindTableItem1(const Type& PatternItem, 
					                       Type& ReturnItem) const
{
 int hashPos = (Hash(PatternItem))%regMax;
 int i = hashPos;

 if (lastpos[hashPos] == -1) return XXX_FALSE;
 /*
 if (dupl[hashPos] == XXX_FALSE) {
	 ReturnItem = regItems[lastpos[hashPos]].item;
	 return XXX_TRUE;
 }
*/
 if (lastpos[hashPos]==hashPos) {
	 ReturnItem = regItems[hashPos].item;
	 return XXX_TRUE;
 } else {
   for (; (((lastpos[i]>hashPos)&&((i % regMax)<lastpos[i])) || 
	     ((lastpos[i]<hashPos)&&(((i % regMax)>lastpos[i])&&((i % regMax)<hashPos)))); i++) {
	   if (valid[(i % regMax)] == XXX_TRUE) {
		 // no test for equality
		 if (key[(i % regMax)] == hashPos) {
			 ReturnItem = regItems[(i % regMax)].item;
		 }
         return XXX_TRUE;
	   }
    }
  }
  return XXX_FALSE;
}


template <class Type>
int XxxPtrArray<Type>::Equal(const Type& Entry1, const Type& Entry2) const
{ 
  return *(Entry1) == *(Entry2);
}


/* Jun 26: Win32 style - templates.C included into templates.h
#ifdef __GNUG__
#include "../server/env.h"
#include "../server/defeng.h"
#include "../utils/record.h"
#ifdef XXX_DEF_SEQADT
#include "../seqadt/execute/commands.h"
#include "../seqadt/storage/seqcat.h"
#include "../seqadt/storage/seqdata.h"
#include "../seqadt/compile/seqquery.h"
#include "../seqadt/storage/unixascii.h"
#include "../seqadt/storage/shoreseq.h"
#include "../seqadt/basic/order.h"
#endif
#ifdef XXX_DEF_RELADT
#include "../reladt/execute/commands.h"
#include "../reladt/compile/relquery.h"
#include "../reladt/storage/relcat.h"
#include "../reladt/storage/reldata.h"
#include "../reladt/basic/relenv.h"
#include "../reladt/storage/shorerel.h"
#endif // XXX_RELADT

*/


/* 
#endif // __GNUG__
*/

#endif // ! XXX_TEMPLATES_C
