//Bjarke, aug. 6: #pragma interface/implementation not needed any longer
//#ifdef __GNUG__
//#pragma implementation
//#endif

#include <iomanip.h>
#include "xxx_thread.h"
#include "client.h"
#include "engines.h"
#include "defeng.h"
#include <stdio.h>

#ifdef XXX_WIN32
#include <conio.h>
#include <process.h>
#define USE_MONITOR
#endif

//SMostafa:
//for SM
#include "stream-mgr.h"
//EMostafa

// defined in types.C
extern void XxxInitializeADTs();
extern void XxxTerminateADTs();
// defined in engines.C
extern void XxxInitializeEngines();
extern void XxxTerminateEngines();
// defined in utils.C
extern void XxxInitializeUtils();
extern void XxxTerminateUtils();
// defined in JavaUDF.C
extern XxxErrCode XxxExtendADTsWithJavaUDFs();
//SMostafa:
//for Stream Manager
StreamManagerThread* StrmMgr = NULL;
//EMostafa:
void SignalHandler(int recvd_signal)
{
 cerr << "Received signal no: " << recvd_signal << endl;
 // if it is not SIGINT, or if a SIGINT has already occurred once
 // exit the system
 if ((recvd_signal != SIGINT) ||
     (XXX_THISENV().Interrupt == XXX_TRUE)) {
   cerr << "Cannot recover from received signal" << endl;
   cerr << "Initiating shutdown procedures" << endl;
   
   // shutdown system before exiting :TODO:L2
   // 1) abort any current transaction
   // 2) close all open connections
   // 3) delete ShoreSM
   // 4) flush all open files
   
   cout << flush;
   cerr << flush;   
#ifdef XXX_DEBUG
   // install the default signal handlers and abort
#ifdef XXX_WIN32
   signal(SIGABRT, SIG_DFL);
   signal(SIGFPE, SIG_DFL);
   signal(SIGINT, SIG_DFL);
   // the next three are defunct for NT
   signal(SIGILL, SIG_DFL);
   signal(SIGSEGV, SIG_DFL);
   signal(SIGTERM, SIG_DFL);
#else
   for (int i = SIGINT; i < SIGPIPE; i++) {
     signal(i, SIG_DFL);
    }
#endif
   abort();
#else
   // try to exit gracefully
   exit(1);
#endif
  }
 else {
   XXX_THISENV().Interrupt = XXX_TRUE;
   XXX_THISENV().InterruptSignal = SIGINT;
   // currently, we do not really use this -- but we should : TODO:L2
  }
}

/*------------------------------------------------------------------
 Function Behaviour :: Exception handler for the new() system call

 Oddities/Quirks ::

 -------------------------------------------------------------------*/
void FreeStoreException()
{
 cerr << "freeStoreException:no more memory" << endl;
 exit(1) ;
}

//
// methods for the XXX init thread 
//
XxxInitThread::XxxInitThread(int argc, char** argv) :
  XxxBaseThread("init_thread"), SockNumber(atoi(argv[1])), 
  QuitCond("shutdown request"), Shut("XXX_down")
{
 valid = 1;
 XxxEnv.ProcessCommandLine(argc-1, argv+1);
 XxxEnv.Initialize(SignalHandler, FreeStoreException, SockNumber);
 if (XxxEnv.DebugFlags.Server) {
   cerr << " Created Init Thread" << endl;
 }
 W_COERCE(fork());
}

void XxxInitThread::ExecCode()
{
 XxxServerThread* ServerThread = NULL;
#ifdef USE_MONITOR
 XxxMonitorThread* MonitorThread = NULL;
#endif

#ifdef XXX_JAVA_VIRTUAL_MACHINE
  // create the JVM
  if (XXX_THISENV().StartJVM() != XXX_OK) {
    // cerr << "JVM not created." << endl;
  }

  // create remote connection with remote exec engine
  if (XXX_THISENV().StartRemoteExecEngine() != XXX_OK) {
	  cerr << "Remote Exec Engine not created." << endl;
  }
#endif

 // this order is important
 // Utils come first, because the engines depend on them
 // Specially, the SHORE storage manager
 if (XXX_THISENV().DebugFlags.Server) {
   cerr << " Executing Init Thread" << endl;
 }

 XxxInitializeUtils();
 if (XXX_CHECK_ERROR("Error in Initialization of Utils")) {
   cerr << "Exiting initialization thread" << endl;
   XxxTerminateUtils();
   Shut.Signal();
   goto exit_init;
  }


 // Next, the global type table is initialized (since it is shared by the
 // various engines). Optionally, each engine could maintain its own type table
 XxxInitializeADTs();
 if (XXX_CHECK_ERROR("Error in Initialization of ADTs")) {
   cerr << "Exiting initialization thread" << endl;
   XxxTerminateADTs();
   XxxTerminateUtils();
   Shut.Signal();
   goto exit_init;
  }

 // Next, since the global type table is initialized, we can extend it with
 // standard Java UDFs. This is defined in JavaUDF.C
 if (XxxExtendADTsWithJavaUDFs() != XXX_OK)
   cerr << "No extension with Java UDFs.\n";

 // Now create the engines (and register them with the appropriate types)
 XxxInitializeEngines();
 if (XXX_CHECK_ERROR("Error in Initialization of Engines")) {
   cerr << "Exiting initialization thread" << endl;
   XxxTerminateEngines();
   XxxTerminateADTs();
   XxxTerminateUtils();
   Shut.Signal();
   goto exit_init;
  }

#ifdef XXX_DEF_COUGAR
  // starts proxy server manager
  if (XXX_THISENV().StartProxyServers() != XXX_OK) {
	 cerr << "ProxyServerManager not created" << endl;
  }
#endif


//  if (XxxEnv.CreateEnvs() != XXX_OK) {
//    XXX_PRINT_ERROR(*(XXX_THISENV().ErrorStr), 
// 		   "Init:Error creating envs");
//    XXX_CLEAR_ERROR();
//   }

#ifdef USE_MONITOR
 //if (isatty(0)) {
 if (1) {
   MonitorThread = new XxxMonitorThread("XXXSERV> ", XXX_THISENV(), QuitCond);
   if (!MonitorThread || !MonitorThread->Valid())  {
     cerr << "cannot create monitor thread!" << endl;
     XxxTerminateEngines();
     XxxTerminateADTs();
     XxxTerminateUtils();

     XXX_CHECK_ERROR("Error in Termination of Init Thread");
     
     Shut.Signal();
     goto exit_init;
     // W_FATAL(ss_m::eOUTOFMEMORY);
    }
  }
#endif

 ServerThread = new XxxServerThread(SockNumber, XXX_THISENV());
 if (!ServerThread || !ServerThread->Valid())  { 
   cerr << "cannot create server thread!" << endl;
   XxxTerminateEngines();
   XxxTerminateADTs();
   XxxTerminateUtils();
   
   XXX_CHECK_ERROR("Error in Termination of Init Thread");
   
   Shut.Signal();
   goto exit_init;
   // W_FATAL(ss_m::eOUTOFMEMORY);
  }

 if (XXX_THISENV().DebugFlags.Server) {
   cerr << " Init Thread sleeping till shutdown" << endl;
 }

 // SMostafa:
 // run the SM
 StrmMgr = new StreamManagerThread(MAX_SUPPORTED_STREAMS);
 // EMostafa

 // Sleep till shutdown
 if (QuitCond.Wait() != XXX_OK) {
   cerr << "error waiting for shutdown condition variable!" << endl;
   goto exit_init;
  }

 if (XXX_THISENV().DebugFlags.Server) {
   cerr <<  "Shutting down!" << endl;
 }

#ifdef USE_MONITOR
 MonitorThread->ShutDown();
 W_COERCE(MonitorThread->wait(::WAIT_FOREVER));
 delete MonitorThread;
#endif

 ServerThread->ShutDown();
 W_COERCE(ServerThread->wait(::WAIT_FOREVER));
 delete ServerThread;

 // SMostafa: SM
 // for stream manager
 StrmMgr->cleanup();
 StrmMgr->ShutDown();
 W_COERCE(StrmMgr->wait(::WAIT_FOREVER));
 delete StrmMgr;

 // EMostafa:

 // Cleans up all XXX data structures
 // Probably need to bracket the first two by 
 // a transaction!
 XxxTerminateEngines();
 XxxTerminateADTs();
 XxxTerminateUtils();

#ifdef XXX_DEF_COUGAR
 // shuts down proxy server manager
 if (XXX_THISENV().ShutProxyServers() != XXX_OK) {
	 cerr << "ProxyServerManager not deleted" << endl;
 }
#endif

 XXX_CHECK_ERROR("Error in Termination of Init Thread");

 Shut.Signal();

#ifdef XXX_JAVA_VIRTUAL_MACHINE
  // close the JVM
  if (XXX_THISENV().ShutJVM() != XXX_OK) {
    // cerr << "Error closing JVM" << endl;
  }
  if (XXX_THISENV().ShutRemoteExecEngine() != XXX_OK) {
	  cerr << "Error closing RemoteExecEngine" << endl;
  }
#endif

exit_init:
  return;
}

XxxInitThread::~XxxInitThread()
{
  // There is no current thread, and hence no XXX_THISENV()
  // if (XXX_THISENV().DebugFlags.Server) {
 if (1) {
  cerr << "Shutdown Init Thread!" << endl;
 }
}

//
// methods for the server socket thread 
//
XxxServerThread::XxxServerThread(int PortNumber, const XxxEnvironment& DefaultEnv) : 
  XxxBaseThread(DefaultEnv, "server_thread"), 
  Connection(PortNumber), Shut("Server_down")
{
 if (Connection.Valid()) valid = 1;
 else {
   cerr << "Unable to bind port " << PortNumber << "." << endl;
   return;
 }
 // file handle on connection socket
#if !defined(XXX_WIN32) || (defined(XXX_WIN32) && !defined(XXX_NONPREEMPTIVE)) 
  fileHandle = new sfile_read_hdl_t(Connection.socketDesc);
#else
 // XXX_WIN32 && XXX_NONPREEMPTIVE
   handle = CreateEvent(NULL, TRUE, FALSE, NULL);
   WSAEventSelect(Connection.socketDesc, handle, FD_ACCEPT);
   eventHandle = new win32_compat_event_t(handle);
#endif

 if (XXX_THISENV().DebugFlags.Server) {
   cerr << "Creating listener socket port " << PortNumber << endl;
 }
 ServerPortNumber = PortNumber;
 if (valid) W_COERCE(fork());
}

void XxxServerThread::ExecCode()
{
 if (!valid) return;

#ifdef XXX_JAVA_VIRTUAL_MACHINE
 // create the JVM
 if (XXX_THISENV().StartJVM() != XXX_OK) {
   // cerr << "JVM not created." << endl;
 }
#endif

 XxxSocketConnection* ConnectSock;
 if (XXX_THISENV().DebugFlags.Connection) {
   cerr << "waiting for clients!" << endl;
 }

 // For automatic tests, provide an external indication of this
 // by creating a dummy file in /tmp
 // TODO: so far, this is only used on Unix, not on NT
 ofstream OFStream; char DummyBuf[200];
 sprintf(DummyBuf, "/tmp/xxx_dummy.%d", ServerPortNumber);
 OFStream.open(DummyBuf); OFStream.close();

 while (1) {
#if defined(XXX_WIN32) && !defined(XXX_NONPREEMPTIVE)
   // no need to wait with Preemptive threads : 
   if (fileHandle->is_down()) break;
#else
#ifndef XXX_WIN32
   if (fileHandle->is_down() || (bool) fileHandle->wait(::WAIT_FOREVER)) break;
#else
	// XXX_WIN32 && XXX_NONPREEMPTIVE
   if (eventHandle->is_down() || (bool) eventHandle->wait(::WAIT_FOREVER)) break;
   ResetEvent(handle);
#endif
#endif
   // if it reaches here, this means that a new connection is pending
   if ((ConnectSock = Connection.AcceptConnection())) {
     if (XXX_THISENV().DebugFlags.Connection) {
       cerr << "Connection established." << endl;
     }
   }
   else {
     if (XXX_THISENV().DebugFlags.Connection) {
       cerr << "Bad connection!" << endl;
     }
     continue;
   }
   // Spawn a request thread
   XxxRequestThread* NewThread = NULL;
   NewThread = new XxxRequestThread(ConnectSock, XXX_THISENV());
   if (!NewThread) {
     cerr << "Error creating new thread!" << endl;
     delete ConnectSock;
     continue;
   }
 }
 if (XXX_THISENV().DebugFlags.Server) {
   cerr << "Broke out of server loop!" << endl;
 }
   
 unlink(DummyBuf);

 // tell the init thread that XXX is done
 Shut.Signal();

#ifdef XXX_JAVA_VIRTUAL_MACHINE
 // close the JVM
 if (XXX_THISENV().ShutJVM() != XXX_OK) {
   //cerr << "JVM could not be closed" << endl;
 }
#endif

}

XxxServerThread::~XxxServerThread()
{
 if (XXX_THISENV().DebugFlags.Server) {
   cerr << "Shutdown Server Thread!" << endl;
 }
}


//
// methods for the stdin input monitor thread 
//
const char* XXX_MON_SHUTDOWN = "shutdown";

XxxMonitorThread::XxxMonitorThread(const char* Prompt, const XxxEnvironment& DefaultEnv, XxxCondVar& QCond) : 
  XxxBaseThread(DefaultEnv, "monitor_thread"),
  QuitCond(QCond), Shut("Monitor_down")
{
 valid = 1;
 // file handle on stdin
#if !defined(XXX_WIN32) || (defined(XXX_WIN32) && !defined(XXX_NONPREEMPTIVE))
 fileHandle = new sfile_read_hdl_t(0);
#else
 // XXX_WIN32 && XXX_NONPREEMPTIVE
 // SHORE V2 - NEW I/O

 HANDLE handle = CreateFile("CONIN$", GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
  SetConsoleMode(handle, ENABLE_LINE_INPUT|ENABLE_ECHO_INPUT|ENABLE_PROCESSED_INPUT);
 eventHandle  = new win32_compat_event_t(GetStdHandle(STD_INPUT_HANDLE));
#endif

 strncpy(prompt, Prompt, XXX_TEXTSTRING_MAX-1);
 prompt[XXX_TEXTSTRING_MAX-1] = 0;
 if (XXX_THISENV().DebugFlags.Server) {
   cerr << " Created Monitor Thread" << endl;
 }
 W_COERCE(fork());
}

void XxxMonitorThread::ExecCode()
{
#ifdef USE_MONITOR
  // create the JVM

#ifdef XXX_JAVA_VIRTUAL_MACHINE
  if (XXX_THISENV().StartJVM() != XXX_OK) {
    //cerr << "JVM not created" << endl;
  }
#endif

 if (XXX_THISENV().DebugFlags.Server) {
   cerr << " Executing Monitor Thread" << endl;
 }

#if defined(XXX_CYGWIN)
 // Bjarke, feb. 11 2002
 // Lets eat a char before entering the while loop because 'enter' 
 // in the cygwin shell sends CR/LF, but the shell only eats CR, 
 // thereby passing LF to predServer. This causes predServer to enter a loop 
 // until a new 'enter' is received. We don't want that.
 { 
   INPUT_RECORD iRecord;
   DWORD nbread;
   char event[3];
   ReadConsoleInput(GetStdHandle(STD_INPUT_HANDLE), &iRecord, 1, &nbread);
   cout << hex << iRecord.Event.KeyEvent.wVirtualKeyCode << endl;
   //itoa(iRecord.Event.KeyEvent.wVirtualKeyCode, event,3);
   //::write(1, event, 3);
 }
#endif

			   char Input[200];
 XxxBool ReadableInput = XXX_TRUE;
 while (1) {
   if (ReadableInput)
		::write(1, prompt, strlen(prompt));

   int BytesRead;

   // TODO: make sure to define XXX_NONPREEMPTIVE somewhere for Unix
#if defined(XXX_WIN32) && !defined(XXX_NONPREEMPTIVE)
   // no need to wait with Preemptive threads : 
   if (fileHandle->is_down()) break;
   BytesRead = ::read(0, Input, sizeof(Input)-1);
#else
#ifndef XXX_WIN32
   if (fileHandle->is_down() || (bool)fileHandle->wait(::WAIT_FOREVER)) break;
   BytesRead = ::read(0, Input, sizeof(Input)-1);
#else
   if (eventHandle->is_down() || (bool) eventHandle->wait(::WAIT_FOREVER)) break;

   INPUT_RECORD iRecord;
   DWORD nbread;
   PeekConsoleInput(GetStdHandle(STD_INPUT_HANDLE), &iRecord, 1, &nbread);
   if (iRecord.EventType == KEY_EVENT)
   {
		if (iRecord.Event.KeyEvent.wVirtualKeyCode < VK_F1 || iRecord.Event.KeyEvent.wVirtualKeyCode > VK_F10)
		{
			// if the key pressed is not a function key
			ReadableInput = XXX_TRUE;
			ReadFile(GetStdHandle(STD_INPUT_HANDLE), Input, sizeof(Input)-1, (unsigned long*)&BytesRead, NULL);
		}
		else
		{
			ReadableInput = XXX_FALSE;
			ReadConsoleInput(GetStdHandle(STD_INPUT_HANDLE), &iRecord, 1, &nbread);

		}
   }
   else
   {
		ReadableInput = XXX_FALSE;
		ReadConsoleInput(GetStdHandle(STD_INPUT_HANDLE), &iRecord, 1, &nbread);
   }
#endif
#endif
   if (ReadableInput) {
	if (BytesRead < 0) {
		// W_FATAL(ss_m::eOS);
		if (XXX_THISENV().DebugFlags.Server) {
		 if (XXX_THISENV().DebugFlags.Server) {
			cout << "End of input --- closing monitor" << endl;
		 }
		}
		break;
		}
	if (!BytesRead || 
		!strncmp(Input, XXX_MON_SHUTDOWN, strlen(XXX_MON_SHUTDOWN))) {
		// eof on socket, or ShutDown command
		int ClientCount = ((XxxDefaultEngine*)XxxDBEngine::DefaultDBEngine())->NumClients();
		if (ClientCount) {
			cout << "Cannot shutdown with " << ClientCount << " clients!" << endl;
		}
		else {
			if (XXX_THISENV().DebugFlags.Server) {
				cout << "Shutting down ..." << endl;
			}
			// this should cause the next fileHandle->wait() to return non-zero
			 // thus implementing the break
			QuitCond.Signal();
//#if defined(XXX_WIN32) && !defined(XXX_NONPREEMPTIVE)
       // Need to explicitly break here, because we dont call wait().
       // Maybe, in any case, we can always break here?
			break;
//#endif
		}	
    }
	else {
		Input[BytesRead] = 0;
		char TmpBuf[200];
		strcpy(TmpBuf, "XXX:");
		strcat(TmpBuf, Input);
		// interpret the input and perform the desired monitor action
		XxxBasicType Dummy1; XxxGenericParse* Dummy2;
		if (XxxDBEngine::DefaultDBEngine()->ExprParse(TmpBuf, NULL, Dummy1, Dummy2)
			!= XXX_OK) {
			XXX_NOTE_ERROR(XXX_BADPARSE, Input);
		}
		XXX_CHECK_ERROR("Error in monitor command");

		*(XXX_THISENV().ErrorStr) << flush;
		*(XXX_THISENV().OutputStr) << flush;
	}
   } // if readable input
 } // while
 if (XXX_THISENV().DebugFlags.Server) {
   cerr << "Broke out of monitor loop!" << endl; 
 }

 // tell the init thread that XXX is done
 Shut.Signal();
#ifdef XXX_JAVA_VIRTUAL_MACHINE
 // close the JVM
 if (XXX_THISENV().ShutJVM() != XXX_OK) {
   // cerr << "Error closing JVM" << endl;
 }
#endif


#endif // monitor
}

XxxMonitorThread::~XxxMonitorThread()
{
 if (XXX_THISENV().DebugFlags.Server) {
   cerr << "Shutdown Monitor Thread!" << endl;
 }
}
/* Commented by Tobias (10-9-98) 
   Praveen implemented these functions somewhere else.
#ifdef XXX_WIN32
////////// Junk here : to avoid recompile of shore
void sfile_write_hdl_t::shutdown() {
  _isdown = true;
  // shutdown the socket: this will cause wait() to fail
  ::shutdown(_fd, SD_SEND);
  closesocket(_fd);
};

void sfile_read_hdl_t::shutdown() {
  _isdown = true;
  // shutdown the socket: this will cause wait() to fail
  ::shutdown(_fd, SD_RECEIVE);
  closesocket(_fd);
};

#endif
*/
