#include "BoundingBox.h"

XxxBoundingBox::XxxBoundingBox()
  : dimension_type(XXX_UNKNOWN), box(NULL)
{
}
  
// Default constructor. Takes 3 arguments
// dim -> number of dimensions for BB
// type -> type of the dimensions
// box -> pointer to an array of the specified type.

XxxBoundingBox::XxxBoundingBox(const int dim,const XxxBasicType type,void *_box)
  : dimension_type(type)
{
  box = NULL;   // Set box to NULL in case it is not allocated
  if (dim==2)   // Only 2 dimensional boxes supported right now
    {
      if (dimension_type == XXX_INT)
	{
	  box = new nbox_t(2,(int *)_box);  
	  // test to see what happens if array is longer than 4.
	}
      else if (dimension_type == XXX_DOUBLE)
	{
	  int i,data[4];
	  
	  // cast double array into int array
	  for (i=0;i<4;i++)
	    data[i]=(int) ( ((double *)_box)[i] );

	  box = new nbox_t(2,data);
	}
      else
	cerr << "Cannot create bounding box of type " << type << endl;
    }
  else
    cerr << "Only 2 dimensional boxes are supported at this time" << endl;
}

XxxBoundingBox::XxxBoundingBox(const nbox_t& _box)
  : dimension_type(XXX_INT)
{
  box = new nbox_t(_box);
}
  

// copy constructor

XxxBoundingBox::XxxBoundingBox(const XxxBoundingBox& B)
  : dimension_type(B.dimension_type)
{
  box = new nbox_t(*B.box);
}

// assignment operator

XxxBoundingBox&
XxxBoundingBox::operator=(const XxxBoundingBox& B) 
{
  if (this == &B)
    return *this;
  dimension_type=B.dimension_type;
  delete box;  // de-allocate old memory
  box= new nbox_t(*B.box);
  return *this;
}


// Destructor. De-allocates all the memory.


XxxBoundingBox::~XxxBoundingBox()
{
  delete box;
}

ostream& operator<<(ostream& s, const XxxBoundingBox& B)
{
  if (B.box != NULL)
    {
      int i;
      for (i=0;i<(2*B.Dimension());i++)
	s << B.box->bound(i) << " ";
      return s;
    }
  else
    return s;
}


	  





