// This DUMMY file is only used, if the JVM is not needed. 
// The actual definitions for the functions are in jaguar/JavaPlans.h and jaguar/JavaRemoteExecEngine.h
#ifdef XXX_JAVA_VIRTUAL_MACHINE

#include "../jaguar/JavaPlans.h"
#include "../jaguar/JavaRemoteExecEngine.h"

#else

#ifndef XXX_JAVAPLANS_H
#define XXX_JAVAPLANS_H

#include "record.h"
#include "values.h"
#include "expr.h"

typedef enum {TARGET_LOCAL, TARGET_CLIENT, TARGET_REMOTE} XxxJavaTargetType;

class XxxJavaTarget {
protected:
	XxxJavaTargetType Type;
	// categories to differenciate remote exec engines should be introduced here.
public:
	XxxJavaTarget(){}
	XxxJavaTarget(XxxJavaTarget *Target)
	{Type = Target->getType();}
	~XxxJavaTarget(){}

	void setTargetLocal()
	{Type = TARGET_LOCAL;}
	void setTargetClient()
	{Type = TARGET_CLIENT;}
	void setTargetRemote()
	{Type = TARGET_REMOTE;}

	XxxBool IsTargetLocal()
	{return (Type == TARGET_LOCAL);}
	XxxBool IsTargetClient()
	{return (Type == TARGET_CLIENT);}
	XxxBool IsTargetRemote()
	{return (Type == TARGET_REMOTE);}

	XxxJavaTargetType getType()
	{return Type;}
};

class XxxJavaExpression : public XxxValueExpression {

public:
	XxxJavaExpression(){}
	XxxJavaExpression(const XxxJavaExpression* JE){}
	~XxxJavaExpression(){}

	virtual XxxValueExpression * Replicate() const
    { return new XxxJavaExpression(*this); }
	virtual ValExprType ValType() const {return JAVA_EXPR;}
	virtual void Print(ostream&) const {}
	virtual XxxErrCode Optimize(XxxExprPlan*& ExecPlan){return XXX_NOT_OK;}
	virtual XxxErrCode TypeCheck(){return XXX_NOT_OK;}
	// Checks to see if the expression matches another expression
	virtual XxxBool Match(const XxxExpression* OtherExpr, 
		char *Env = NULL) const {return XXX_FALSE;}
};


class XxxJavaExprPlan : public XxxValueExprPlan 
{
public:
	XxxJavaExprPlan(XxxJavaTarget *JavaTarget, XxxValueExprPlan* Children[],
					XxxRecordSchema *Schema[], int NbInputs,
					XxxBasicType ResultType, XxxADTMetaInfo* ResultMetaInfo):
	XxxValueExprPlan(XxxValueExpression::BOOL_EXPR, NbInputs, XXX_FALSE, Children){}
	~XxxJavaExprPlan(){}


	XxxErrCode initializeJavaPlan()
	{return XXX_OK;}
	virtual XxxErrCode Evaluate(const XxxRecord* Rec[],
						const XxxRecordSchema* Schema[],
						XxxADTValue *Result, 
						const XxxValueEnv* Env = NULL) const
	{return XXX_OK;}

	virtual XxxGenericPlan * Replicate() const  {return NULL;}
};



class XxxJavaRemoteConnections {
public:
	class RemoteHosts {
	protected:
		struct RemoteJavaExecEngine {
			char Name[25];
			int  Port;
		};
		RemoteJavaExecEngine Hosts[1];
		int NbHosts;

	public:
		RemoteHosts(){NbHosts = 0;}
		~RemoteHosts(){}

		XxxErrCode Add(char* HostName, int Port);
		XxxErrCode Delete(char* HostName);
	};
public:
	XxxJavaRemoteConnections(RemoteHosts *HostsList);
	~XxxJavaRemoteConnections();


	XxxBool IsValid()
	{ return XXX_FALSE;}

};


class XxxRemoteExecEngine
{
public:
	XxxRemoteExecEngine(XxxJavaRemoteConnections *RemoteJavaConnections);
	~XxxRemoteExecEngine();

	XxxErrCode Send(int StreamId, int PacketType, char *ByteStream, int Size);
	XxxErrCode Recv(int StreamId, XxxRecord*& Rec);
};







#endif // XXX_JAVAPLANS_H
#endif // XXX_JAVA_VIRTUAL_MACHINE











