/* This file contains the XxxFunctionReport class.
 * It produces reports about registered UDFs 
 * @author Tobias Mayr (mayr@cs.cornell.edu)
 */

#ifndef XXX_REPORT_H
#define XXX_REPORT_H

#include "types.h"

/* Generates reports about registered UDFs and the state of the JVM. */
class XxxFunctionReport
{
private:

  static const int MAX_LENGTH;
  static const int MAX_NUM_CL;

  static int NumADTs;
  static XxxBasicType ADTs[];

  static bool everCalled;
  static bool newReport;
  static char *serverSiteFunctions;
  static char *endOfServerSiteFunctions;
  static char *clientSiteFunctions;
  static char *endOfClientSiteFunctions;
  static int numClassLoaders;
  static char **classLoaders;
  static char **endOfClassLoaders;

  //Bjarke, aug. 3: void return values added to functions
  static void checkInitialization();
  static void recollectInformation();
  static void deleteInformation();

public:
  
  static XxxErrCode PrintIncrementalReport(ostream *ostr);	
  static XxxErrCode PrintReport(ostream *ostr);

  static XxxErrCode AddMethod(XxxBasicType Type, XxxFuncMethodInfo *FMInfo);

};


#endif // XXX_REPORT_H

