#ifndef XXX_CASTEXPR_H
#define XXX_CASTEXPR_H
#include <iostream.h>
#include "expr.h"
#include "values.h"
#include "exprplan.h"
#include "record.h"

/**
 * Models all casts of value expressions
 */
class XxxCastValueExpression : public XxxValueExpression {
  friend class CastPlan;
 protected:
 public:
  //// Plan for cast expressions
  class CastPlan : public XxxValueExprPlan { public:
    XxxADTValue* StoredConstVal; // for one time evaluation of constants
    XxxBasicType InType;
    XxxADTValue* ChildAnswer;
    XxxADTMetaInfo *ChildCatInfo;

    CastPlan(XxxCastValueExpression* CastExpr,
	     XxxValueExprPlan* ChildPlan);
    CastPlan(const CastPlan &Plan);
    virtual XxxGenericPlan * Replicate() const {
      return (XxxGenericPlan *)(new CastPlan(*this));
    }    
    virtual ~CastPlan() {
      delete ChildAnswer;
      if (StoredConstVal) delete [] ((char*)StoredConstVal);
     }

    virtual XxxErrCode PreCompute();
    virtual XxxErrCode Evaluate(const XxxRecord* Rec[],
				const XxxRecordSchema* Schema[],
				XxxADTValue *Result,
				const XxxValueEnv* Env = NULL) const;
   };
  XxxBasicType CastType;
  XxxCastValueExpression(XxxBasicType CastTyp,
			 XxxADTMetaInfo* MetaInfo,
			 XxxExpression* Child);
  XxxCastValueExpression(const XxxCastValueExpression& src);
  /// Provides a convenient way to copy arbitrary expressions
  virtual XxxExpression *Replicate() const 
    { return new XxxCastValueExpression(*this); }

  virtual ValExprType ValType() const {return CAST_EXPR;}
  virtual void Print(ostream&) const;
  virtual XxxErrCode Optimize(XxxExprPlan*& ExecPlan);
  virtual XxxErrCode TypeCheck();

  // Check to see if matches other expression
  virtual XxxBool Match(const XxxExpression* OtherExpr, 
			char *Env = NULL) const;
 };

#endif
