#include "filestream.h"

XxxFileStream::XxxFileStream(int fileet) 
: ostream(&sBuffer), sBuffer(theBuffer, 1024, fileet, this) 
{
  // Makes sure that the fileet is in non-blocking mode
#ifdef SOLARIS2
 /*
 if (fcntl(fileet,f_SETFL,O_NONBLOCK) == -1) { 
   cerr << "Warning: Unable to set non-blocking I/O to client" << endl;
  }
 */
#else
 cerr << "Warning: OS not supported yet, need to implement function to set non-blocking I/O"
   << endl;
#endif
}

XxxFileStreamBuf::XxxFileStreamBuf(char *theBuf, int len, int file,
				   XxxFileStream *owner) 
: streambuf() 
{
  this->owner = owner;
  fd = file;

#if defined(XXX_WIN32) && defined(XXX_NONPREEMPTIVE)
  eHandle = NULL;
  // eHandle is initialized just before it is used - not clear why!
#else
  fHandle = new sfile_write_hdl_t(fd);
#endif

  setbuf(theBuf,len); // set the "reserve" buffer area
  setp(theBuf,theBuf+len); // set the output buffer area
}

XxxFileStreamBuf::~XxxFileStreamBuf() 
{ 
#if defined(XXX_WIN32) && defined(XXX_NONPREEMPTIVE)
	if (eHandle)
		delete eHandle;
#else
	if (fHandle)
		delete fHandle;
#endif
}

int XxxFileStreamBuf::overflow(int nCh) 
{ 
  if (!(owner->good()))
    return EOF;
  int sent;
  char *currBuffer;
  int len = pptr() - pbase();
  currBuffer = pbase();
  while (len != 0) {
#if defined(XXX_WIN32) && defined(XXX_NONPREEMPTIVE)
    handle = CreateEvent(NULL, TRUE, FALSE, NULL);
    WSAEventSelect(fd, handle, FD_WRITE);
    eHandle = new win32_compat_event_t(handle);

    if (eHandle->is_down() ||	(bool)eHandle->wait(::WAIT_FOREVER))
#else
    if (fHandle->is_down() ||	(bool)fHandle->wait(::WAIT_FOREVER))
#endif
	{
      owner->clear(ios::badbit);
      return EOF;
    }

#if defined(Sparc) && defined(SOLARIS2)
    int CurrentFlags = fcntl(fd, F_GETFL);
    fcntl(fd, F_SETFL, O_NDELAY);
#endif
    sent = write(fd, currBuffer, len);
#if defined(Sparc) && defined(SOLARIS2)
    fcntl(fd, F_SETFL, CurrentFlags);
#endif
    if (sent == -1 || sent == 0) { 
      // Fileet Error or client closed connection
      owner->clear(ios::badbit);
      return EOF;
    }
    len -= sent;
    currBuffer += sent;
  }
  setp(pbase(),epptr());
  if (nCh != EOF) { 
    *(pptr()) = nCh;
    pbump(1);
  }
  return 0;
}

int XxxFileStreamBuf::underflow() 
{ 
 cerr << "XxxFileBuf: This is an output buffer, reading operations not supported" << endl; 
 return 0;
}

int XxxFileStreamBuf::sync() 
{ 
 return overflow(EOF);
}


