#ifndef XXX_FILESTREAM_H
#define XXX_FILESTREAM_H

#include <iostream.h>
#include <fcntl.h>
#include <sys/types.h>
#include "shoresm.h"

XXX_EXTERN_CLASS_DECL(XxxFileStream);

/**
 * Defines a stream buffer to be used for thread-safe output streams
 */
class XxxFileStreamBuf : public streambuf { 
public:
  XxxFileStreamBuf(char *buf, int len, int file,
		   XxxFileStream *owner);
  ~XxxFileStreamBuf();
  virtual int overflow(int nCh);
  virtual int underflow();
  virtual int sync();

private:
  int fd;
#if defined(XXX_WIN32) && defined(XXX_NONPREEMPTIVE)
  win32_compat_event_t *eHandle;
  HANDLE handle;
#else
  sfile_write_hdl_t *fHandle;
#endif

  XxxFileStream *owner;
};

/**
 * Defines a thread-safe output stream
 */
class XxxFileStream : public ostream { 
public:
  XxxFileStream(int fileet);
  ~XxxFileStream() {}
protected:
  // make a buffer of 1024 bytes
  char theBuffer[1024];
  XxxFileStreamBuf sBuffer;
  
};   

#endif // XXX_FILESTREAM_H




