#ifndef XXX_INLISTEXPR_H
#define XXX_INLISTEXPR_H
#include <iostream.h>
#include "expr.h"
#include "values.h"
#include "exprplan.h"

/**
 * Models IN List expression.
 */
class XxxInListExpression : public XxxBooleanExpression {
  friend class InListPlan;
 protected:
 public:
  //// Plan for in list expressions
  class InListPlan : public XxxBooleanExpressionPlan {
  public:
    XxxBasicType TargetType;
    XxxADTMetaInfo* TargetMetaInfo;
    XxxADTValue *TargetVal;
    XxxADTValue *ChoiceVal;

    InListPlan(XxxInListExpression* InListExpr,
	     XxxValueExprPlan* ChildrenPlan[]);
    InListPlan(const InListPlan &Plan);
    virtual ~InListPlan() {
      delete TargetVal; 
      delete ChoiceVal; 
    };
    virtual XxxGenericPlan * Replicate() const {
      return (XxxGenericPlan *)(new InListPlan(*this));
    }    
    virtual XxxErrCode Evaluate(const XxxRecord* Rec[],
				const XxxRecordSchema* Schema[],
				XxxADTValue *Result,
				const XxxValueEnv* Env = NULL) const;

/*
    static XxxErrCode ExprEval(const XxxADTValue* ArgL,
             XxxBasicType TypeL,
             const XxxADTMetaInfo* MetaInfoL,
             const XxxADTValue* ArgR,
             XxxBasicType TypeR,
             const XxxADTMetaInfo* MetaInfoR,
             XxxBool& ExprResult);
*/
   };

  XxxInListExpression(int NChildren,
		    XxxExpression* Children[]);
  XxxInListExpression(const XxxInListExpression& src);

  // Provides a convenient way to copy arbitrary expressions
  virtual XxxExpression *Replicate() const 
    { return new XxxInListExpression(*this); }

  virtual ValExprType ValType() const {return BOOL_EXPR;}
  virtual void Print(ostream&) const;
  virtual XxxErrCode Optimize(XxxExprPlan*& ExecPlan);
  virtual XxxErrCode TypeCheck();

  // Check to see if matches other expression
  virtual XxxBool Match(const XxxExpression* OtherExpr, 
			char *Env = NULL) const;
 };

#endif
