#ifndef XXX_LOOKUP_H
#define XXX_LOOKUP_H


#include <iostream.h>
#include <stdlib.h>

class keyValue
{
 public:
  keyValue(char *inKey=NULL,char *inValue=NULL)
    {
      key=inKey;
      value=inValue;
    }

  void display()
    {
      if (key != NULL)
		cout<<"\nKey: "<<key;
      else
		cout<<"\nKey: NULL";
      if (value != NULL)
		cout<<"\nValue: "<<value;
      else
		cout<<"\nValue: NULL";
		cout<<"\n";
    }

  char *key;
  char *value;
};

typedef keyValue *keyValuePtr;

class tupleItem
{
 public:
  tupleItem(keyValuePtr in_data,
	    tupleItem *in_next)
  {
    data=in_data;
    next=in_next;
  };
  keyValuePtr data;
  tupleItem *next;
};

class linkedList
{
 public:
  linkedList()
    {
      items=NULL;
      list_size=0;
    };

  int size()
    {return (list_size);}
  int isEmpty()
    {return(list_size==0);}
  void add(keyValuePtr new_item)
    {
        items= new tupleItem(new_item,items);
	list_size++;
    }
  void remove(char *in_item)
    {
      tupleItem **current=&items;
      
      while ((*current) !=NULL)
	{
	  char *tmp=(*current)->data->key;
	  if (strcmp(tmp,in_item))
	    {
	      tupleItem *tmp=*current;
	      *current=(*current)->next;
	      delete *current;
	    }
	  current=&((*current)->next);
	}
    }

  void display()
    {
      tupleItem *tmp;
      for (tmp=items;
	   tmp!=NULL;
	   tmp=tmp->next)
      tmp->data->display();
    }

  //Bjarke, aug. 8: const added to parameter type
  char *findValue(const char * in_string)
    {
      tupleItem *tmp;
      for (tmp=items;
	   tmp!=NULL;
	   tmp=tmp->next)
	if (strcmp(tmp->data->key,in_string)==0)
	 return (tmp->data->value);
      return (char *)(NULL);
    }
 private:
  tupleItem *items;
  int list_size;
};

typedef linkedList *linkedListPtr;



#endif



