/* Memory Mapping Wrapper

 *	Han Wang 11/21/97

 *

 * This class acts as a wrapper for memory mapping functions.

 * The functions are statically defined, so there is no need

 * to instantiate an object.

 * 

 * Usage:



 	void *MMapAddress;

	if ( MMapAddress = XXXMemoryMap::map(FileSize, FilDes) == NULL) {

		XXX_NOTE_ERROR(XXX_BADFILE, "Unable to mmap document file");

		return XXX_NOT_OK;

	}



 	if (XXXMemoryMap::unmap(MMapAddress, FileSize) == 0) {

		XXX_NOTE_ERROR(XXX_BADFILE, "Unable to munmaBADFILE, "Unable to munmap document file");

		return XXX_NOT_OK;

	}

 *

 */



#ifndef _MEMMAP_H_

#define _MEMMAP_H_



#ifndef _WIN32

#include <sys/types.h>

#include <sys/ipc.h>

#include <sys/mman.h>
#endif



#include "prd-config.h"

#include "xxx_thread.h"



/**

 * This is a wrapper for memory-mapped files

 */

class XxxMemoryMap {

public:

 XxxMemoryMap(const char* FileName);

 virtual ~XxxMemoryMap();

 XxxErrCode GetHandle(void*& MemHandle) const

  { MemHandle = memHandle;

    return ((valid && memHandle)?XXX_OK:XXX_NOT_OK);

  }

 XxxBool IsValid() const { return valid;}

 int Size() const { return fileSize;}

 XxxErrCode XxxMemoryMap::close();	

protected:

 XxxBool valid;

 void *memHandle;

 int fileSize;

#ifdef XXX_WIN32

 HANDLE fileHandle;

 HANDLE mapHandle;



 XxxErrCode map(HANDLE FileDes, 

                void *&MemHandle);

 XxxErrCode unmap(void *MemHandle);

#else

 int fileDes;



 XxxErrCode map(int FileDes, int FileSize,

                void *&MemHandle);

 XxxErrCode unmap(void *MemHandle, int FileSize);

#endif



};



#endif /* _MEMMAP_H_ */



