#include "misc.h"

//
// XxxBitMap
//
int XxxBitMap::NumBitsSet() const 
{
 int Counter = 0;
 for (unsigned char i = 0; i < ArraySize; i++) {
   if (BitArray[i]) Counter++;
  }
 return Counter;
}

void XxxBitMap::ClearAll()
{
 for (unsigned char i = 0; i < ArraySize; i++)
   ClearBit(i);
}
void XxxBitMap::SetAll()
{
 for (unsigned char i = 0; i < ArraySize; i++) 
   SetBit(i);
}

void XxxBitMap::Or(const XxxBitMap& BM1, XxxBitMap& ReturnBM) const 
{
 for (unsigned char i = 0; i < ArraySize; i++)  {
   if (GetBit(i) || BM1.GetBit(i))
     ReturnBM.SetBit(i);
   else
     ReturnBM.ClearBit(i);
  }
}

void XxxBitMap::And(const XxxBitMap& BM1, XxxBitMap& ReturnBM) const 
{
 for (unsigned char i = 0; i < ArraySize; i++)  {
   if (GetBit(i) && BM1.GetBit(i))
     ReturnBM.SetBit(i);
   else
     ReturnBM.ClearBit(i);
  }
}

void XxxBitMap::Xor(const XxxBitMap& BM1, XxxBitMap& ReturnBM) const 
{
 for (unsigned char i = 0; i < ArraySize; i++)  {
   if ((GetBit(i) || BM1.GetBit(i)) && !(GetBit(i) && BM1.GetBit(i)))
     ReturnBM.SetBit(i);
   else
     ReturnBM.ClearBit(i);
  }
}

void XxxBitMap::CopyBits(const XxxBitMap& BMap)
{
 // both should be of the same size or the
 // target should be larger than the source
 if (ArraySize >= BMap.ArraySize) {
   for (unsigned char i = 0; i < BMap.ArraySize; i++)  {
     BitArray[i] = BMap.BitArray[i];
    }
  }
}

void XxxBitMap::operator=(const XxxBitMap& BM)
{
 if (ArraySize) delete [] BitArray;
 ArraySize = BM.ArraySize;
 if (ArraySize) {
   BitArray = new XxxBool[ArraySize];
   memcpy((void *)BitArray, (const void *)BM.BitArray,
	  ArraySize*sizeof(XxxBool));
  }
 else {
   BitArray = NULL;
  }
}

void XxxBitMap::Print(ostream& OStr) const
{
 for (unsigned char i = 0; i < ArraySize; i++)  {
   OStr << (int)(GetBit(i));
  }
}

void XxxBitMap::ChangeSize(unsigned char Size)
{
 unsigned char OldArraySize = ArraySize;
 XxxBool* OldBitArray = BitArray;
 ArraySize = Size;
 if (ArraySize) {
   BitArray = new XxxBool[ArraySize];
  }
 else {
   BitArray = NULL;
  }
 ClearAll();

 // now copy over the old bits
 if (ArraySize >= OldArraySize) {
   for (unsigned char i = 0; i < OldArraySize; i++)  {
     BitArray[i] = OldBitArray[i];
    }
 }
 if (OldArraySize && OldBitArray)
   delete [] OldBitArray;
}
