#ifndef XXX_MISCUTILS_H
#define XXX_MISCUTILS_H
#include <iostream.h>
#include "types.h"
#include "templates.h"

class XxxBitMap { 
  XxxBool* BitArray;
 public:
  unsigned char ArraySize;
  XxxBitMap(unsigned char Size=0) {
    ArraySize = Size;
    if (Size)
      BitArray = new XxxBool[Size];
    else 
      BitArray = NULL;
    ClearAll();
   }

  XxxBitMap(const XxxBitMap& BM) {
    ArraySize = BM.ArraySize;
    if (ArraySize) {
      BitArray = new XxxBool[ArraySize];
      memcpy((void *)BitArray, (const void *)BM.BitArray,
	   ArraySize*sizeof(XxxBool));
     }
    else {
      BitArray = NULL;
     }
   }
  ~XxxBitMap() { if (ArraySize) delete [] BitArray; }
  // used as defacto constructor when there is an array of bitmaps
  void ChangeSize(unsigned char Size);

  XxxBool& operator[](unsigned char i) { 
    if (i >= ArraySize) ChangeSize(i+1);
    return BitArray[i];
  }
  void operator=(const XxxBitMap& BMap);
  void SetBit(unsigned char i) { (*this)[i] = true;}
  void ClearBit(unsigned char i) { (*this)[i] = false;}
  XxxBool GetBit(unsigned char i) const { return BitArray[i];}

  int NumBitsSet() const;
  XxxBool Equals(const XxxBitMap& BMap) const {
    if (ArraySize == BMap.ArraySize) {
      if (memcmp((const void *)BitArray, 
		 (const void *)BMap.BitArray,
		 ArraySize*sizeof(XxxBool)) == 0) {
	return XXX_TRUE;
       }
      else return XXX_FALSE;;
     }
    return XXX_FALSE;
   }
  void CopyBits(const XxxBitMap& BMap);
  void ClearAll();
  void SetAll();
  void Or(const XxxBitMap& BM1, XxxBitMap& ReturnBM) const;
  void And(const XxxBitMap& BM1, XxxBitMap& ReturnBM) const;
  void Xor(const XxxBitMap& BM1, XxxBitMap& ReturnBM) const;

  void Print(ostream& OStr) const;
 };

#endif
