#ifndef XXX_SHORESM_DEFS_H
#define XXX_SHORESM_DEFS_H

#include "sm_vas.h"  // shore header

#ifdef XXX_WIN32
 int errno;
#endif

#ifdef XXX_WIN32
#define _WINBASE_
#endif

/**
 * Used to represent the ID of a logical "device". Each device has one 
 * logical volume id associated with it.
 */
typedef lvid_t XxxShoreVolumeId;

/// Used to represent the ID of a logical object. 
typedef serial_t XxxShoreObjectId;

/// Used to represent the ID of a physical object. 
typedef stid_t XxxShorePhysicalId;

/// Used to represent an index key
typedef vec_t XxxShoreKey;

/// Used to represent a shore transaction
typedef xct_t XxxShoreXact;

/// Used to represent a shore transaction
typedef tid_t XxxShoreXactId;

/**
 * Used to represent the logical OID of a SHORE object.
 * Hopefully, a logical volume id is associated with a device.
 */
class XxxShoreLogicalOID { public:
  /// Logical device/volume ID
  XxxShoreVolumeId VolId;
  /// OID within volume
  XxxShoreObjectId LocalId;
};

/**
 * Used to represent the physical OID of a file.
 */
class XxxShorePhysicalOID { public:
  /// Logical device/volume ID
  XxxShoreVolumeId VolId;
  /// OID within volume
  XxxShorePhysicalId LocalId;
};

/// Used to represent parameters for a SHORE sort
typedef sort_parm_t XxxShoreSortParams;

/// Used to represent key information for a SHORE sort
typedef key_info_t XxxShoreKeyInfo;

#ifdef XXX_SHORE_V2
/// Used to represent some shore V2.0 types
typedef object_t XxxShoreSortObject;
typedef factory_t XxxShoreFactory;

typedef rid_t XxxShoreRecId;

typedef vid_t  XxxShorePhysVolumeId;

typedef w_rc_t			XxxShoreRetVal;
typedef skey_t			XxxShoreSortKey;
typedef sort_keys_t		XxxShoreSortKeyList;
typedef key_cookie_t	XxxShoreSortKeyData;
#endif

#endif
