#include "sockstream.h"

XxxSockStream::XxxSockStream(int socket) 
: ostream(&sBuffer), sBuffer(theBuffer, XXX_SOCKSTREAM_BUFSZ, socket, this) 
{
  // Praveen : dont need this
  // setf(ios::unitbuf);
  /***
  *** My silly efforts to flush socket buffers: not needed now: PS
 int Set = 1;
 if (setsockopt(socket, IPPROTO_TCP, TCP_NODELAY,
		(char *)&Set, sizeof(int)) < 0) {
   fprintf(stderr,"unable to setsockopt TCP_NODELAY\n");
 }
 Set = 0;
 if (setsockopt(socket, SOL_SOCKET, SO_DONTLINGER,
		(char *)&Set, sizeof(int)) < 0) {
   fprintf(stderr,"unable to setsockopt TCP_NODELAY\n");
 }
 int SetSize = sizeof(int);
 if (getsockopt(socket, SOL_SOCKET, SO_SNDBUF,
		(char *)&Set, &SetSize) < 0) {
   fprintf(stderr,"unable to getsockopt SO_SENDBUF\n");
 }
 cerr << "Got SO_SNDBUF = " << Set << endl;
 Set = 8192;
 if (setsockopt(socket, SOL_SOCKET, SO_SNDBUF,
		(char *)&Set, SetSize) < 0) {
   fprintf(stderr,"unable to setsockopt SO_SENDBUF\n");
 }
 if (getsockopt(socket, SOL_SOCKET, SO_SNDBUF,
		(char *)&Set, &SetSize) < 0) {
   fprintf(stderr,"unable to getsockopt SO_SENDBUF\n");
 }
 cerr << "Set SO_SNDBUF to " << Set << endl;
 **/
}

XxxSockStreamBuf::XxxSockStreamBuf(char *theBuf, int len, int sock,
				   XxxSockStream *owner) 
: streambuf(), owner(owner)
{
  theSocket = sock;

#ifdef XXX_NONPREEMPTIVE
  // set non-delay flags on output file descriptor
#if defined(Sparc) && !defined(SOLARIS2)
  // for SunOs
  // if (fcntl(sock, F_SETFL, FNDELAY) == -1) {
  //   cerr << "Warning: Unable to set non-blocking I/O to client" << endl;
  //  }
  if (fcntl(sock, F_SETFL, FAPPEND) == -1) {
    cerr << "Warning: Unable to set append I/O for client" << endl;
  }
#endif
#if defined(Sparc) && defined(SOLARIS2)
  // for Solaris
  // if (fcntl(sock, F_SETFL, FNDELAY) == -1) {
  //   cerr << "Warning: Unable to set non-blocking I/O to client" << endl;
  //  }
  // if (fcntl(sock, F_SETFL, O_NDELAY) == -1) {
  //   cerr << "Warning: Unable to set append I/O for client" << endl;
  //  }
#endif
  
#if defined(XXX_WIN32)
  // TODO
  //cerr << "Warning: OS not supported yet, need to implement function to set non-blocking I/O"
  //     << endl;
#endif
#endif // XXX_NONPREEMPTIVE

#if defined(XXX_WIN32) && defined(XXX_NONPREEMPTIVE)
  eHandle = NULL;
  // eHandle is initialized just before it is used - not clear why!
#else
  fHandle = new sfile_write_hdl_t(theSocket);
#endif

  setbuf(theBuf,len); // set the "reserve" buffer area
  setp(theBuf,theBuf+len); // set the output buffer area
}

XxxSockStreamBuf::~XxxSockStreamBuf() 
{ 
#if defined(XXX_WIN32) && defined(XXX_NONPREEMPTIVE)
	if (eHandle)
		delete eHandle;
#else	
	if (fHandle)
		delete fHandle;
#endif
}

int XxxSockStreamBuf::overflow(int nCh) 
{ 
  if (!(owner->good()))
    return EOF;
  int sent;
  char *currBuffer;
  int len = pptr() - pbase();
  currBuffer = pbase();
  while (len != 0) {
#if defined(XXX_WIN32) && defined(XXX_NONPREEMPTIVE)
    handle = CreateEvent(NULL, TRUE, FALSE, NULL);
    WSAEventSelect((unsigned int) theSocket, handle, FD_WRITE);
	// WSAEventSelect ensures that theSocket is in non blocking mode
    eHandle = new win32_compat_event_t(handle);
	
	if (eHandle->is_down() || (bool) eHandle->wait(::WAIT_FOREVER))
#else
  if (fHandle->is_down() || (bool) fHandle->wait(::WAIT_FOREVER))
#endif
  {
      owner->clear(ios::badbit);
      return EOF;
  }

#if defined(Sparc) && defined(SOLARIS2)
    int CurrentFlags = fcntl(theSocket, F_GETFL);
    fcntl(theSocket, F_SETFL, O_NDELAY);
#endif
    sent = send(theSocket, currBuffer, len, 0);
#if defined(Sparc) && defined(SOLARIS2)
    fcntl(theSocket, F_SETFL, CurrentFlags);
#endif
    if (sent == -1 || sent == 0) { 
      // Socket Error or client closed connection
      owner->clear(ios::badbit);
      return EOF;
    }
    len -= sent;
    currBuffer += sent;
  }
  setp(pbase(),epptr());
  if (nCh != EOF) { 
    *(pptr()) = nCh;
    pbump(1);
  }
  return 0;
}

int XxxSockStreamBuf::underflow() 
{ 
 cerr << "XxxSockBuf: This is an output buffer, reading operations not supported" << endl; 
 return 0;
}

int XxxSockStreamBuf::sync() 
{ 
 return overflow(EOF);
}


