#ifndef XXX_SOCKSTREAM_H
#define XXX_SOCKSTREAM_H

#include <iostream.h>
#include <fcntl.h>
#include <sys/types.h>
#include "shoresm.h"

XXX_EXTERN_CLASS_DECL(XxxSockStream);

/**
 * Defines a stream buffer to be used for thread-safe output streams
 */
class XxxSockStreamBuf : public streambuf { 
public:
  XxxSockStreamBuf(char *buf, int len, int sock,
		   XxxSockStream *owner);
  ~XxxSockStreamBuf();
  virtual int overflow(int nCh);
  virtual int underflow();
  virtual int sync();

private:
  int theSocket;
#if defined(XXX_WIN32) && defined(XXX_NONPREEMPTIVE)
  win32_compat_event_t *eHandle;
  HANDLE handle;
#else
  sfile_write_hdl_t *fHandle;
#endif

  XxxSockStream *owner;
};

/**
 * Defines a thread-safe output stream
 */
class XxxSockStream : public ostream { 
public:
  XxxSockStream(int socket);
  ~XxxSockStream() {}
protected:
#define XXX_SOCKSTREAM_BUFSZ 4096
  // make a buffer of 4096 bytes
  char theBuffer[XXX_SOCKSTREAM_BUFSZ];
  XxxSockStreamBuf sBuffer;
};   

#endif // XXX_SOCKSTREAM_H




