/* System Commands
* Han Wang
*/

#include <stdio.h>
//Bjarke, sep. 14 2001: include stdlib.h for system()-call
#include <stdlib.h>
#include "syscmd.h"
#include "prd-config.h" /* for XXX_DIRNAME_MAX */
#ifdef XXX_WIN32
#include <string.h>
#endif


/***** Common Implementation *****/
/* Calls that are common to both UNIX and NT only */

int XxxSystemCmd::ViewPostscript(const char *FileName)
{
  char Command[20 + 2*XXX_DIRNAME_MAX];
 
  sprintf(Command, "ghostview %s", FileName);
  return system(Command);
}


#ifdef XXX_WIN32 /***** WINDOWS NT Implementation ******/

int XxxSystemCmd::TestExistDir(const char *DirName)
{
	char command[100];
	sprintf(command, "cd /d %s", DirName);

	return system(command);
}


int XxxSystemCmd::DeleteFile(const char *FileName)
{
  char Command[8 + XXX_DIRNAME_MAX];
 
  sprintf(Command, "del /F %s", FileName);
  return system(Command);
}

int XxxSystemCmd::ViewTextfile(const char *FileName)
{
  char Command[20 + 2*XXX_DIRNAME_MAX];
	
  sprintf(Command, "notepad %s", FileName);
  return system(Command);
}



#else /***** UNIX Implemantation ******/
int XxxSystemCmd::TestExistDir(const char *DirName)
{
	char command[2*XXX_DIRNAME_MAX];
	sprintf(command, "/bin/sh -c cd %s", DirName);

	return system(command);
}

int XxxSystemCmd::DeleteFile(const char *FileName) 
{
  char Command[3 + XXX_DIRNAME_MAX];
	
  sprintf(Command, "/bin/sh -c rm -f %s", FileName);
  return system(Command);
}


int XxxSystemCmd::ViewTextfile(const char *FileName)
{
  char Command[20 + 2*XXX_DIRNAME_MAX];
	
  sprintf(Command, "/bin/sh -c emacs %s", FileName);
  return system(Command);
}


#endif


