/* System Calls wrapper
 *	Han Wang 11/21/97
 *
 * Use this class to wrap system calls.
 * Statically define all call wrappers.
 *
 * Usage:
	if ( XxxSystemCmd::DeleteFile(FileName) ) {
		XXX_NOTE_ERROR(XXX_BADADT, "Error calling remove for document");
		return XXX_NOT_OK;
	}
 */

#ifndef XXX_SYSCMD_H_
#define XXX_SYSCMD_H_

#ifndef XXX_WIN32
#include <sys/types.h>
#include <sys/ipc.h>
#else
#include "shoresm-defs.h"
#endif

/**
 *
 */
class XxxSystemCmd {
 public:
  XxxSystemCmd() {}
  ~XxxSystemCmd() {}
   
  static int TestExistDir(const char *DirName);
  static int DeleteFile(const char *FileName);
  static int ViewPostscript(const char *FileName);
  static int ViewTextfile(const char *FileName);
  
};

#endif /* XXX_SYSCMD_H_ */

