#include "typelist.h"

//Bjarke, sep. 19 2001: removed #ifdef since string.h should be included on all platforms
//#ifdef XXX_WIN32
#include <string.h>
//#endif

TypeInfo::TypeInfo(char *shoreData){
	typeId = *((int *)shoreData);

	int size = sizeof(int);
	memcpy(name, shoreData + size, 10);
	memcpy(type, shoreData + size +10, 10);

	infoLen = *((int *)(shoreData + size +20));
	
	if(infoLen){
		tInfo = new char[infoLen];
		
		memcpy(tInfo, shoreData+2*size+20, infoLen);
	} else {
		tInfo = 0;
	}
}

TypeInfo::TypeInfo(int typeId, const char* name, const char* type, int infoLen, char *tInfo){
	this->typeId = typeId;
	strcpy(this->name, name);
	strcpy(this->type, type);
	this->infoLen = infoLen;
	if(infoLen == 0){
		tInfo = 0;
	} else {
		this->tInfo = new char[infoLen];
		memcpy(this->tInfo, tInfo, infoLen);
	}
}

TypeInfo::~TypeInfo(){
	if(infoLen != 0) {
		delete[] tInfo;
	}
}

void* TypeInfo::Serialize(){
	int size = 2 * sizeof(int) + 20 + infoLen;
	char* data = new char[size];
	
	*((int *)data) = typeId;
	
	memcpy(data+sizeof(int), name, 10);
	memcpy(data+sizeof(int)+10, type, 10);

	*((int *)(data + sizeof(int) + 20)) = infoLen;
	
	if(infoLen){
		memcpy(data+size-infoLen, tInfo, infoLen);
	}
	
	return data;
}

int TypeInfo::DataSize(){
	return (2*sizeof(int)+20+infoLen);
}
