#ifndef VIEWLIST_H
#define VIEWLIST_H

/**
 *	Used to represent an instance of view, consisting of the view's
 *  name, and its definition
 *  @author BinQuan Gu
 */
class ViewInfo {
public:
	// The name for this view
	char name[40];
	// The string used to create this view
	char *vInfo;

public:
	/**
	 *	Construct the viewInfo struct from the object stored
	 *  in shore, used when the server is restarted
	 */
	ViewInfo(char *shoreData);

	ViewInfo(const char* name, char *vInfo);

	~ViewInfo();

	void *Serialize();

	int DataSize();
};

#endif

